/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ASTQ = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQAdapterASTY {
  static taste(node) {
    return typeof node === "object" && node !== null && typeof node.ASTy === "boolean";
  }
  static getParentNode(node /*, type */) {
    return node.parent();
  }
  static getChildNodes(node /*, type */) {
    return node.childs();
  }
  static getNodeType(node) {
    return node.type();
  }
  static getNodeAttrNames(node) {
    return node.attrs();
  }
  static getNodeAttrValue(node, attr) {
    return node.get(attr);
  }
}
exports.default = ASTQAdapterASTY;

},{}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQAdapterCheerio {
  static taste(node) {
    /* global Document: true */
    /* global Element: true */
    return typeof node === "object" && node !== null && (!(typeof Element === "object" && node instanceof Element) && typeof node.tagName === "string" && node.tagName !== "" || !(typeof Document === "object" && node instanceof Document) && typeof node.type === "string" && node.type === "root");
  }
  static getParentNode(node /*, type */) {
    return node.parentNode;
  }
  static getChildNodes(node /*, type */) {
    return typeof node.childNodes === "object" && node.childNodes instanceof Array ? node.childNodes : [];
  }
  static getNodeType(node) {
    return node.tagName || `#${node.type || "unknown"}`;
  }
  static getNodeAttrNames(node) {
    let attrs = ["value"];
    if (typeof node.attribs === "object") attrs = attrs.concat(Object.keys(node.attribs));
    return attrs;
  }
  static getNodeAttrValue(node, attr) {
    let value;
    if (attr === "value") value = node.nodeValue;else if (typeof node.attribs === "object") value = node.attribs[attr];
    return value;
  }
}
exports.default = ASTQAdapterCheerio;

},{}],3:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*  See also: https://graphql.org/graphql-js/type/#graphqlobjecttype  */

class ASTQAdapterGraphQL {
  static taste(node) {
    return typeof node === "object" && node !== null && typeof node.kind === "string" && node.kind !== "";
  }
  static getParentNode(node, type) {
    throw new Error("GraphQL AST does not support parent node traversal");
  }
  static getChildNodes(node, type) {
    let childs = [];
    let checkField = (node, field) => {
      if (Object.prototype.hasOwnProperty.call(node, field) && this.taste(node[field])) childs.push(node[field]);else if (Object.prototype.hasOwnProperty.call(node, field) && typeof node[field] === "object" && node[field] instanceof Array) {
        node[field].forEach(node => {
          if (this.taste(node)) childs.push(node);
        });
      }
    };
    if (type === "*") {
      for (let field in node) checkField(node, field);
    } else {
      if (typeof node[type] !== "undefined") checkField(node, type);
    }
    return childs;
  }
  static getNodeType(node) {
    return node.kind;
  }
  static getNodeAttrNames(node) {
    let names = [];
    for (let field in node) if (Object.prototype.hasOwnProperty.call(node, field) && typeof node[field] !== "object" && field !== "kind" && field !== "loc") names.push(field);
    return names;
  }
  static getNodeAttrValue(node, attr) {
    if (Object.prototype.hasOwnProperty.call(node, attr) && typeof node[attr] !== "object" && attr !== "kind" && attr !== "loc") return node[attr];else return undefined;
  }
}
exports.default = ASTQAdapterGraphQL;

},{}],4:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQAdapterJSON {
  static taste(node) {
    return typeof node === "object" && node !== null;
  }
  static getParentNode(node, type) {
    throw new Error("JSON does not support parent node traversal");
  }
  static getChildNodes(node, type) {
    let childs = [];
    let checkField = (node, field) => {
      if (Object.prototype.hasOwnProperty.call(node, field) && this.taste(node[field])) childs.push(node[field]);else if (Object.prototype.hasOwnProperty.call(node, field) && typeof node[field] === "object" && node[field] instanceof Array) {
        node[field].forEach(node => {
          if (this.taste(node)) childs.push(node);
        });
      }
    };
    if (type === "*") {
      for (let field in node) checkField(node, field);
    } else {
      if (typeof node[type] !== "undefined") checkField(node, type);
    }
    return childs;
  }
  static getNodeType(node) {
    if (node === null) return "Null";else if (node instanceof Boolean) return "Boolean";else if (node instanceof Number) return "Number";else if (node instanceof String) return "String";else if (typeof node === "object") {
      if (node instanceof Array) return "Array";else if (typeof node.constructor === "function" && typeof node.constructor.name === "string") return node.constructor.name;else return "Object";
    } else return "Unknown";
  }
  static getNodeAttrNames(node) {
    let names = [];
    for (let field in node) if (Object.prototype.hasOwnProperty.call(node, field) && typeof node[field] !== "object") names.push(field);
    return names;
  }
  static getNodeAttrValue(node, attr) {
    if (Object.prototype.hasOwnProperty.call(node, attr) && typeof node[attr] !== "object") return node[attr];else return undefined;
  }
}
exports.default = ASTQAdapterJSON;

},{}],5:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*  See also: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/SpiderMonkey/Parser_API  */

class ASTQAdapterMozAST {
  static taste(node) {
    return typeof node === "object" && node !== null && typeof node.type === "string" && node.type !== "";
  }
  static getParentNode(node, type) {
    if (type !== "*" && type !== "parent") throw new Error("no such axis named \"" + type + "\" for walking to parent nodes");
    if (typeof node.parent !== "undefined") return node.parent;else throw new Error("Your Mozilla SpiderMonkey AST does not support parent node traversal");
  }
  static getChildNodes(node, type) {
    let childs = [];
    let checkField = (node, field) => {
      if (Object.prototype.hasOwnProperty.call(node, field) && this.taste(node[field])) childs.push(node[field]);else if (Object.prototype.hasOwnProperty.call(node, field) && typeof node[field] === "object" && node[field] instanceof Array) {
        node[field].forEach(node => {
          if (this.taste(node)) childs.push(node);
        });
      }
    };
    if (type === "*") {
      for (let field in node) checkField(node, field);
    } else {
      if (typeof node[type] !== "undefined") checkField(node, type);
    }
    return childs;
  }
  static getNodeType(node) {
    return node.type;
  }
  static getNodeAttrNames(node) {
    let names = [];
    for (let field in node) if (Object.prototype.hasOwnProperty.call(node, field) && typeof node[field] !== "object" && field !== "type" && field !== "loc") names.push(field);
    return names;
  }
  static getNodeAttrValue(node, attr) {
    if (Object.prototype.hasOwnProperty.call(node, attr) && typeof node[attr] !== "object" && attr !== "type" && attr !== "loc") return node[attr];else return undefined;
  }
}
exports.default = ASTQAdapterMozAST;

},{}],6:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQAdapterParse5 {
  static taste(node) {
    /* global Node: true */
    return typeof node === "object" && node !== null && !(typeof Node === "object" && node instanceof Node) && typeof node.nodeName === "string" && node.nodeName !== "";
  }
  static getParentNode(node /*, type */) {
    return node.parentNode;
  }
  static getChildNodes(node /*, type */) {
    return typeof node.childNodes === "object" && node.childNodes instanceof Array ? node.childNodes : [];
  }
  static getNodeType(node) {
    return node.nodeName;
  }
  static getNodeAttrNames(node) {
    let attrs = ["value"];
    if (typeof node.attrs === "object" && node.attrs instanceof Array) attrs = attrs.concat(node.attrs.map(n => n.name));
    return attrs;
  }
  static getNodeAttrValue(node, attr) {
    let value;
    if (attr === "value") value = node.value;else if (typeof node.attrs === "object" && node.attrs instanceof Array) {
      let values = node.attrs.filter(n => n.name === attr).map(n => n.value);
      if (values.length === 1) value = values[0];
    }
    return value;
  }
}
exports.default = ASTQAdapterParse5;

},{}],7:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQAdapterUniST {
  static taste(node) {
    return typeof node === "object" && node !== null && typeof node.type === "string" && node.type !== "";
  }
  static getParentNode(node /*, type */) {
    if (typeof node.parent === "object" && node.parent !== null) return node.parent;else throw new Error("Your UniST AST does not support parent node traversal");
  }
  static getChildNodes(node /*, type */) {
    return typeof node.children === "object" && node.children instanceof Array ? node.children : [];
  }
  static getNodeType(node) {
    return node.type;
  }
  static getNodeAttrNames(node) {
    const attrs = [];
    for (const attr in node) if (Object.prototype.hasOwnProperty.call(node, attr) && attr !== "type" && attr !== "data" && attr !== "position" && attr !== "children" && typeof node[attr] !== "object") attrs.push(attr);
    return attrs;
  }
  static getNodeAttrValue(node, attr) {
    if (Object.prototype.hasOwnProperty.call(node, attr) && attr !== "type" && attr !== "data" && attr !== "position" && attr !== "children" && typeof node[attr] !== "object") return node[attr];else return undefined;
  }
}
exports.default = ASTQAdapterUniST;

},{}],8:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQAdapterXMLDOM {
  static taste(node) {
    /* global Node: true */
    return typeof Node === "object" && node !== null && node instanceof Node && typeof node === "object" && typeof node.nodeType === "number" && typeof node.nodeName === "string";
  }
  static getParentNode(node /*, type */) {
    return node.parentNode;
  }
  static getChildNodes(node /*, type */) {
    return typeof node.childNodes === "object" && node.childNodes !== null && node.hasChildNodes() ? Array.prototype.slice.call(node.childNodes, 0) : [];
  }
  static getNodeType(node) {
    return typeof node.nodeName === "string" ? node.nodeName : "unknown";
  }
  static getNodeAttrNames(node) {
    return typeof node.attributes === "object" && node.attributes !== null && node.hasAttributes() ? Array.prototype.slice.call(node.attributes, 0).map(n => n.nodeName) : [];
  }
  static getNodeAttrValue(node, attr) {
    return typeof node.attributes === "object" && node.attributes !== null && node.hasAttributes() ? node.getAttribute(attr) : undefined;
  }
}
exports.default = ASTQAdapterXMLDOM;

},{}],9:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQAdapter {
  constructor() {
    this._adapters = [];
    return this;
  }
  register(adapter, force = false) {
    this._adapters.unshift({
      adapter,
      force
    });
    return this;
  }
  unregister(adapter) {
    if (adapter === undefined) this._adapters = [];else {
      let adapters = [];
      for (let i = 0; i < this._adapters.length; i++) if (this._adapters[i].adapter !== adapter) adapters.push(this._adapters[i]);
      this._adapters = adapters;
    }
    return this;
  }
  select(node) {
    for (let i = 0; i < this._adapters.length; i++) if (this._adapters[i].force || this._adapters[i].adapter.taste(node)) return this._adapters[i].adapter;
    return undefined;
  }
}
exports.default = ASTQAdapter;

},{}],10:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*  internal helper function: find position between siblings  */
const pos = (A, T) => {
  let parent = A.getParentNode(T, "*");
  if (parent === null) return 1;
  let pchilds = A.getChildNodes(parent, "*");
  for (let i = 0; i < pchilds.length; i++) if (pchilds[i] === T) return i + 1;
  throw new Error("cannot find myself");
};

/*  internal helper function: find parent nodes  */
const parents = (A, T) => {
  let parents = [];
  while ((T = A.getParentNode(T, "*")) !== null) parents.push(T);
  return parents;
};

/*  the exported standard functions  */
const stdfuncs = {
  /*  type name of node  */
  "type": (A, T) => {
    return A.getNodeType(T);
  },
  /*  attribute names of node  */
  "attrs": (A, T, sep) => {
    if (sep === undefined) sep = " ";
    /* eslint no-console: 0 */
    return sep + A.getNodeAttrNames(T).join(sep) + sep;
  },
  /*  depth of node in tree  */
  "depth": (A, T) => {
    let depth = 1;
    let node = T;
    while ((node = A.getParentNode(node, "*")) !== null) depth++;
    return depth;
  },
  /*  return position of node between siblings  */
  "pos": (A, T) => {
    return pos(A, T);
  },
  /*  check position of node between siblings  */
  "nth": (A, T, num) => {
    num = parseInt(num, 10);
    let parent = A.getParentNode(T, "*");
    if (parent !== null) {
      let pchilds = A.getChildNodes(parent, "*");
      if (num < 0) num = pchilds.length - (num + 1);
      for (let i = 0; i < pchilds.length; i++) if (pchilds[i] === T) return i + 1 === num;
      return false;
    } else if (num === 1) return true;else return false;
  },
  /*  check position of node to be first of siblings  */
  "first": (A, T) => {
    return stdfuncs.nth(A, T, 1);
  },
  /*  check position of node to be last of siblings  */
  "last": (A, T) => {
    return stdfuncs.nth(A, T, -1);
  },
  /*  count number of keys/elements/characters/etc  */
  "count": (A, T, val) => {
    if (typeof val === "object" && val instanceof Array) return val.length;else if (typeof val === "object") return Object.keys(val).length;else if (typeof val === "string") return val.length;else return String(val).length;
  },
  /*  check whether node is below another  */
  "below": (A, T, other) => {
    if (!A.taste(other)) throw new Error("invalid argument to function \"below\" (node expected)");
    let node = T;
    while ((node = A.getParentNode(node, "*")) !== null) if (node === other) return true;
    return false;
  },
  /*  check whether node follows another  */
  "follows": (A, T, other) => {
    if (!A.taste(other)) throw new Error("invalid argument to function \"follows\" (node expected)");
    if (T === other) return false;
    let pathOfT = [T].concat(parents(A, T)).reverse();
    let pathOfOther = [other].concat(parents(A, other)).reverse();
    let len = Math.min(pathOfT.length, pathOfOther.length);
    let i;
    for (i = 0; i < len; i++) if (pathOfT[i] !== pathOfOther[i]) break;
    if (i === 0) throw new Error("internal error: root nodes have to be same same");else if (i === len) {
      if (pathOfOther.length < pathOfT.length) return true;else return false;
    } else return pos(A, pathOfT[i]) > pos(A, pathOfOther[i]);
  },
  /*  check whether node is in a list of nodes  */
  "in": (A, T, val) => {
    if (!(typeof val === "object" && val instanceof Array)) throw new Error("invalid argument to function \"in\" (array expected)");
    for (let i = 0; i < val.length; i++) if (val[i] === T) return true;
    return false;
  },
  /*  retrieve a sub-string  */
  "substr": (A, T, str, pos, len) => {
    return String(str).substr(pos, len);
  },
  /*  retrieve index of a sub-string  */
  "index": (A, T, str, sub, from) => {
    return String(str).indexOf(sub, from);
  },
  /*  remove whitespaces at begin and end of string  */
  "trim": (A, T, str) => {
    return String(str).trim();
  },
  /*  convert string to lower-case  */
  "lc": (A, T, str) => {
    return String(str).toLowerCase();
  },
  /*  convert string to upper-case  */
  "uc": (A, T, str) => {
    return String(str).toUpperCase();
  }
};
var _default = exports.default = stdfuncs;

},{}],11:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQFuncs {
  constructor() {
    this._funcs = {};
    return this;
  }
  register(name, func) {
    this._funcs[name] = func;
  }
  run(name, args) {
    let func = this._funcs[name];
    if (typeof func !== "function") throw new Error("invalid function \"" + name + "\"");
    return func.apply(null, args);
  }
}
exports.default = ASTQFuncs;

},{}],12:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _astqUtil = _interopRequireDefault(require("./astq-util.js"));
var _astqQueryTrace = _interopRequireDefault(require("./astq-query-trace.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQQueryExec extends _astqQueryTrace.default {
  constructor(adapter, params, funcs, trace) {
    super();
    this.adapter = adapter;
    this.params = params;
    this.funcs = funcs;
    this.trace = trace;
  }
  execQuery(Q, T) {
    this.traceBegin(Q, T);
    let output = [];

    /*  iterate over all query paths  */
    Q.childs().forEach(Q => {
      output = output.concat(this.execPath(Q, T));
    });
    this.traceEnd(Q, T, output);
    return output;
  }
  execPath(Q, T) {
    this.traceBegin(Q, T);
    let nodes = [T];
    let result = [];
    let resultExplicit = false;

    /*  iterate over all steps of a query path  */
    Q.childs().forEach(Q => {
      let output = [];
      nodes.forEach(T => {
        output = output.concat(this.execStep(Q, T));
      });
      nodes = output;
      if (Q.get("isResult")) {
        resultExplicit = true;
        result = result.concat(nodes);
      }
    });
    this.traceEnd(Q, T, nodes);
    return resultExplicit ? result : nodes;
  }
  execStep(Q, T) {
    this.traceBegin(Q, T);

    /*  determine (optional) axis, (mandatory) match and (optional) filter  */
    let childs = Q.childs();
    let axis = null;
    let match = null;
    let filter = null;
    let i = 0;
    if (i < childs.length && childs[i].type() === "Axis") axis = childs[i++];
    if (i < childs.length && childs[i].type() === "Match") match = childs[i++];
    if (i < childs.length && childs[i].type() === "Filter") filter = childs[i++];
    if (match === null) throw new Error("no matching part in query step");
    let nodes = [];

    /*  helper function for matching and taking node  */
    let id = match.get("id");
    let matchAndTake = T => {
      let type = this.adapter.getNodeType(T);
      if (id === "*" || id === type) {
        let take = true;
        if (filter !== null) if (!this.execFilter(filter, T)) take = false;
        if (take) nodes.push(T);
      }
    };

    /*  determine nodes along axis which potentially might match  */
    if (axis !== null) {
      let op = axis.get("op");
      let t = axis.get("type");
      if (op === "/") {
        /*  direct child nodes  */
        this.adapter.getChildNodes(T, t).forEach(T => matchAndTake(T));
      } else if (op === "//") {
        /*  transitive child nodes  */
        let walk = T => {
          matchAndTake(T);
          this.adapter.getChildNodes(T, t).forEach(T => walk(T)); /* RECURSION */
        };
        this.adapter.getChildNodes(T, t).forEach(T => walk(T));
      } else if (op === "./") {
        /*  current node plus direct child nodes  */
        matchAndTake(T);
        this.adapter.getChildNodes(T, t).forEach(T => matchAndTake(T));
      } else if (op === ".//") {
        /*  current node plus transitive child nodes  */
        matchAndTake(T);
        let walk = T => {
          matchAndTake(T);
          this.adapter.getChildNodes(T, t).forEach(T => walk(T)); /* RECURSION */
        };
        this.adapter.getChildNodes(T, t).forEach(T => walk(T));
      } else if (op === "-/") {
        /*  direct left sibling  */
        let parent = this.adapter.getParentNode(T, "*");
        if (parent !== null) {
          let pchilds = this.adapter.getChildNodes(parent, t);
          let leftSibling = null;
          for (let i = 0; i < pchilds.length; i++) {
            if (pchilds[i] === T) break;
            leftSibling = pchilds[i];
          }
          if (leftSibling !== null) matchAndTake(leftSibling);
        }
      } else if (op === "-//") {
        /*  transitive left siblings  */
        let parent = this.adapter.getParentNode(T, "*");
        if (parent !== null) {
          let pchilds = this.adapter.getChildNodes(parent, t);
          let i = 0;
          for (; i < pchilds.length; i++) if (pchilds[i] === T) break;
          for (i--; i >= 0; i--) matchAndTake(pchilds[i]);
        }
      } else if (op === "+/") {
        /*  direct right sibling  */
        let parent = this.adapter.getParentNode(T, "*");
        if (parent !== null) {
          let pchilds = this.adapter.getChildNodes(parent, t);
          let i;
          for (i = 0; i < pchilds.length; i++) if (pchilds[i] === T) break;
          if (i < pchilds.length) matchAndTake(pchilds[++i]);
        }
      } else if (op === "+//") {
        /*  transitive right siblings  */
        let parent = this.adapter.getParentNode(T, "*");
        if (parent !== null) {
          let pchilds = this.adapter.getChildNodes(parent, t);
          let i;
          for (i = 0; i < pchilds.length; i++) if (pchilds[i] === T) break;
          if (i < pchilds.length) for (i++; i < pchilds.length; i++) matchAndTake(pchilds[i]);
        }
      } else if (op === "~/") {
        /*  direct left and right sibling  */
        let parent = this.adapter.getParentNode(T, "*");
        if (parent !== null) {
          let pchilds = this.adapter.getChildNodes(parent, t);
          let i;
          for (i = 0; i < pchilds.length; i++) if (pchilds[i] === T) break;
          if (i > 0) matchAndTake(pchilds[i - 1]);
          if (i < pchilds.length - 1) matchAndTake(pchilds[i + 1]);
        }
      } else if (op === "~//") {
        /*  transitive left and right siblings  */
        let parent = this.adapter.getParentNode(T, "*");
        if (parent !== null) {
          let pchilds = this.adapter.getChildNodes(parent, t);
          for (let i = 0; i < pchilds.length; i++) if (pchilds[i] !== T) matchAndTake(pchilds[i]);
        }
      } else if (op === "../") {
        /*  direct parent  */
        let parent = this.adapter.getParentNode(T, t);
        if (parent !== null) matchAndTake(parent);
      } else if (op === "..//") {
        /*  transitive parents  */
        let node = T;
        for (;;) {
          let parent = this.adapter.getParentNode(node, t);
          if (parent === null) break;
          matchAndTake(parent);
          node = parent;
        }
      } else if (op === "<//") {
        /*  transitive preceding nodes  */
        let ctx = {
          sentinel: T,
          take: true
        };
        for (;;) {
          let parent = this.adapter.getParentNode(T, "*");
          if (parent === null) break;
          T = parent;
        }
        let walk = T => {
          if (T === ctx.sentinel) ctx.take = false;
          if (ctx.take) matchAndTake(T);
          if (ctx.take) this.adapter.getChildNodes(T, t).forEach(T => walk(T)); /* RECURSION */
        };
        if (T !== ctx.sentinel) {
          matchAndTake(T);
          this.adapter.getChildNodes(T, t).forEach(T => walk(T));
        }
        nodes = nodes.reverse();
      } else if (op === ">//") {
        /*  transitive following nodes  */
        let ctx = {
          sentinel: T,
          take: false
        };
        for (;;) {
          let parent = this.adapter.getParentNode(T, "*");
          if (parent === null) break;
          T = parent;
        }
        let walk = T => {
          if (ctx.take) matchAndTake(T);
          if (T === ctx.sentinel) ctx.take = true;
          this.adapter.getChildNodes(T, t).forEach(T => walk(T)); /* RECURSION */
        };
        this.adapter.getChildNodes(T, t).forEach(T => walk(T));
      }
    } else /*  current node  */
      matchAndTake(T);
    this.traceEnd(Q, T, nodes);
    return nodes;
  }
  execFilter(Q, T) {
    this.traceBegin(Q, T);
    let expr = Q.childs()[0];
    let result = this.execExpr(expr, T);
    result = _astqUtil.default.truthy(result);
    this.traceEnd(Q, T, result);
    return result;
  }
  execExpr(Q, T) {
    switch (Q.type()) {
      case "ConditionalBinary":
        return this.execExprConditionalBinary(Q, T);
      case "ConditionalTernary":
        return this.execExprConditionalTernary(Q, T);
      case "Logical":
        return this.execExprLogical(Q, T);
      case "Bitwise":
        return this.execExprBitwise(Q, T);
      case "Relational":
        return this.execExprRelational(Q, T);
      case "Arithmetical":
        return this.execExprArithmetical(Q, T);
      case "Unary":
        return this.execExprUnary(Q, T);
      case "FuncCall":
        return this.execExprFuncCall(Q, T);
      case "Attribute":
        return this.execExprAttribute(Q, T);
      case "Param":
        return this.execExprParam(Q, T);
      case "LiteralString":
        return this.execExprLiteralString(Q, T);
      case "LiteralRegExp":
        return this.execExprLiteralRegExp(Q, T);
      case "LiteralNumber":
        return this.execExprLiteralNumber(Q, T);
      case "LiteralValue":
        return this.execExprLiteralValue(Q, T);
      case "Path":
        return this.execExprPath(Q, T);
    }
  }
  execExprConditionalBinary(Q, T) {
    this.traceBegin(Q, T);
    let result = this.execExpr(Q.childs()[0], T);
    if (!_astqUtil.default.truthy(result)) result = this.execExpr(Q.childs()[1], T);
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprConditionalTernary(Q, T) {
    this.traceBegin(Q, T);
    let result = this.execExpr(Q.childs()[0], T);
    if (_astqUtil.default.truthy(result)) result = this.execExpr(Q.childs()[1], T);else result = this.execExpr(Q.childs()[2], T);
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprLogical(Q, T) {
    this.traceBegin(Q, T);
    let result = false;
    switch (Q.get("op")) {
      case "&&":
        result = _astqUtil.default.truthy(this.execExpr(Q.childs()[0], T));
        if (result) result = result && _astqUtil.default.truthy(this.execExpr(Q.childs()[1], T));
        break;
      case "||":
        result = _astqUtil.default.truthy(this.execExpr(Q.childs()[0], T));
        if (!result) result = result || _astqUtil.default.truthy(this.execExpr(Q.childs()[1], T));
        break;
    }
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprBitwise(Q, T) {
    this.traceBegin(Q, T);
    let v1 = _astqUtil.default.coerce(this.execExpr(Q.childs()[0], T), "number");
    let v2 = _astqUtil.default.coerce(this.execExpr(Q.childs()[1], T), "number");
    let result;
    switch (Q.get("op")) {
      case "&":
        result = v1 & v2;
        break;
      case "|":
        result = v1 | v2;
        break;
      case "<<":
        result = v1 << v2;
        break;
      case ">>":
        result = v1 >> v2;
        break;
    }
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprRelational(Q, T) {
    this.traceBegin(Q, T);
    let v1 = this.execExpr(Q.childs()[0], T);
    let v2 = this.execExpr(Q.childs()[1], T);
    let result;
    switch (Q.get("op")) {
      case "==":
        result = v1 === v2;
        break;
      case "!=":
        result = v1 !== v2;
        break;
      case "<=":
        result = _astqUtil.default.coerce(v1, "number") <= _astqUtil.default.coerce(v2, "number");
        break;
      case ">=":
        result = _astqUtil.default.coerce(v1, "number") >= _astqUtil.default.coerce(v2, "number");
        break;
      case "<":
        result = _astqUtil.default.coerce(v1, "number") < _astqUtil.default.coerce(v2, "number");
        break;
      case ">":
        result = _astqUtil.default.coerce(v1, "number") > _astqUtil.default.coerce(v2, "number");
        break;
      case "=~":
        result = _astqUtil.default.coerce(v1, "string").match(_astqUtil.default.coerce(v2, "regexp")) !== null;
        break;
      case "!~":
        result = _astqUtil.default.coerce(v1, "string").match(_astqUtil.default.coerce(v2, "regexp")) === null;
        break;
    }
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprArithmetical(Q, T) {
    this.traceBegin(Q, T);
    let v1 = this.execExpr(Q.childs()[0], T);
    let v2 = this.execExpr(Q.childs()[1], T);
    let result;
    switch (Q.get("op")) {
      case "+":
        if (typeof v1 === "string") result = v1 + _astqUtil.default.coerce(v2, "string");else result = _astqUtil.default.coerce(v1, "number") + _astqUtil.default.coerce(v2, "number");
        break;
      case "-":
        result = _astqUtil.default.coerce(v1, "number") + _astqUtil.default.coerce(v2, "number");
        break;
      case "*":
        result = _astqUtil.default.coerce(v1, "number") * _astqUtil.default.coerce(v2, "number");
        break;
      case "/":
        result = _astqUtil.default.coerce(v1, "number") / _astqUtil.default.coerce(v2, "number");
        break;
      case "%":
        result = _astqUtil.default.coerce(v1, "number") % _astqUtil.default.coerce(v2, "number");
        break;
      case "**":
        result = Math.pow(_astqUtil.default.coerce(v1, "number"), _astqUtil.default.coerce(v2, "number"));
        break;
    }
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprUnary(Q, T) {
    this.traceBegin(Q, T);
    let v = this.execExpr(Q.childs()[0], T);
    let result;
    /* jscs: disable */
    switch (Q.get("op")) {
      case "!":
        result = !_astqUtil.default.coerce(v, "boolean");
        break;
      case "~":
        result = ~_astqUtil.default.coerce(v, "number");
        break;
    }
    /* jscs: enable */
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprFuncCall(Q, T) {
    this.traceBegin(Q, T);
    let id = Q.get("id");
    let args = [this.adapter, T];
    Q.childs().forEach(Q => {
      args.push(this.execExpr(Q, T));
    });
    let result = this.funcs.run(id, args);
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprAttribute(Q, T) {
    this.traceBegin(Q, T);
    let id = Q.get("id");
    let result = this.adapter.getNodeAttrValue(T, id);
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprParam(Q, T) {
    this.traceBegin(Q, T);
    let id = Q.get("id");
    if (typeof this.params[id] === "undefined") throw new Error("invalid parameter \"" + id + "\"");
    let result = this.params[id];
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprLiteralString(Q, T) {
    this.traceBegin(Q, T);
    let result = Q.get("value");
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprLiteralRegExp(Q, T) {
    this.traceBegin(Q, T);
    let result = Q.get("value");
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprLiteralNumber(Q, T) {
    this.traceBegin(Q, T);
    let result = Q.get("value");
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprLiteralValue(Q, T) {
    this.traceBegin(Q, T);
    let result = Q.get("value");
    this.traceEnd(Q, T, result);
    return result;
  }
  execExprPath(Q, T) {
    this.traceBegin(Q, T);
    let result = this.execPath(Q, T);
    this.traceEnd(Q, T, result);
    return result;
  }
}
exports.default = ASTQQueryExec;

},{"./astq-query-trace.js":13,"./astq-util.js":15}],13:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _astqUtil = _interopRequireDefault(require("./astq-util.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/* eslint no-console: 0 */

class ASTQQueryTrace {
  /*  determine output prefix based on tree depth  */
  prefixOf(Q, T) {
    let depth = 0;
    let node = Q;
    while ((node = node.parent()) !== null) depth++;
    let prefix1 = _astqUtil.default.pad("", 4 * depth);
    depth = 0;
    node = T;
    while ((node = this.adapter.getParentNode(node, "*")) !== null) depth++;
    let prefix2 = _astqUtil.default.pad("", 4 * depth);
    return {
      prefix1,
      prefix2
    };
  }

  /*  begin tracing step  */
  traceBegin(Q, T) {
    if (!this.trace) return;
    let {
      prefix1,
      prefix2
    } = this.prefixOf(Q, T);
    console.log("ASTQ: execute: | " + _astqUtil.default.pad(prefix1 + Q.type() + " (", -60) + " | " + prefix2 + this.adapter.getNodeType(T));
  }

  /*  end tracing step  */
  traceEnd(Q, T, val) {
    if (!this.trace) return;
    let {
      prefix1,
      prefix2
    } = this.prefixOf(Q, T);
    let result;
    if (val === undefined) result = "undefined";else if (typeof val === "object" && val instanceof Array) {
      result = "[";
      val.forEach(node => {
        result += "node(" + this.adapter.getNodeType(node) + "),";
      });
      result = result.replace(/,$/, "") + "]";
    } else result = typeof val + "(" + val + ")";
    if (result.length > 60) result = result.substr(0, 60) + "...";
    console.log("ASTQ: execute: | " + _astqUtil.default.pad(prefix1 + "): " + result, -60) + " | " + prefix2 + this.adapter.getNodeType(T));
  }
}
exports.default = ASTQQueryTrace;

},{"./astq-util.js":15}],14:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _asty = _interopRequireDefault(require("asty"));
var _pegjsUtil = _interopRequireDefault(require("pegjs-util"));
var _astqQueryExec = _interopRequireDefault(require("./astq-query-exec.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/* eslint no-console: off */

/*  load external dependencies  */

/*  get query executor  */

/*  get query parser (by loading and on-the-fly compiling PEG.js grammar)  */

const ASTQQueryParse = (// @generated by Peggy 4.0.2.
//
// https://peggyjs.org/
(function() {
  "use strict";

function peg$subclass(child, parent) {
  function C() { this.constructor = child; }
  C.prototype = parent.prototype;
  child.prototype = new C();
}

function peg$SyntaxError(message, expected, found, location) {
  var self = Error.call(this, message);
  // istanbul ignore next Check is a necessary evil to support older environments
  if (Object.setPrototypeOf) {
    Object.setPrototypeOf(self, peg$SyntaxError.prototype);
  }
  self.expected = expected;
  self.found = found;
  self.location = location;
  self.name = "SyntaxError";
  return self;
}

peg$subclass(peg$SyntaxError, Error);

function peg$padEnd(str, targetLength, padString) {
  padString = padString || " ";
  if (str.length > targetLength) { return str; }
  targetLength -= str.length;
  padString += padString.repeat(targetLength);
  return str + padString.slice(0, targetLength);
}

peg$SyntaxError.prototype.format = function(sources) {
  var str = "Error: " + this.message;
  if (this.location) {
    var src = null;
    var k;
    for (k = 0; k < sources.length; k++) {
      if (sources[k].source === this.location.source) {
        src = sources[k].text.split(/\r\n|\n|\r/g);
        break;
      }
    }
    var s = this.location.start;
    var offset_s = (this.location.source && (typeof this.location.source.offset === "function"))
      ? this.location.source.offset(s)
      : s;
    var loc = this.location.source + ":" + offset_s.line + ":" + offset_s.column;
    if (src) {
      var e = this.location.end;
      var filler = peg$padEnd("", offset_s.line.toString().length, ' ');
      var line = src[s.line - 1];
      var last = s.line === e.line ? e.column : line.length + 1;
      var hatLen = (last - s.column) || 1;
      str += "\n --> " + loc + "\n"
          + filler + " |\n"
          + offset_s.line + " | " + line + "\n"
          + filler + " | " + peg$padEnd("", s.column - 1, ' ')
          + peg$padEnd("", hatLen, "^");
    } else {
      str += "\n at " + loc;
    }
  }
  return str;
};

peg$SyntaxError.buildMessage = function(expected, found) {
  var DESCRIBE_EXPECTATION_FNS = {
    literal: function(expectation) {
      return "\"" + literalEscape(expectation.text) + "\"";
    },

    class: function(expectation) {
      var escapedParts = expectation.parts.map(function(part) {
        return Array.isArray(part)
          ? classEscape(part[0]) + "-" + classEscape(part[1])
          : classEscape(part);
      });

      return "[" + (expectation.inverted ? "^" : "") + escapedParts.join("") + "]";
    },

    any: function() {
      return "any character";
    },

    end: function() {
      return "end of input";
    },

    other: function(expectation) {
      return expectation.description;
    }
  };

  function hex(ch) {
    return ch.charCodeAt(0).toString(16).toUpperCase();
  }

  function literalEscape(s) {
    return s
      .replace(/\\/g, "\\\\")
      .replace(/"/g,  "\\\"")
      .replace(/\0/g, "\\0")
      .replace(/\t/g, "\\t")
      .replace(/\n/g, "\\n")
      .replace(/\r/g, "\\r")
      .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
      .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
  }

  function classEscape(s) {
    return s
      .replace(/\\/g, "\\\\")
      .replace(/\]/g, "\\]")
      .replace(/\^/g, "\\^")
      .replace(/-/g,  "\\-")
      .replace(/\0/g, "\\0")
      .replace(/\t/g, "\\t")
      .replace(/\n/g, "\\n")
      .replace(/\r/g, "\\r")
      .replace(/[\x00-\x0F]/g,          function(ch) { return "\\x0" + hex(ch); })
      .replace(/[\x10-\x1F\x7F-\x9F]/g, function(ch) { return "\\x"  + hex(ch); });
  }

  function describeExpectation(expectation) {
    return DESCRIBE_EXPECTATION_FNS[expectation.type](expectation);
  }

  function describeExpected(expected) {
    var descriptions = expected.map(describeExpectation);
    var i, j;

    descriptions.sort();

    if (descriptions.length > 0) {
      for (i = 1, j = 1; i < descriptions.length; i++) {
        if (descriptions[i - 1] !== descriptions[i]) {
          descriptions[j] = descriptions[i];
          j++;
        }
      }
      descriptions.length = j;
    }

    switch (descriptions.length) {
      case 1:
        return descriptions[0];

      case 2:
        return descriptions[0] + " or " + descriptions[1];

      default:
        return descriptions.slice(0, -1).join(", ")
          + ", or "
          + descriptions[descriptions.length - 1];
    }
  }

  function describeFound(found) {
    return found ? "\"" + literalEscape(found) + "\"" : "end of input";
  }

  return "Expected " + describeExpected(expected) + " but " + describeFound(found) + " found.";
};

function peg$parse(input, options) {
  options = options !== undefined ? options : {};

  var peg$FAILED = {};
  var peg$source = options.grammarSource;

  var peg$startRuleFunctions = { query: peg$parsequery };
  var peg$startRuleFunction = peg$parsequery;

  var peg$c0 = ",";
  var peg$c1 = "!";
  var peg$c2 = "//";
  var peg$c3 = "/";
  var peg$c4 = "-//";
  var peg$c5 = "-/";
  var peg$c6 = "+//";
  var peg$c7 = "+/";
  var peg$c8 = "~//";
  var peg$c9 = "~/";
  var peg$c10 = "..//";
  var peg$c11 = "../";
  var peg$c12 = ".//";
  var peg$c13 = "./";
  var peg$c14 = "<//";
  var peg$c15 = ">//";
  var peg$c16 = ":";
  var peg$c17 = "*";
  var peg$c18 = "[";
  var peg$c19 = "]";
  var peg$c20 = "?:";
  var peg$c21 = "?";
  var peg$c22 = "||";
  var peg$c23 = "&&";
  var peg$c24 = "|";
  var peg$c25 = "^";
  var peg$c26 = "&";
  var peg$c27 = "==";
  var peg$c28 = "!=";
  var peg$c29 = "<=";
  var peg$c30 = ">=";
  var peg$c31 = "=~";
  var peg$c32 = "!~";
  var peg$c33 = "<<";
  var peg$c34 = ">>";
  var peg$c35 = "**";
  var peg$c36 = "(";
  var peg$c37 = ")";
  var peg$c38 = "@";
  var peg$c39 = "{";
  var peg$c40 = "}";
  var peg$c41 = "\"";
  var peg$c42 = "'";
  var peg$c43 = "\\\\";
  var peg$c44 = "\\\"";
  var peg$c45 = "\\b";
  var peg$c46 = "\\v";
  var peg$c47 = "\\f";
  var peg$c48 = "\\t";
  var peg$c49 = "\\r";
  var peg$c50 = "\\n";
  var peg$c51 = "\\e";
  var peg$c52 = "\\x";
  var peg$c53 = "\\u";
  var peg$c54 = "\\'";
  var peg$c55 = "`";
  var peg$c56 = "\\`";
  var peg$c57 = "0b";
  var peg$c58 = "0o";
  var peg$c59 = "0x";
  var peg$c60 = ".";
  var peg$c61 = "true";
  var peg$c62 = "false";
  var peg$c63 = "null";
  var peg$c64 = "NaN";
  var peg$c65 = "undefined";
  var peg$c66 = "/*";
  var peg$c67 = "*/";

  var peg$r0 = /^[<>]/;
  var peg$r1 = /^[+\-]/;
  var peg$r2 = /^[%*\/]/;
  var peg$r3 = /^[!~]/;
  var peg$r4 = /^[a-zA-Z_]/;
  var peg$r5 = /^[a-zA-Z0-9_\-]/;
  var peg$r6 = /^[^"]/;
  var peg$r7 = /^[^']/;
  var peg$r8 = /^[0-9a-fA-F]/;
  var peg$r9 = /^[^`]/;
  var peg$r10 = /^[01]/;
  var peg$r11 = /^[0-7]/;
  var peg$r12 = /^[0-9]/;
  var peg$r13 = /^[eE]/;
  var peg$r14 = /^[ \t\r\n]/;

  var peg$e0 = peg$literalExpectation(",", false);
  var peg$e1 = peg$literalExpectation("!", false);
  var peg$e2 = peg$otherExpectation("axis");
  var peg$e3 = peg$literalExpectation("//", false);
  var peg$e4 = peg$literalExpectation("/", false);
  var peg$e5 = peg$literalExpectation("-//", false);
  var peg$e6 = peg$literalExpectation("-/", false);
  var peg$e7 = peg$literalExpectation("+//", false);
  var peg$e8 = peg$literalExpectation("+/", false);
  var peg$e9 = peg$literalExpectation("~//", false);
  var peg$e10 = peg$literalExpectation("~/", false);
  var peg$e11 = peg$literalExpectation("..//", false);
  var peg$e12 = peg$literalExpectation("../", false);
  var peg$e13 = peg$literalExpectation(".//", false);
  var peg$e14 = peg$literalExpectation("./", false);
  var peg$e15 = peg$literalExpectation("<//", false);
  var peg$e16 = peg$literalExpectation(">//", false);
  var peg$e17 = peg$literalExpectation(":", false);
  var peg$e18 = peg$literalExpectation("*", false);
  var peg$e19 = peg$literalExpectation("[", false);
  var peg$e20 = peg$literalExpectation("]", false);
  var peg$e21 = peg$literalExpectation("?:", false);
  var peg$e22 = peg$literalExpectation("?", false);
  var peg$e23 = peg$literalExpectation("||", false);
  var peg$e24 = peg$literalExpectation("&&", false);
  var peg$e25 = peg$literalExpectation("|", false);
  var peg$e26 = peg$literalExpectation("^", false);
  var peg$e27 = peg$literalExpectation("&", false);
  var peg$e28 = peg$literalExpectation("==", false);
  var peg$e29 = peg$literalExpectation("!=", false);
  var peg$e30 = peg$literalExpectation("<=", false);
  var peg$e31 = peg$literalExpectation(">=", false);
  var peg$e32 = peg$classExpectation(["<", ">"], false, false);
  var peg$e33 = peg$literalExpectation("=~", false);
  var peg$e34 = peg$literalExpectation("!~", false);
  var peg$e35 = peg$literalExpectation("<<", false);
  var peg$e36 = peg$literalExpectation(">>", false);
  var peg$e37 = peg$classExpectation(["+", "-"], false, false);
  var peg$e38 = peg$literalExpectation("**", false);
  var peg$e39 = peg$classExpectation(["%", "*", "/"], false, false);
  var peg$e40 = peg$classExpectation(["!", "~"], false, false);
  var peg$e41 = peg$literalExpectation("(", false);
  var peg$e42 = peg$literalExpectation(")", false);
  var peg$e43 = peg$otherExpectation("node attribute");
  var peg$e44 = peg$literalExpectation("@", false);
  var peg$e45 = peg$otherExpectation("query parameter reference");
  var peg$e46 = peg$literalExpectation("{", false);
  var peg$e47 = peg$literalExpectation("}", false);
  var peg$e48 = peg$otherExpectation("identifier");
  var peg$e49 = peg$classExpectation([["a", "z"], ["A", "Z"], "_"], false, false);
  var peg$e50 = peg$classExpectation([["a", "z"], ["A", "Z"], ["0", "9"], "_", "-"], false, false);
  var peg$e51 = peg$otherExpectation("quoted string literal");
  var peg$e52 = peg$literalExpectation("\"", false);
  var peg$e53 = peg$classExpectation(["\""], true, false);
  var peg$e54 = peg$literalExpectation("'", false);
  var peg$e55 = peg$classExpectation(["'"], true, false);
  var peg$e56 = peg$otherExpectation("escaped double-quoted-string character");
  var peg$e57 = peg$literalExpectation("\\\\", false);
  var peg$e58 = peg$literalExpectation("\\\"", false);
  var peg$e59 = peg$literalExpectation("\\b", false);
  var peg$e60 = peg$literalExpectation("\\v", false);
  var peg$e61 = peg$literalExpectation("\\f", false);
  var peg$e62 = peg$literalExpectation("\\t", false);
  var peg$e63 = peg$literalExpectation("\\r", false);
  var peg$e64 = peg$literalExpectation("\\n", false);
  var peg$e65 = peg$literalExpectation("\\e", false);
  var peg$e66 = peg$literalExpectation("\\x", false);
  var peg$e67 = peg$classExpectation([["0", "9"], ["a", "f"], ["A", "F"]], false, false);
  var peg$e68 = peg$literalExpectation("\\u", false);
  var peg$e69 = peg$otherExpectation("escaped single-quoted-string character");
  var peg$e70 = peg$literalExpectation("\\'", false);
  var peg$e71 = peg$otherExpectation("regular expression literal");
  var peg$e72 = peg$literalExpectation("`", false);
  var peg$e73 = peg$literalExpectation("\\`", false);
  var peg$e74 = peg$classExpectation(["`"], true, false);
  var peg$e75 = peg$otherExpectation("numeric literal");
  var peg$e76 = peg$literalExpectation("0b", false);
  var peg$e77 = peg$classExpectation(["0", "1"], false, false);
  var peg$e78 = peg$literalExpectation("0o", false);
  var peg$e79 = peg$classExpectation([["0", "7"]], false, false);
  var peg$e80 = peg$literalExpectation("0x", false);
  var peg$e81 = peg$classExpectation([["0", "9"]], false, false);
  var peg$e82 = peg$literalExpectation(".", false);
  var peg$e83 = peg$classExpectation(["e", "E"], false, false);
  var peg$e84 = peg$otherExpectation("global value");
  var peg$e85 = peg$literalExpectation("true", false);
  var peg$e86 = peg$literalExpectation("false", false);
  var peg$e87 = peg$literalExpectation("null", false);
  var peg$e88 = peg$literalExpectation("NaN", false);
  var peg$e89 = peg$literalExpectation("undefined", false);
  var peg$e90 = peg$otherExpectation("optional blank");
  var peg$e91 = peg$otherExpectation("multi-line comment");
  var peg$e92 = peg$literalExpectation("/*", false);
  var peg$e93 = peg$literalExpectation("*/", false);
  var peg$e94 = peg$anyExpectation();
  var peg$e95 = peg$otherExpectation("any whitespaces");
  var peg$e96 = peg$classExpectation([" ", "\t", "\r", "\n"], false, false);
  var peg$e97 = peg$otherExpectation("end of file");

  var peg$f0 = function(qs) {
            return qs
        };
  var peg$f1 = function(f, l) {
            return ast("Query").add(unroll(f, l, 3))
        };
  var peg$f2 = function(f, l) {
            return ast("Path").add(unroll(f, l, 1))
        };
  var peg$f3 = function(a, m, r, f) {
            return ast("Step").add(a, m, f).set(r !== null ? { isResult: true } : {})
        };
  var peg$f4 = function(a, m, r, f) {
            return ast("Step").add(a, m, f).set(r !== null ? { isResult: true } : {})
        };
  var peg$f5 = function(op, t) {
            return ast("Axis").set({ op: op, type: t !== null ? t : "*" })
        };
  var peg$f6 = function(id) {
            return id.get("id")
        };
  var peg$f7 = function(str) {
            return str.get("value")
        };
  var peg$f8 = function(id) {
            return ast("Match").merge(id)
        };
  var peg$f9 = function(str) {
            return ast("Match").set({ id: str.get("value") })
        };
  var peg$f10 = function() {
            return ast("Match").set({ id: "*" })
        };
  var peg$f11 = function(e) {
            return ast("Filter").add(e)
        };
  var peg$f12 = function(e1, e2) {
            return ast("ConditionalBinary").add(e1, e2)
        };
  var peg$f13 = function(e1, e2, e3) {
            return ast("ConditionalTernary").add(e1, e2, e3)
        };
  var peg$f14 = function(e1, op, e2) {
            return ast("Logical").set({ op: op }).add(e1, e2)
        };
  var peg$f15 = function(e1, op, e2) {
            return ast("Logical").set({ op: op }).add(e1, e2)
        };
  var peg$f16 = function(e1, op, e2) {
            return ast("Bitwise").set({ op: op }).add(e1, e2)
        };
  var peg$f17 = function(e1, op, e2) {
            return ast("Bitwise").set({ op: op }).add(e1, e2)
        };
  var peg$f18 = function(e1, op, e2) {
            return ast("Bitwise").set({ op: op }).add(e1, e2)
        };
  var peg$f19 = function(e1, op, e2) {
            return ast("Relational").set({ op: op }).add(e1, e2)
        };
  var peg$f20 = function(e1, op, e2) {
            return ast("Bitwise").set({ op: op }).add(e1, e2)
        };
  var peg$f21 = function(e1, op, e2) {
            return ast("Arithmetical").set({ op: op }).add(e1, e2)
        };
  var peg$f22 = function(e1, op, e2) {
            return ast("Arithmetical").set({ op: op }).add(e1, e2)
        };
  var peg$f23 = function(op, e) {
            return ast("Unary").set({ op: op }).add(e)
        };
  var peg$f24 = function(id, p) {
            return ast("FuncCall").merge(id).add(p)
        };
  var peg$f25 = function(f, l) { /* RECURSION */
            return unroll(f, l, 3)
        };
  var peg$f26 = function(id) {
            return ast("Attribute").merge(id)
        };
  var peg$f27 = function(str) {
            return ast("Attribute").set({ id: str.get("value") })
        };
  var peg$f28 = function(name) {
            return ast("Param").merge(name)
        };
  var peg$f29 = function(e) {  /* RECURSION */
             return e
        };
  var peg$f30 = function(id) {
            return ast("Identifier").set({ id: id })
        };
  var peg$f31 = function(s) {
            return ast("LiteralString").set({ value: s.join("") })
        };
  var peg$f32 = function(s) {
            return ast("LiteralString").set({ value: s.join("") })
        };
  var peg$f33 = function() { return "\\"   };
  var peg$f34 = function() { return "\""   };
  var peg$f35 = function() { return "\b"   };
  var peg$f36 = function() { return "\x0B" };
  var peg$f37 = function() { return "\f"   };
  var peg$f38 = function() { return "\t"   };
  var peg$f39 = function() { return "\r"   };
  var peg$f40 = function() { return "\n"   };
  var peg$f41 = function() { return "\x1B" };
  var peg$f42 = function(n) {
            return String.fromCharCode(parseInt(n, 16))
        };
  var peg$f43 = function(n) {
            return String.fromCharCode(parseInt(n, 16))
        };
  var peg$f44 = function() { return "'"    };
  var peg$f45 = function(re) {
            var v
            try { v = new RegExp(re.replace(/\\`/g, "`")) }
            catch (e) { error(e.message) }
            return ast("LiteralRegExp").set({ value: v })
        };
  var peg$f46 = function(s, n) {
            return ast("LiteralNumber").set({ value: parseInt(s + n, 2) })
        };
  var peg$f47 = function(s, n) {
            return ast("LiteralNumber").set({ value: parseInt(s + n, 8) })
        };
  var peg$f48 = function(s, n) {
            return ast("LiteralNumber").set({ value: parseInt(s + n, 16) })
        };
  var peg$f49 = function(n) {
            return ast("LiteralNumber").set({ value: parseFloat(n) })
        };
  var peg$f50 = function(n) {
            return ast("LiteralNumber").set({ value: parseInt(n, 10) })
        };
  var peg$f51 = function() { return ast("LiteralValue").set({ value: true      }) };
  var peg$f52 = function() { return ast("LiteralValue").set({ value: false     }) };
  var peg$f53 = function() { return ast("LiteralValue").set({ value: null      }) };
  var peg$f54 = function() { return ast("LiteralValue").set({ value: NaN       }) };
  var peg$f55 = function() { return ast("LiteralValue").set({ value: undefined }) };
  var peg$currPos = options.peg$currPos | 0;
  var peg$savedPos = peg$currPos;
  var peg$posDetailsCache = [{ line: 1, column: 1 }];
  var peg$maxFailPos = peg$currPos;
  var peg$maxFailExpected = options.peg$maxFailExpected || [];
  var peg$silentFails = options.peg$silentFails | 0;

  var peg$resultsCache = {};

  var peg$result;

  if (options.startRule) {
    if (!(options.startRule in peg$startRuleFunctions)) {
      throw new Error("Can't start parsing from rule \"" + options.startRule + "\".");
    }

    peg$startRuleFunction = peg$startRuleFunctions[options.startRule];
  }

  function text() {
    return input.substring(peg$savedPos, peg$currPos);
  }

  function offset() {
    return peg$savedPos;
  }

  function range() {
    return {
      source: peg$source,
      start: peg$savedPos,
      end: peg$currPos
    };
  }

  function location() {
    return peg$computeLocation(peg$savedPos, peg$currPos);
  }

  function expected(description, location) {
    location = location !== undefined
      ? location
      : peg$computeLocation(peg$savedPos, peg$currPos);

    throw peg$buildStructuredError(
      [peg$otherExpectation(description)],
      input.substring(peg$savedPos, peg$currPos),
      location
    );
  }

  function error(message, location) {
    location = location !== undefined
      ? location
      : peg$computeLocation(peg$savedPos, peg$currPos);

    throw peg$buildSimpleError(message, location);
  }

  function peg$literalExpectation(text, ignoreCase) {
    return { type: "literal", text: text, ignoreCase: ignoreCase };
  }

  function peg$classExpectation(parts, inverted, ignoreCase) {
    return { type: "class", parts: parts, inverted: inverted, ignoreCase: ignoreCase };
  }

  function peg$anyExpectation() {
    return { type: "any" };
  }

  function peg$endExpectation() {
    return { type: "end" };
  }

  function peg$otherExpectation(description) {
    return { type: "other", description: description };
  }

  function peg$computePosDetails(pos) {
    var details = peg$posDetailsCache[pos];
    var p;

    if (details) {
      return details;
    } else {
      if (pos >= peg$posDetailsCache.length) {
        p = peg$posDetailsCache.length - 1;
      } else {
        p = pos;
        while (!peg$posDetailsCache[--p]) {}
      }

      details = peg$posDetailsCache[p];
      details = {
        line: details.line,
        column: details.column
      };

      while (p < pos) {
        if (input.charCodeAt(p) === 10) {
          details.line++;
          details.column = 1;
        } else {
          details.column++;
        }

        p++;
      }

      peg$posDetailsCache[pos] = details;

      return details;
    }
  }

  function peg$computeLocation(startPos, endPos, offset) {
    var startPosDetails = peg$computePosDetails(startPos);
    var endPosDetails = peg$computePosDetails(endPos);

    var res = {
      source: peg$source,
      start: {
        offset: startPos,
        line: startPosDetails.line,
        column: startPosDetails.column
      },
      end: {
        offset: endPos,
        line: endPosDetails.line,
        column: endPosDetails.column
      }
    };
    if (offset && peg$source && (typeof peg$source.offset === "function")) {
      res.start = peg$source.offset(res.start);
      res.end = peg$source.offset(res.end);
    }
    return res;
  }

  function peg$fail(expected) {
    if (peg$currPos < peg$maxFailPos) { return; }

    if (peg$currPos > peg$maxFailPos) {
      peg$maxFailPos = peg$currPos;
      peg$maxFailExpected = [];
    }

    peg$maxFailExpected.push(expected);
  }

  function peg$buildSimpleError(message, location) {
    return new peg$SyntaxError(message, null, null, location);
  }

  function peg$buildStructuredError(expected, found, location) {
    return new peg$SyntaxError(
      peg$SyntaxError.buildMessage(expected, found),
      expected,
      found,
      location
    );
  }

  function peg$parsequery() {
    var s0, s1, s2, s3, s4;

    var key = peg$currPos * 38 + 0;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parse_();
    s2 = peg$parsequerySet();
    if (s2 !== peg$FAILED) {
      s3 = peg$parse_();
      s4 = peg$parseeof();
      if (s4 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f0(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequerySet() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var key = peg$currPos * 38 + 1;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parsequeryPath();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 44) {
        s5 = peg$c0;
        peg$currPos++;
      } else {
        s5 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e0); }
      }
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parsequeryPath();
        if (s7 !== peg$FAILED) {
          s4 = [s4, s5, s6, s7];
          s3 = s4;
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 44) {
          s5 = peg$c0;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e0); }
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parsequeryPath();
          if (s7 !== peg$FAILED) {
            s4 = [s4, s5, s6, s7];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f1(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequeryPath() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 2;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parsequeryStep();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      s5 = peg$parsequeryStepSubsequent();
      if (s5 !== peg$FAILED) {
        s4 = [s4, s5];
        s3 = s4;
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        s5 = peg$parsequeryStepSubsequent();
        if (s5 !== peg$FAILED) {
          s4 = [s4, s5];
          s3 = s4;
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f2(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequeryStep() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var key = peg$currPos * 38 + 3;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parsequeryAxis();
    if (s1 === peg$FAILED) {
      s1 = null;
    }
    s2 = peg$parse_();
    s3 = peg$parsequeryMatch();
    if (s3 !== peg$FAILED) {
      s4 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 33) {
        s5 = peg$c1;
        peg$currPos++;
      } else {
        s5 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e1); }
      }
      if (s5 === peg$FAILED) {
        s5 = null;
      }
      s6 = peg$parse_();
      s7 = peg$parsequeryFilter();
      if (s7 === peg$FAILED) {
        s7 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f3(s1, s3, s5, s7);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequeryStepSubsequent() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var key = peg$currPos * 38 + 4;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parsequeryAxis();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parsequeryMatch();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 33) {
          s5 = peg$c1;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e1); }
        }
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        s7 = peg$parsequeryFilter();
        if (s7 === peg$FAILED) {
          s7 = null;
        }
        peg$savedPos = s0;
        s0 = peg$f4(s1, s3, s5, s7);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequeryAxis() {
    var s0, s1, s2;

    var key = peg$currPos * 38 + 5;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    s1 = peg$currPos;
    if (input.substr(peg$currPos, 2) === peg$c2) {
      s2 = peg$c2;
      peg$currPos += 2;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e3); }
    }
    if (s2 === peg$FAILED) {
      if (input.charCodeAt(peg$currPos) === 47) {
        s2 = peg$c3;
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e4); }
      }
      if (s2 === peg$FAILED) {
        if (input.substr(peg$currPos, 3) === peg$c4) {
          s2 = peg$c4;
          peg$currPos += 3;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e5); }
        }
        if (s2 === peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c5) {
            s2 = peg$c5;
            peg$currPos += 2;
          } else {
            s2 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e6); }
          }
          if (s2 === peg$FAILED) {
            if (input.substr(peg$currPos, 3) === peg$c6) {
              s2 = peg$c6;
              peg$currPos += 3;
            } else {
              s2 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e7); }
            }
            if (s2 === peg$FAILED) {
              if (input.substr(peg$currPos, 2) === peg$c7) {
                s2 = peg$c7;
                peg$currPos += 2;
              } else {
                s2 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e8); }
              }
              if (s2 === peg$FAILED) {
                if (input.substr(peg$currPos, 3) === peg$c8) {
                  s2 = peg$c8;
                  peg$currPos += 3;
                } else {
                  s2 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e9); }
                }
                if (s2 === peg$FAILED) {
                  if (input.substr(peg$currPos, 2) === peg$c9) {
                    s2 = peg$c9;
                    peg$currPos += 2;
                  } else {
                    s2 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$e10); }
                  }
                  if (s2 === peg$FAILED) {
                    if (input.substr(peg$currPos, 4) === peg$c10) {
                      s2 = peg$c10;
                      peg$currPos += 4;
                    } else {
                      s2 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$e11); }
                    }
                    if (s2 === peg$FAILED) {
                      if (input.substr(peg$currPos, 3) === peg$c11) {
                        s2 = peg$c11;
                        peg$currPos += 3;
                      } else {
                        s2 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$e12); }
                      }
                      if (s2 === peg$FAILED) {
                        if (input.substr(peg$currPos, 3) === peg$c12) {
                          s2 = peg$c12;
                          peg$currPos += 3;
                        } else {
                          s2 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$e13); }
                        }
                        if (s2 === peg$FAILED) {
                          if (input.substr(peg$currPos, 2) === peg$c13) {
                            s2 = peg$c13;
                            peg$currPos += 2;
                          } else {
                            s2 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$e14); }
                          }
                          if (s2 === peg$FAILED) {
                            if (input.substr(peg$currPos, 3) === peg$c14) {
                              s2 = peg$c14;
                              peg$currPos += 3;
                            } else {
                              s2 = peg$FAILED;
                              if (peg$silentFails === 0) { peg$fail(peg$e15); }
                            }
                            if (s2 === peg$FAILED) {
                              if (input.substr(peg$currPos, 3) === peg$c15) {
                                s2 = peg$c15;
                                peg$currPos += 3;
                              } else {
                                s2 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$e16); }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    if (s2 !== peg$FAILED) {
      s1 = input.substring(s1, peg$currPos);
    } else {
      s1 = s2;
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parsequeryAxisType();
      if (s2 === peg$FAILED) {
        s2 = null;
      }
      peg$savedPos = s0;
      s0 = peg$f5(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e2); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequeryAxisType() {
    var s0, s1, s2;

    var key = peg$currPos * 38 + 6;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 58) {
      s1 = peg$c16;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e17); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseid();
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f6(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 58) {
        s1 = peg$c16;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e17); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsestring();
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f7(s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequeryMatch() {
    var s0, s1;

    var key = peg$currPos * 38 + 7;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseid();
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f8(s1);
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parsestring();
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f9(s1);
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.charCodeAt(peg$currPos) === 42) {
          s1 = peg$c17;
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e18); }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f10();
        }
        s0 = s1;
      }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsequeryFilter() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 8;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 91) {
      s1 = peg$c18;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e19); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseexprConditional();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 93) {
          s5 = peg$c19;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e20); }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f11(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprConditional() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9;

    var key = peg$currPos * 38 + 9;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprLogicalOr();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      if (input.substr(peg$currPos, 2) === peg$c20) {
        s3 = peg$c20;
        peg$currPos += 2;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e21); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprConditional();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f12(s1, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$parseexprLogicalOr();
      if (s1 !== peg$FAILED) {
        s2 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 63) {
          s3 = peg$c21;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e22); }
        }
        if (s3 !== peg$FAILED) {
          s4 = peg$parse_();
          s5 = peg$parseexprConditional();
          if (s5 !== peg$FAILED) {
            s6 = peg$parse_();
            if (input.charCodeAt(peg$currPos) === 58) {
              s7 = peg$c16;
              peg$currPos++;
            } else {
              s7 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e17); }
            }
            if (s7 !== peg$FAILED) {
              s8 = peg$parse_();
              s9 = peg$parseexprConditional();
              if (s9 !== peg$FAILED) {
                peg$savedPos = s0;
                s0 = peg$f13(s1, s5, s9);
              } else {
                peg$currPos = s0;
                s0 = peg$FAILED;
              }
            } else {
              peg$currPos = s0;
              s0 = peg$FAILED;
            }
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$parseexprLogicalOr();
      }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprLogicalOr() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 10;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprLogicalAnd();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      if (input.substr(peg$currPos, 2) === peg$c22) {
        s3 = peg$c22;
        peg$currPos += 2;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e23); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprLogicalOr();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f14(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprLogicalAnd();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprLogicalAnd() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 11;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprBitwiseOr();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      if (input.substr(peg$currPos, 2) === peg$c23) {
        s3 = peg$c23;
        peg$currPos += 2;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e24); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprLogicalAnd();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f15(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprBitwiseOr();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprBitwiseOr() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 12;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprBitwiseXOr();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 124) {
        s3 = peg$c24;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e25); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprBitwiseOr();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f16(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprBitwiseXOr();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprBitwiseXOr() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 13;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprBitwiseAnd();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 94) {
        s3 = peg$c25;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e26); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprBitwiseXOr();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f17(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprBitwiseAnd();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprBitwiseAnd() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 14;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprRelational();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 38) {
        s3 = peg$c26;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e27); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprBitwiseAnd();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f18(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprRelational();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprRelational() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 15;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprBitwiseShift();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c27) {
        s4 = peg$c27;
        peg$currPos += 2;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e28); }
      }
      if (s4 === peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c28) {
          s4 = peg$c28;
          peg$currPos += 2;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e29); }
        }
        if (s4 === peg$FAILED) {
          if (input.substr(peg$currPos, 2) === peg$c29) {
            s4 = peg$c29;
            peg$currPos += 2;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e30); }
          }
          if (s4 === peg$FAILED) {
            if (input.substr(peg$currPos, 2) === peg$c30) {
              s4 = peg$c30;
              peg$currPos += 2;
            } else {
              s4 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e31); }
            }
            if (s4 === peg$FAILED) {
              s4 = input.charAt(peg$currPos);
              if (peg$r0.test(s4)) {
                peg$currPos++;
              } else {
                s4 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e32); }
              }
              if (s4 === peg$FAILED) {
                if (input.substr(peg$currPos, 2) === peg$c31) {
                  s4 = peg$c31;
                  peg$currPos += 2;
                } else {
                  s4 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e33); }
                }
                if (s4 === peg$FAILED) {
                  if (input.substr(peg$currPos, 2) === peg$c32) {
                    s4 = peg$c32;
                    peg$currPos += 2;
                  } else {
                    s4 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$e34); }
                  }
                }
              }
            }
          }
        }
      }
      if (s4 !== peg$FAILED) {
        s3 = input.substring(s3, peg$currPos);
      } else {
        s3 = s4;
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprRelational();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f19(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprBitwiseShift();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprBitwiseShift() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 16;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprAdditive();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c33) {
        s4 = peg$c33;
        peg$currPos += 2;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e35); }
      }
      if (s4 === peg$FAILED) {
        if (input.substr(peg$currPos, 2) === peg$c34) {
          s4 = peg$c34;
          peg$currPos += 2;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e36); }
        }
      }
      if (s4 !== peg$FAILED) {
        s3 = input.substring(s3, peg$currPos);
      } else {
        s3 = s4;
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprBitwiseShift();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f20(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprAdditive();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprAdditive() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 17;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprMultiplicative();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = input.charAt(peg$currPos);
      if (peg$r1.test(s3)) {
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e37); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprAdditive();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f21(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprMultiplicative();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprMultiplicative() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 18;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprUnary();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c35) {
        s4 = peg$c35;
        peg$currPos += 2;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e38); }
      }
      if (s4 === peg$FAILED) {
        s4 = input.charAt(peg$currPos);
        if (peg$r2.test(s4)) {
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e39); }
        }
      }
      if (s4 !== peg$FAILED) {
        s3 = input.substring(s3, peg$currPos);
      } else {
        s3 = s4;
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprMultiplicative();
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f22(s1, s3, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprUnary();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprUnary() {
    var s0, s1, s2;

    var key = peg$currPos * 38 + 19;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = input.charAt(peg$currPos);
    if (peg$r3.test(s1)) {
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e40); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseexprOther();
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f23(s1, s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprOther();
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprOther() {
    var s0;

    var key = peg$currPos * 38 + 20;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$parseexprFunctionCall();
    if (s0 === peg$FAILED) {
      s0 = peg$parseexprAttribute();
      if (s0 === peg$FAILED) {
        s0 = peg$parseexprParam();
        if (s0 === peg$FAILED) {
          s0 = peg$parseexprLiteral();
          if (s0 === peg$FAILED) {
            s0 = peg$parseexprParenthesis();
            if (s0 === peg$FAILED) {
              s0 = peg$parsequeryPath();
            }
          }
        }
      }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprFunctionCall() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var key = peg$currPos * 38 + 21;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseid();
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 40) {
        s3 = peg$c36;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e41); }
      }
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        s5 = peg$parseexprFunctionCallParams();
        if (s5 === peg$FAILED) {
          s5 = null;
        }
        s6 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 41) {
          s7 = peg$c37;
          peg$currPos++;
        } else {
          s7 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e42); }
        }
        if (s7 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f24(s1, s5);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprFunctionCallParams() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var key = peg$currPos * 38 + 22;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    s1 = peg$parseexprConditional();
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$parse_();
      if (input.charCodeAt(peg$currPos) === 44) {
        s5 = peg$c0;
        peg$currPos++;
      } else {
        s5 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e0); }
      }
      if (s5 !== peg$FAILED) {
        s6 = peg$parse_();
        s7 = peg$parseexprConditional();
        if (s7 !== peg$FAILED) {
          s4 = [s4, s5, s6, s7];
          s3 = s4;
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 44) {
          s5 = peg$c0;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e0); }
        }
        if (s5 !== peg$FAILED) {
          s6 = peg$parse_();
          s7 = peg$parseexprConditional();
          if (s7 !== peg$FAILED) {
            s4 = [s4, s5, s6, s7];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      peg$savedPos = s0;
      s0 = peg$f25(s1, s2);
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprAttribute() {
    var s0, s1, s2;

    var key = peg$currPos * 38 + 23;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 64) {
      s1 = peg$c38;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e44); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parseid();
      if (s2 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f26(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 64) {
        s1 = peg$c38;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e44); }
      }
      if (s1 !== peg$FAILED) {
        s2 = peg$parsestring();
        if (s2 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f27(s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e43); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprParam() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 24;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 123) {
      s1 = peg$c39;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e46); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseid();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 125) {
          s5 = peg$c40;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e47); }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f28(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e45); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprLiteral() {
    var s0;

    var key = peg$currPos * 38 + 25;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$parsestring();
    if (s0 === peg$FAILED) {
      s0 = peg$parseregexp();
      if (s0 === peg$FAILED) {
        s0 = peg$parsenumber();
        if (s0 === peg$FAILED) {
          s0 = peg$parsevalue();
        }
      }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseexprParenthesis() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 26;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 40) {
      s1 = peg$c36;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e41); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$parse_();
      s3 = peg$parseexprConditional();
      if (s3 !== peg$FAILED) {
        s4 = peg$parse_();
        if (input.charCodeAt(peg$currPos) === 41) {
          s5 = peg$c37;
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e42); }
        }
        if (s5 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f29(s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseid() {
    var s0, s1, s2, s3, s4, s5, s6;

    var key = peg$currPos * 38 + 27;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = peg$currPos;
    s3 = peg$currPos;
    peg$silentFails++;
    s4 = peg$parsevalue();
    peg$silentFails--;
    if (s4 === peg$FAILED) {
      s3 = undefined;
    } else {
      peg$currPos = s3;
      s3 = peg$FAILED;
    }
    if (s3 !== peg$FAILED) {
      s4 = input.charAt(peg$currPos);
      if (peg$r4.test(s4)) {
        peg$currPos++;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e49); }
      }
      if (s4 !== peg$FAILED) {
        s5 = [];
        s6 = input.charAt(peg$currPos);
        if (peg$r5.test(s6)) {
          peg$currPos++;
        } else {
          s6 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e50); }
        }
        while (s6 !== peg$FAILED) {
          s5.push(s6);
          s6 = input.charAt(peg$currPos);
          if (peg$r5.test(s6)) {
            peg$currPos++;
          } else {
            s6 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e50); }
          }
        }
        s3 = [s3, s4, s5];
        s2 = s3;
      } else {
        peg$currPos = s2;
        s2 = peg$FAILED;
      }
    } else {
      peg$currPos = s2;
      s2 = peg$FAILED;
    }
    if (s2 !== peg$FAILED) {
      s1 = input.substring(s1, peg$currPos);
    } else {
      s1 = s2;
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f30(s1);
    }
    s0 = s1;
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e48); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsestring() {
    var s0, s1, s2, s3;

    var key = peg$currPos * 38 + 28;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 34) {
      s1 = peg$c41;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e52); }
    }
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$parsestringEscapedCharDQ();
      if (s3 === peg$FAILED) {
        s3 = input.charAt(peg$currPos);
        if (peg$r6.test(s3)) {
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e53); }
        }
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$parsestringEscapedCharDQ();
        if (s3 === peg$FAILED) {
          s3 = input.charAt(peg$currPos);
          if (peg$r6.test(s3)) {
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e53); }
          }
        }
      }
      if (input.charCodeAt(peg$currPos) === 34) {
        s3 = peg$c41;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e52); }
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f31(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      if (input.charCodeAt(peg$currPos) === 39) {
        s1 = peg$c42;
        peg$currPos++;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e54); }
      }
      if (s1 !== peg$FAILED) {
        s2 = [];
        s3 = peg$parsestringEscapedCharSQ();
        if (s3 === peg$FAILED) {
          s3 = input.charAt(peg$currPos);
          if (peg$r7.test(s3)) {
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e55); }
          }
        }
        while (s3 !== peg$FAILED) {
          s2.push(s3);
          s3 = peg$parsestringEscapedCharSQ();
          if (s3 === peg$FAILED) {
            s3 = input.charAt(peg$currPos);
            if (peg$r7.test(s3)) {
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e55); }
            }
          }
        }
        if (input.charCodeAt(peg$currPos) === 39) {
          s3 = peg$c42;
          peg$currPos++;
        } else {
          s3 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e54); }
        }
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f32(s2);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e51); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsestringEscapedCharDQ() {
    var s0, s1, s2, s3, s4, s5, s6, s7;

    var key = peg$currPos * 38 + 29;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.substr(peg$currPos, 2) === peg$c43) {
      s1 = peg$c43;
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e57); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f33();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      if (input.substr(peg$currPos, 2) === peg$c44) {
        s1 = peg$c44;
        peg$currPos += 2;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e58); }
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f34();
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 2) === peg$c45) {
          s1 = peg$c45;
          peg$currPos += 2;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e59); }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f35();
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 2) === peg$c46) {
            s1 = peg$c46;
            peg$currPos += 2;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e60); }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$f36();
          }
          s0 = s1;
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.substr(peg$currPos, 2) === peg$c47) {
              s1 = peg$c47;
              peg$currPos += 2;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e61); }
            }
            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$f37();
            }
            s0 = s1;
            if (s0 === peg$FAILED) {
              s0 = peg$currPos;
              if (input.substr(peg$currPos, 2) === peg$c48) {
                s1 = peg$c48;
                peg$currPos += 2;
              } else {
                s1 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e62); }
              }
              if (s1 !== peg$FAILED) {
                peg$savedPos = s0;
                s1 = peg$f38();
              }
              s0 = s1;
              if (s0 === peg$FAILED) {
                s0 = peg$currPos;
                if (input.substr(peg$currPos, 2) === peg$c49) {
                  s1 = peg$c49;
                  peg$currPos += 2;
                } else {
                  s1 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e63); }
                }
                if (s1 !== peg$FAILED) {
                  peg$savedPos = s0;
                  s1 = peg$f39();
                }
                s0 = s1;
                if (s0 === peg$FAILED) {
                  s0 = peg$currPos;
                  if (input.substr(peg$currPos, 2) === peg$c50) {
                    s1 = peg$c50;
                    peg$currPos += 2;
                  } else {
                    s1 = peg$FAILED;
                    if (peg$silentFails === 0) { peg$fail(peg$e64); }
                  }
                  if (s1 !== peg$FAILED) {
                    peg$savedPos = s0;
                    s1 = peg$f40();
                  }
                  s0 = s1;
                  if (s0 === peg$FAILED) {
                    s0 = peg$currPos;
                    if (input.substr(peg$currPos, 2) === peg$c51) {
                      s1 = peg$c51;
                      peg$currPos += 2;
                    } else {
                      s1 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$e65); }
                    }
                    if (s1 !== peg$FAILED) {
                      peg$savedPos = s0;
                      s1 = peg$f41();
                    }
                    s0 = s1;
                    if (s0 === peg$FAILED) {
                      s0 = peg$currPos;
                      if (input.substr(peg$currPos, 2) === peg$c52) {
                        s1 = peg$c52;
                        peg$currPos += 2;
                      } else {
                        s1 = peg$FAILED;
                        if (peg$silentFails === 0) { peg$fail(peg$e66); }
                      }
                      if (s1 !== peg$FAILED) {
                        s2 = peg$currPos;
                        s3 = peg$currPos;
                        s4 = input.charAt(peg$currPos);
                        if (peg$r8.test(s4)) {
                          peg$currPos++;
                        } else {
                          s4 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$e67); }
                        }
                        if (s4 !== peg$FAILED) {
                          s5 = input.charAt(peg$currPos);
                          if (peg$r8.test(s5)) {
                            peg$currPos++;
                          } else {
                            s5 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$e67); }
                          }
                          if (s5 !== peg$FAILED) {
                            s4 = [s4, s5];
                            s3 = s4;
                          } else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s3;
                          s3 = peg$FAILED;
                        }
                        if (s3 !== peg$FAILED) {
                          s2 = input.substring(s2, peg$currPos);
                        } else {
                          s2 = s3;
                        }
                        if (s2 !== peg$FAILED) {
                          peg$savedPos = s0;
                          s0 = peg$f42(s2);
                        } else {
                          peg$currPos = s0;
                          s0 = peg$FAILED;
                        }
                      } else {
                        peg$currPos = s0;
                        s0 = peg$FAILED;
                      }
                      if (s0 === peg$FAILED) {
                        s0 = peg$currPos;
                        if (input.substr(peg$currPos, 2) === peg$c53) {
                          s1 = peg$c53;
                          peg$currPos += 2;
                        } else {
                          s1 = peg$FAILED;
                          if (peg$silentFails === 0) { peg$fail(peg$e68); }
                        }
                        if (s1 !== peg$FAILED) {
                          s2 = peg$currPos;
                          s3 = peg$currPos;
                          s4 = input.charAt(peg$currPos);
                          if (peg$r8.test(s4)) {
                            peg$currPos++;
                          } else {
                            s4 = peg$FAILED;
                            if (peg$silentFails === 0) { peg$fail(peg$e67); }
                          }
                          if (s4 !== peg$FAILED) {
                            s5 = input.charAt(peg$currPos);
                            if (peg$r8.test(s5)) {
                              peg$currPos++;
                            } else {
                              s5 = peg$FAILED;
                              if (peg$silentFails === 0) { peg$fail(peg$e67); }
                            }
                            if (s5 !== peg$FAILED) {
                              s6 = input.charAt(peg$currPos);
                              if (peg$r8.test(s6)) {
                                peg$currPos++;
                              } else {
                                s6 = peg$FAILED;
                                if (peg$silentFails === 0) { peg$fail(peg$e67); }
                              }
                              if (s6 !== peg$FAILED) {
                                s7 = input.charAt(peg$currPos);
                                if (peg$r8.test(s7)) {
                                  peg$currPos++;
                                } else {
                                  s7 = peg$FAILED;
                                  if (peg$silentFails === 0) { peg$fail(peg$e67); }
                                }
                                if (s7 !== peg$FAILED) {
                                  s4 = [s4, s5, s6, s7];
                                  s3 = s4;
                                } else {
                                  peg$currPos = s3;
                                  s3 = peg$FAILED;
                                }
                              } else {
                                peg$currPos = s3;
                                s3 = peg$FAILED;
                              }
                            } else {
                              peg$currPos = s3;
                              s3 = peg$FAILED;
                            }
                          } else {
                            peg$currPos = s3;
                            s3 = peg$FAILED;
                          }
                          if (s3 !== peg$FAILED) {
                            s2 = input.substring(s2, peg$currPos);
                          } else {
                            s2 = s3;
                          }
                          if (s2 !== peg$FAILED) {
                            peg$savedPos = s0;
                            s0 = peg$f43(s2);
                          } else {
                            peg$currPos = s0;
                            s0 = peg$FAILED;
                          }
                        } else {
                          peg$currPos = s0;
                          s0 = peg$FAILED;
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e56); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsestringEscapedCharSQ() {
    var s0, s1;

    var key = peg$currPos * 38 + 30;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.substr(peg$currPos, 2) === peg$c54) {
      s1 = peg$c54;
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e70); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f44();
    }
    s0 = s1;
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e69); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseregexp() {
    var s0, s1, s2, s3, s4;

    var key = peg$currPos * 38 + 31;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.charCodeAt(peg$currPos) === 96) {
      s1 = peg$c55;
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e72); }
    }
    if (s1 !== peg$FAILED) {
      s2 = peg$currPos;
      s3 = [];
      if (input.substr(peg$currPos, 2) === peg$c56) {
        s4 = peg$c56;
        peg$currPos += 2;
      } else {
        s4 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e73); }
      }
      if (s4 === peg$FAILED) {
        s4 = input.charAt(peg$currPos);
        if (peg$r9.test(s4)) {
          peg$currPos++;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e74); }
        }
      }
      while (s4 !== peg$FAILED) {
        s3.push(s4);
        if (input.substr(peg$currPos, 2) === peg$c56) {
          s4 = peg$c56;
          peg$currPos += 2;
        } else {
          s4 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e73); }
        }
        if (s4 === peg$FAILED) {
          s4 = input.charAt(peg$currPos);
          if (peg$r9.test(s4)) {
            peg$currPos++;
          } else {
            s4 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e74); }
          }
        }
      }
      s2 = input.substring(s2, peg$currPos);
      if (input.charCodeAt(peg$currPos) === 96) {
        s3 = peg$c55;
        peg$currPos++;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e72); }
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f45(s2);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e71); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsenumber() {
    var s0, s1, s2, s3, s4, s5, s6, s7, s8, s9, s10, s11;

    var key = peg$currPos * 38 + 32;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    s1 = peg$currPos;
    s2 = input.charAt(peg$currPos);
    if (peg$r1.test(s2)) {
      peg$currPos++;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e37); }
    }
    if (s2 === peg$FAILED) {
      s2 = null;
    }
    s1 = input.substring(s1, peg$currPos);
    if (input.substr(peg$currPos, 2) === peg$c57) {
      s2 = peg$c57;
      peg$currPos += 2;
    } else {
      s2 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e76); }
    }
    if (s2 !== peg$FAILED) {
      s3 = peg$currPos;
      s4 = [];
      s5 = input.charAt(peg$currPos);
      if (peg$r10.test(s5)) {
        peg$currPos++;
      } else {
        s5 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e77); }
      }
      if (s5 !== peg$FAILED) {
        while (s5 !== peg$FAILED) {
          s4.push(s5);
          s5 = input.charAt(peg$currPos);
          if (peg$r10.test(s5)) {
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e77); }
          }
        }
      } else {
        s4 = peg$FAILED;
      }
      if (s4 !== peg$FAILED) {
        s3 = input.substring(s3, peg$currPos);
      } else {
        s3 = s4;
      }
      if (s3 !== peg$FAILED) {
        peg$savedPos = s0;
        s0 = peg$f46(s1, s3);
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      s1 = peg$currPos;
      s2 = input.charAt(peg$currPos);
      if (peg$r1.test(s2)) {
        peg$currPos++;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e37); }
      }
      if (s2 === peg$FAILED) {
        s2 = null;
      }
      s1 = input.substring(s1, peg$currPos);
      if (input.substr(peg$currPos, 2) === peg$c58) {
        s2 = peg$c58;
        peg$currPos += 2;
      } else {
        s2 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e78); }
      }
      if (s2 !== peg$FAILED) {
        s3 = peg$currPos;
        s4 = [];
        s5 = input.charAt(peg$currPos);
        if (peg$r11.test(s5)) {
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e79); }
        }
        if (s5 !== peg$FAILED) {
          while (s5 !== peg$FAILED) {
            s4.push(s5);
            s5 = input.charAt(peg$currPos);
            if (peg$r11.test(s5)) {
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e79); }
            }
          }
        } else {
          s4 = peg$FAILED;
        }
        if (s4 !== peg$FAILED) {
          s3 = input.substring(s3, peg$currPos);
        } else {
          s3 = s4;
        }
        if (s3 !== peg$FAILED) {
          peg$savedPos = s0;
          s0 = peg$f47(s1, s3);
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        s1 = peg$currPos;
        s2 = input.charAt(peg$currPos);
        if (peg$r1.test(s2)) {
          peg$currPos++;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e37); }
        }
        if (s2 === peg$FAILED) {
          s2 = null;
        }
        s1 = input.substring(s1, peg$currPos);
        if (input.substr(peg$currPos, 2) === peg$c59) {
          s2 = peg$c59;
          peg$currPos += 2;
        } else {
          s2 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e80); }
        }
        if (s2 !== peg$FAILED) {
          s3 = peg$currPos;
          s4 = [];
          s5 = input.charAt(peg$currPos);
          if (peg$r8.test(s5)) {
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e67); }
          }
          if (s5 !== peg$FAILED) {
            while (s5 !== peg$FAILED) {
              s4.push(s5);
              s5 = input.charAt(peg$currPos);
              if (peg$r8.test(s5)) {
                peg$currPos++;
              } else {
                s5 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e67); }
              }
            }
          } else {
            s4 = peg$FAILED;
          }
          if (s4 !== peg$FAILED) {
            s3 = input.substring(s3, peg$currPos);
          } else {
            s3 = s4;
          }
          if (s3 !== peg$FAILED) {
            peg$savedPos = s0;
            s0 = peg$f48(s1, s3);
          } else {
            peg$currPos = s0;
            s0 = peg$FAILED;
          }
        } else {
          peg$currPos = s0;
          s0 = peg$FAILED;
        }
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          s1 = peg$currPos;
          s2 = peg$currPos;
          s3 = input.charAt(peg$currPos);
          if (peg$r1.test(s3)) {
            peg$currPos++;
          } else {
            s3 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e37); }
          }
          if (s3 === peg$FAILED) {
            s3 = null;
          }
          s4 = [];
          s5 = input.charAt(peg$currPos);
          if (peg$r12.test(s5)) {
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e81); }
          }
          while (s5 !== peg$FAILED) {
            s4.push(s5);
            s5 = input.charAt(peg$currPos);
            if (peg$r12.test(s5)) {
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e81); }
            }
          }
          if (input.charCodeAt(peg$currPos) === 46) {
            s5 = peg$c60;
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e82); }
          }
          if (s5 !== peg$FAILED) {
            s6 = [];
            s7 = input.charAt(peg$currPos);
            if (peg$r12.test(s7)) {
              peg$currPos++;
            } else {
              s7 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e81); }
            }
            if (s7 !== peg$FAILED) {
              while (s7 !== peg$FAILED) {
                s6.push(s7);
                s7 = input.charAt(peg$currPos);
                if (peg$r12.test(s7)) {
                  peg$currPos++;
                } else {
                  s7 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e81); }
                }
              }
            } else {
              s6 = peg$FAILED;
            }
            if (s6 !== peg$FAILED) {
              s7 = peg$currPos;
              s8 = input.charAt(peg$currPos);
              if (peg$r13.test(s8)) {
                peg$currPos++;
              } else {
                s8 = peg$FAILED;
                if (peg$silentFails === 0) { peg$fail(peg$e83); }
              }
              if (s8 !== peg$FAILED) {
                s9 = input.charAt(peg$currPos);
                if (peg$r1.test(s9)) {
                  peg$currPos++;
                } else {
                  s9 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e37); }
                }
                if (s9 === peg$FAILED) {
                  s9 = null;
                }
                s10 = [];
                s11 = input.charAt(peg$currPos);
                if (peg$r12.test(s11)) {
                  peg$currPos++;
                } else {
                  s11 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e81); }
                }
                if (s11 !== peg$FAILED) {
                  while (s11 !== peg$FAILED) {
                    s10.push(s11);
                    s11 = input.charAt(peg$currPos);
                    if (peg$r12.test(s11)) {
                      peg$currPos++;
                    } else {
                      s11 = peg$FAILED;
                      if (peg$silentFails === 0) { peg$fail(peg$e81); }
                    }
                  }
                } else {
                  s10 = peg$FAILED;
                }
                if (s10 !== peg$FAILED) {
                  s8 = [s8, s9, s10];
                  s7 = s8;
                } else {
                  peg$currPos = s7;
                  s7 = peg$FAILED;
                }
              } else {
                peg$currPos = s7;
                s7 = peg$FAILED;
              }
              if (s7 === peg$FAILED) {
                s7 = null;
              }
              s3 = [s3, s4, s5, s6, s7];
              s2 = s3;
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
          } else {
            peg$currPos = s2;
            s2 = peg$FAILED;
          }
          if (s2 !== peg$FAILED) {
            s1 = input.substring(s1, peg$currPos);
          } else {
            s1 = s2;
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$f49(s1);
          }
          s0 = s1;
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            s1 = peg$currPos;
            s2 = peg$currPos;
            s3 = input.charAt(peg$currPos);
            if (peg$r1.test(s3)) {
              peg$currPos++;
            } else {
              s3 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e37); }
            }
            if (s3 === peg$FAILED) {
              s3 = null;
            }
            s4 = [];
            s5 = input.charAt(peg$currPos);
            if (peg$r12.test(s5)) {
              peg$currPos++;
            } else {
              s5 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e81); }
            }
            if (s5 !== peg$FAILED) {
              while (s5 !== peg$FAILED) {
                s4.push(s5);
                s5 = input.charAt(peg$currPos);
                if (peg$r12.test(s5)) {
                  peg$currPos++;
                } else {
                  s5 = peg$FAILED;
                  if (peg$silentFails === 0) { peg$fail(peg$e81); }
                }
              }
            } else {
              s4 = peg$FAILED;
            }
            if (s4 !== peg$FAILED) {
              s3 = [s3, s4];
              s2 = s3;
            } else {
              peg$currPos = s2;
              s2 = peg$FAILED;
            }
            if (s2 !== peg$FAILED) {
              s1 = input.substring(s1, peg$currPos);
            } else {
              s1 = s2;
            }
            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$f50(s1);
            }
            s0 = s1;
          }
        }
      }
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e75); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsevalue() {
    var s0, s1;

    var key = peg$currPos * 38 + 33;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.substr(peg$currPos, 4) === peg$c61) {
      s1 = peg$c61;
      peg$currPos += 4;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e85); }
    }
    if (s1 !== peg$FAILED) {
      peg$savedPos = s0;
      s1 = peg$f51();
    }
    s0 = s1;
    if (s0 === peg$FAILED) {
      s0 = peg$currPos;
      if (input.substr(peg$currPos, 5) === peg$c62) {
        s1 = peg$c62;
        peg$currPos += 5;
      } else {
        s1 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e86); }
      }
      if (s1 !== peg$FAILED) {
        peg$savedPos = s0;
        s1 = peg$f52();
      }
      s0 = s1;
      if (s0 === peg$FAILED) {
        s0 = peg$currPos;
        if (input.substr(peg$currPos, 4) === peg$c63) {
          s1 = peg$c63;
          peg$currPos += 4;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e87); }
        }
        if (s1 !== peg$FAILED) {
          peg$savedPos = s0;
          s1 = peg$f53();
        }
        s0 = s1;
        if (s0 === peg$FAILED) {
          s0 = peg$currPos;
          if (input.substr(peg$currPos, 3) === peg$c64) {
            s1 = peg$c64;
            peg$currPos += 3;
          } else {
            s1 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e88); }
          }
          if (s1 !== peg$FAILED) {
            peg$savedPos = s0;
            s1 = peg$f54();
          }
          s0 = s1;
          if (s0 === peg$FAILED) {
            s0 = peg$currPos;
            if (input.substr(peg$currPos, 9) === peg$c65) {
              s1 = peg$c65;
              peg$currPos += 9;
            } else {
              s1 = peg$FAILED;
              if (peg$silentFails === 0) { peg$fail(peg$e89); }
            }
            if (s1 !== peg$FAILED) {
              peg$savedPos = s0;
              s1 = peg$f55();
            }
            s0 = s1;
          }
        }
      }
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e84); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parse_() {
    var s0, s1;

    var key = peg$currPos * 38 + 34;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = [];
    s1 = peg$parseco();
    if (s1 === peg$FAILED) {
      s1 = peg$parsews();
    }
    while (s1 !== peg$FAILED) {
      s0.push(s1);
      s1 = peg$parseco();
      if (s1 === peg$FAILED) {
        s1 = peg$parsews();
      }
    }
    peg$silentFails--;
    s1 = peg$FAILED;
    if (peg$silentFails === 0) { peg$fail(peg$e90); }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseco() {
    var s0, s1, s2, s3, s4, s5;

    var key = peg$currPos * 38 + 35;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    if (input.substr(peg$currPos, 2) === peg$c66) {
      s1 = peg$c66;
      peg$currPos += 2;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e92); }
    }
    if (s1 !== peg$FAILED) {
      s2 = [];
      s3 = peg$currPos;
      s4 = peg$currPos;
      peg$silentFails++;
      if (input.substr(peg$currPos, 2) === peg$c67) {
        s5 = peg$c67;
        peg$currPos += 2;
      } else {
        s5 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e93); }
      }
      peg$silentFails--;
      if (s5 === peg$FAILED) {
        s4 = undefined;
      } else {
        peg$currPos = s4;
        s4 = peg$FAILED;
      }
      if (s4 !== peg$FAILED) {
        if (input.length > peg$currPos) {
          s5 = input.charAt(peg$currPos);
          peg$currPos++;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e94); }
        }
        if (s5 !== peg$FAILED) {
          s4 = [s4, s5];
          s3 = s4;
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      } else {
        peg$currPos = s3;
        s3 = peg$FAILED;
      }
      while (s3 !== peg$FAILED) {
        s2.push(s3);
        s3 = peg$currPos;
        s4 = peg$currPos;
        peg$silentFails++;
        if (input.substr(peg$currPos, 2) === peg$c67) {
          s5 = peg$c67;
          peg$currPos += 2;
        } else {
          s5 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e93); }
        }
        peg$silentFails--;
        if (s5 === peg$FAILED) {
          s4 = undefined;
        } else {
          peg$currPos = s4;
          s4 = peg$FAILED;
        }
        if (s4 !== peg$FAILED) {
          if (input.length > peg$currPos) {
            s5 = input.charAt(peg$currPos);
            peg$currPos++;
          } else {
            s5 = peg$FAILED;
            if (peg$silentFails === 0) { peg$fail(peg$e94); }
          }
          if (s5 !== peg$FAILED) {
            s4 = [s4, s5];
            s3 = s4;
          } else {
            peg$currPos = s3;
            s3 = peg$FAILED;
          }
        } else {
          peg$currPos = s3;
          s3 = peg$FAILED;
        }
      }
      if (input.substr(peg$currPos, 2) === peg$c67) {
        s3 = peg$c67;
        peg$currPos += 2;
      } else {
        s3 = peg$FAILED;
        if (peg$silentFails === 0) { peg$fail(peg$e93); }
      }
      if (s3 !== peg$FAILED) {
        s1 = [s1, s2, s3];
        s0 = s1;
      } else {
        peg$currPos = s0;
        s0 = peg$FAILED;
      }
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e91); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parsews() {
    var s0, s1;

    var key = peg$currPos * 38 + 36;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = [];
    s1 = input.charAt(peg$currPos);
    if (peg$r14.test(s1)) {
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e96); }
    }
    if (s1 !== peg$FAILED) {
      while (s1 !== peg$FAILED) {
        s0.push(s1);
        s1 = input.charAt(peg$currPos);
        if (peg$r14.test(s1)) {
          peg$currPos++;
        } else {
          s1 = peg$FAILED;
          if (peg$silentFails === 0) { peg$fail(peg$e96); }
        }
      }
    } else {
      s0 = peg$FAILED;
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e95); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }

  function peg$parseeof() {
    var s0, s1;

    var key = peg$currPos * 38 + 37;
    var cached = peg$resultsCache[key];

    if (cached) {
      peg$currPos = cached.nextPos;

      return cached.result;
    }

    peg$silentFails++;
    s0 = peg$currPos;
    peg$silentFails++;
    if (input.length > peg$currPos) {
      s1 = input.charAt(peg$currPos);
      peg$currPos++;
    } else {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e94); }
    }
    peg$silentFails--;
    if (s1 === peg$FAILED) {
      s0 = undefined;
    } else {
      peg$currPos = s0;
      s0 = peg$FAILED;
    }
    peg$silentFails--;
    if (s0 === peg$FAILED) {
      s1 = peg$FAILED;
      if (peg$silentFails === 0) { peg$fail(peg$e97); }
    }

    peg$resultsCache[key] = { nextPos: peg$currPos, result: s0 };

    return s0;
  }


    /*  standard PEGUtil integration code  */
    var unroll = options.util.makeUnroll(location, options)
    var ast    = options.util.makeAST   (location, options)

  peg$result = peg$startRuleFunction();

  if (options.peg$library) {
    return /** @type {any} */ ({
      peg$result,
      peg$currPos,
      peg$FAILED,
      peg$maxFailExpected,
      peg$maxFailPos
    });
  }
  if (peg$result !== peg$FAILED && peg$currPos === input.length) {
    return peg$result;
  } else {
    if (peg$result !== peg$FAILED && peg$currPos < input.length) {
      peg$fail(peg$endExpectation());
    }

    throw peg$buildStructuredError(
      peg$maxFailExpected,
      peg$maxFailPos < input.length ? input.charAt(peg$maxFailPos) : null,
      peg$maxFailPos < input.length
        ? peg$computeLocation(peg$maxFailPos, peg$maxFailPos + 1)
        : peg$computeLocation(peg$maxFailPos, peg$maxFailPos)
    );
  }
}

  return {
    StartRules: ["query"],
    SyntaxError: peg$SyntaxError,
    parse: peg$parse
  };
})()
);
class ASTQQuery {
  /*  create a new instance of the query instance  */
  constructor(selector) {
    this.asty = new _asty.default();
    this.ast = null;
    if (selector) this.compile(selector);
  }

  /*  compile query selector into AST  */
  compile(selector, trace) {
    if (trace) console.log("ASTQ: compile: +---------------------------------------" + "----------------------------------------------------------------\n" + "ASTQ: compile: | " + selector);
    let result = _pegjsUtil.default.parse(ASTQQueryParse, selector, {
      startRule: "query",
      makeAST: (line, column, offset, args) => {
        return this.asty.create.apply(this.asty, args).pos(line, column, offset);
      }
    });
    if (result.error !== null) throw new Error("ASTQ: compile: query parsing failed:\n" + _pegjsUtil.default.errorMessage(result.error, true).replace(/^/mg, "ERROR: "));
    this.ast = result.ast;
    if (trace) console.log("ASTQ: compile: +---------------------------------------" + "----------------------------------------------------------------\n" + this.dump().replace(/\n$/, "").replace(/^/mg, "ASTQ: compile: | "));
    return this;
  }

  /*  dump the query AST  */
  dump() {
    return this.ast.dump();
  }

  /*  execute the query AST onto node  */
  execute(node, adapter, params, funcs, trace) {
    if (trace) console.log("ASTQ: execute: +---------------------------------------" + "----------------------------------------------------------------");
    let qe = new _astqQueryExec.default(adapter, params, funcs, trace);
    return qe.execQuery(this.ast, node);
  }
}
exports.default = ASTQQuery;

},{"./astq-query-exec.js":12,"asty":"asty","pegjs-util":"pegjs-util"}],15:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

class ASTQUtil {
  /*  pad a string with spaces to the left/right  */
  static pad(str, num) {
    let n = num < 0 ? -num : num;
    if (str.length > n) str = str.substr(0, n);else {
      let pad = Array(n + 1 - str.length).join(" ");
      str = num < 0 ? str + pad : pad + str;
    }
    return str;
  }

  /*  check whether value is "true" (or can be considered to be true)  */
  static truthy(value) {
    let result;
    switch (typeof value) {
      case "boolean":
        result = value;
        break;
      case "number":
        result = value !== 0 && !isNaN(value);
        break;
      case "string":
        result = value !== "";
        break;
      case "object":
        result = false;
        if (value !== null) {
          result = true;
          if (value instanceof Array) result = value.length > 0;
        }
        break;
      default:
        result = false;
    }
    return result;
  }

  /*  coerce value to particular type  */
  static coerce(value, type) {
    /* eslint valid-typeof: off */
    if (typeof value !== type) {
      try {
        switch (type) {
          case "boolean":
            if (typeof value === "object" && value instanceof Array) value = value.length !== 0;else if (typeof value !== "boolean") value = Boolean(value);
            break;
          case "number":
            if (typeof value === "object" && value instanceof Array) value = value.length;else if (typeof value !== "number") value = Number(value);
            break;
          case "string":
            if (typeof value !== "string") value = String(value);
            break;
          case "regexp":
            if (!(typeof value === "object" && value instanceof RegExp)) value = new RegExp(value);
            break;
        }
      } catch (e) {
        throw new Error("cannot coerce value into type " + type);
      }
    }
    return value;
  }
}
exports.default = ASTQUtil;

},{}],16:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/* global 2: false */
/* global 8: false */
/* global 0: false */
/* global 20240308:  false */

let version = {
  major: 2,
  minor: 8,
  micro: 0,
  date: 20240308
};
var _default = exports.default = version;

},{}],17:[function(require,module,exports){
"use strict";

var _cacheLru = _interopRequireDefault(require("cache-lru"));
var _astqAdapter = _interopRequireDefault(require("./astq-adapter.js"));
var _astqAdapterXmldom = _interopRequireDefault(require("./astq-adapter-xmldom.js"));
var _astqAdapterParse = _interopRequireDefault(require("./astq-adapter-parse5.js"));
var _astqAdapterMozast = _interopRequireDefault(require("./astq-adapter-mozast.js"));
var _astqAdapterGraphql = _interopRequireDefault(require("./astq-adapter-graphql.js"));
var _astqAdapterJson = _interopRequireDefault(require("./astq-adapter-json.js"));
var _astqAdapterCheerio = _interopRequireDefault(require("./astq-adapter-cheerio.js"));
var _astqAdapterUnist = _interopRequireDefault(require("./astq-adapter-unist.js"));
var _astqAdapterAsty = _interopRequireDefault(require("./astq-adapter-asty.js"));
var _astqFuncs = _interopRequireDefault(require("./astq-funcs.js"));
var _astqFuncsStd = _interopRequireDefault(require("./astq-funcs-std.js"));
var _astqQuery = _interopRequireDefault(require("./astq-query.js"));
var _astqVersion = _interopRequireDefault(require("./astq-version.js"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*  load external depdendencies  */

/*  load internal dependencies  */

/*  define the API class  */
class ASTQ {
  /*  create a new ASTq instance  */
  constructor() {
    /*  create adapter registry and pre-register standard adapters  */
    this._adapter = new _astqAdapter.default().register(_astqAdapterXmldom.default, false).register(_astqAdapterParse.default, false).register(_astqAdapterMozast.default, false).register(_astqAdapterGraphql.default, false).register(_astqAdapterJson.default, false).register(_astqAdapterCheerio.default, false).register(_astqAdapterUnist.default, false).register(_astqAdapterAsty.default, false);

    /*  create function registry and pre-register standard functions  */
    this._funcs = new _astqFuncs.default();
    for (let name in _astqFuncsStd.default) this.func(name, _astqFuncsStd.default[name]);

    /*  create LRU cache  */
    this._cache = new _cacheLru.default();
  }

  /*  return the version information  */
  version() {
    return _astqVersion.default;
  }

  /*  switch to a single custom adapter  */
  adapter(adapter, force = false) {
    if (arguments.length < 1 || arguments.length > 2) throw new Error("ASTQ#adapter: invalid number of arguments");
    this._adapter.unregister();
    if (!(typeof adapter === "object" && adapter instanceof Array)) adapter = [adapter];
    if (adapter.length > 1 && force) throw new Error("ASTQ#adapter: you can force just a single adapter to not taste the AST node");
    adapter.forEach(adapter => {
      if (typeof adapter === "string") {
        if (adapter === "mozast") adapter = _astqAdapterMozast.default;else if (adapter === "graphql") adapter = _astqAdapterGraphql.default;else if (adapter === "xmldom") adapter = _astqAdapterXmldom.default;else if (adapter === "parse5") adapter = _astqAdapterParse.default;else if (adapter === "json") adapter = _astqAdapterJson.default;else if (adapter === "cheerio") adapter = _astqAdapterCheerio.default;else if (adapter === "unist") adapter = _astqAdapterUnist.default;else if (adapter === "asty") adapter = _astqAdapterAsty.default;else throw new Error("ASTQ#adapter: unknown built-in adapter");
      }
      this._adapter.register(adapter, force);
    });
    return this;
  }

  /*  register an additional function  */
  func(name, func) {
    if (arguments.length !== 2) throw new Error("ASTQ#func: invalid number of arguments");
    this._funcs.register(name, func);
    return this;
  }

  /*  configure the LRU cache limit  */
  cache(entries) {
    if (arguments.length !== 1) throw new Error("ASTQ#cache: invalid number of arguments");
    this._cache.limit(entries);
    return this;
  }

  /*  individual step 1: compile selector DSL into a query AST  */
  compile(selector, trace) {
    if (arguments.length < 1) throw new Error("ASTQ#compile: too less arguments");
    if (arguments.length > 2) throw new Error("ASTQ#compile: too many arguments");
    if (trace === undefined) trace = false;
    let query = this._cache.get(selector);
    if (query === undefined) {
      query = new _astqQuery.default();
      query.compile(selector, trace);
      this._cache.set(selector, query);
    }
    return query;
  }

  /*  individual step 2: execute query AST onto node  */
  execute(node, query, params, trace) {
    if (arguments.length < 2) throw new Error("ASTQ#execute: too less arguments");
    if (arguments.length > 4) throw new Error("ASTQ#execute: too many arguments");
    if (params === undefined) params = {};
    if (trace === undefined) trace = false;
    let adapter = this._adapter.select(node);
    if (adapter === undefined) throw new Error("ASTQ#execute: no suitable adapter found for node");
    return query.execute(node, adapter, params, this._funcs, trace);
  }

  /*  all-in-one step: execute selector DSL onto node  */
  query(node, selector, params, trace) {
    if (arguments.length < 2) throw new Error("ASTQ#query: too less arguments");
    if (arguments.length > 4) throw new Error("ASTQ#query: too many arguments");
    if (params === undefined) params = {};
    if (trace === undefined) trace = false;
    return this.execute(node, this.compile(selector, trace), params, trace);
  }
}

/*  export the traditional way for interoperability reasons
    (as Babel would export an object with a 'default' field)  */
module.exports = ASTQ;

},{"./astq-adapter-asty.js":1,"./astq-adapter-cheerio.js":2,"./astq-adapter-graphql.js":3,"./astq-adapter-json.js":4,"./astq-adapter-mozast.js":5,"./astq-adapter-parse5.js":6,"./astq-adapter-unist.js":7,"./astq-adapter-xmldom.js":8,"./astq-adapter.js":9,"./astq-funcs-std.js":10,"./astq-funcs.js":11,"./astq-query.js":14,"./astq-version.js":16,"cache-lru":"cache-lru"}]},{},[1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17])(17)
});
