/*
**  ASTq -- Abstract Syntax Tree (AST) Query Engine
**  Copyright (c) 2014-2024 Dr. Ralf S. Engelschall <rse@engelschall.com>
**
**  Permission is hereby granted, free of charge, to any person obtaining
**  a copy of this software and associated documentation files (the
**  "Software"), to deal in the Software without restriction, including
**  without limitation the rights to use, copy, modify, merge, publish,
**  distribute, sublicense, and/or sell copies of the Software, and to
**  permit persons to whom the Software is furnished to do so, subject to
**  the following conditions:
**
**  The above copyright notice and this permission notice shall be included
**  in all copies or substantial portions of the Software.
**
**  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
**  EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
**  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
**  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
**  CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
**  TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
**  SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

(function(f){if(typeof exports==="object"&&typeof module!=="undefined"){module.exports=f()}else if(typeof define==="function"&&define.amd){define([],f)}else{var g;if(typeof window!=="undefined"){g=window}else if(typeof global!=="undefined"){g=global}else if(typeof self!=="undefined"){g=self}else{g=this}g.ASTQ = f()}})(function(){var define,module,exports;return (function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).ASTY=e()}}(function(){return function(){return function e(t,n,r){function i(u,a){if(!n[u]){if(!t[u]){var f="function"==typeof _dereq_&&_dereq_;if(!a&&f)return f(u,!0);if(o)return o(u,!0);var l=new Error("Cannot find module '"+u+"'");throw l.code="MODULE_NOT_FOUND",l}var c=n[u]={exports:{}};t[u][0].call(c.exports,function(e){return i(t[u][1][e]||e)},c,c.exports,e,t,n,r)}return n[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<r.length;u++)i(r[u]);return i}}()({1:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!=r(e)||!e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!=r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;n.default=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"init",value:function(e,t,n,i){if(arguments.length<2)throw new Error("init: invalid number of arguments");if(this.ctx=e,this.ASTy=!0,this.T=t,this.L={L:0,C:0,O:0},this.A={},this.C=[],this.P=null,"object"===r(n))for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&this.set(o,n[o]);return"object"===r(i)&&i instanceof Array&&this.add(i),this}},{key:"create",value:function(e,t,n){return this.ctx.create(e,t,n)}},{key:"type",value:function(e){if(0===arguments.length)return this.T;if(1===arguments.length)return this.T=e,this;throw new Error("type: invalid number of arguments")}},{key:"pos",value:function(e,t,n){if(0===arguments.length)return{line:this.L.L,column:this.L.C,offset:this.L.O};if(arguments.length<=3)return this.L.L=e||0,this.L.C=t||0,this.L.O=n||0,this;throw new Error("pos: invalid number of arguments")}},{key:"set",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(1===n.length&&"object"===r(n[0]))Object.keys(n[0]).forEach(function(t){void 0!==n[0][t]?e.A[t]=n[0][t]:delete e.A[t]});else{if(2!==n.length)throw new Error("set: invalid number of arguments");void 0!==n[1]?this.A[n[0]]=n[1]:delete this.A[n[0]]}return this}},{key:"unset",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(1===n.length&&"object"===r(n[0])&&n[0]instanceof Array)n[0].forEach(function(t){delete e.A[t]});else{if(1!==n.length)throw new Error("unset: invalid number of arguments");delete this.A[n[0]]}return this}},{key:"get",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(1!==n.length)throw new Error("get: invalid number of arguments");if("object"===r(n[0])&&n[0]instanceof Array)return n[0].map(function(t){if("string"!=typeof t)throw new Error("get: invalid key argument");return e.A[t]});var o=n[0];if("string"!=typeof o)throw new Error("get: invalid key argument");return this.A[o]}},{key:"attrs",value:function(){return Object.keys(this.A)}},{key:"nth",value:function(){if(null===this.P)return 1;var e=this.P.C.indexOf(this);if(e<0)throw new Error("nth: internal error -- node not in childs of its parent");return e}},{key:"ins",value:function(e){for(var t=this,n=arguments.length,i=new Array(n>1?n-1:0),o=1;o<n;o++)i[o-1]=arguments[o];if(0===i.length)throw new Error("ins: invalid number of arguments");if(e<0&&(e=this.C.length+1-e),!(e>=0&&e<=this.C.length))throw new Error("ins: invalid position");var u=function(n){if(!t.ctx.isA(n))throw new Error("ins: invalid AST node argument");t.C.splice(e++,0,n),n.P=t};return i.forEach(function(e){"object"===r(e)&&e instanceof Array?e.forEach(function(e){u(e)}):null!==e&&u(e)}),this}},{key:"add",value:function(){for(var e=this,t=arguments.length,n=new Array(t),i=0;i<t;i++)n[i]=arguments[i];if(0===n.length)throw new Error("add: invalid number of arguments");var o=function(t){if(!e.ctx.isA(t))throw new Error("add: invalid AST node argument");e.C.push(t),t.P=e};return n.forEach(function(e){"object"===r(e)&&e instanceof Array?e.forEach(function(e){o(e)}):null!==e&&o(e)}),this}},{key:"del",value:function(){for(var e=this,t=arguments.length,n=new Array(t),r=0;r<t;r++)n[r]=arguments[r];if(0===n.length)throw new Error("del: invalid number of arguments");return n.forEach(function(t){if(!e.ctx.isA(t))throw new Error("del: invalid AST node argument");for(var n=!1,r=0;r<e.C.length;r++)if(e.C[r]===t){e.C.splice(r,1),t.P=null,n=!0;break}if(!n)throw new Error("del: AST node not found in childs")}),this}},{key:"childs",value:function(){if(arguments.length>2)throw new Error("childs: invalid number of arguments");if(2===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0])&&"number"==typeof(arguments.length<=1?void 0:arguments[1]))return this.C.slice(arguments.length<=0?void 0:arguments[0],arguments.length<=1?void 0:arguments[1]);if(1===arguments.length&&"number"==typeof(arguments.length<=0?void 0:arguments[0]))return this.C.slice(arguments.length<=0?void 0:arguments[0]);if(0===arguments.length)return this.C;throw new Error("childs: invalid type of arguments")}},{key:"child",value:function(e){if("number"!=typeof e)throw new Error("child: invalid argument");return e<this.C.length?this.C[e]:null}},{key:"parent",value:function(){return this.P}},{key:"serialize",value:function(){return this.ctx.__serialize(this)}}]),e}()},{}],2:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!=r(e)||!e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!=r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;var u={mid:{unicode:String.fromCharCode(9500),ascii:"+"},last:{unicode:String.fromCharCode(9492),ascii:"+"},down:{unicode:String.fromCharCode(9474),ascii:"|"},left:{unicode:String.fromCharCode(9472),ascii:"-"}};n.default=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"dump",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1/0,t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:function(e,t){return t},n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2],i="",o=this;return this.walk(function(a,f){if(!(f>e)){if(f>0){var l=function(e){var t=0,n=0;return null!==e.P&&(t=e.P.C.indexOf(e),n=e.P.C.length-1),{nth:t,max:n}},c=l(a),s=c.nth,y=c.max,h=" ";h=n?"".concat(u.left.unicode).concat(u.left.unicode).concat(h):"".concat(u.left.ascii).concat(u.left.ascii).concat(h),h=s<y?"".concat(n?u.mid.unicode:u.mid.ascii).concat(h):"".concat(n?u.last.unicode:u.last.ascii).concat(h);for(var d=a.P;null!==d&&d!==o;d=d.P)if(null!==d.P){var v=l(d);h=v.nth<v.max?"".concat(n?u.down.unicode:u.down.ascii,"   ").concat(h):"    ".concat(h)}i+=t("tree",h)}i+=t("type",a.T)+" ";var p=Object.keys(a.A).filter(function(e){return!e.match(/^__/)});if(p.length>0){i+=t("parenthesis","(");var b=!0;p.forEach(function(e){b?b=!1:i+=t("comma",",")+" ",i+=t("key",e)+t("colon",":")+" ";var n=a.A[e];switch(r(n)){case"boolean":case"number":i+=t("value",n.toString());break;case"string":var o=function(e){return e.charCodeAt(0).toString(16).toUpperCase()};i+=t("value",'"'+n.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+o(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+o(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+o(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+o(e)})+'"');break;case"object":n instanceof RegExp?i+=t("value","/"+n.source+"/"):i+=t("value",JSON.stringify(n));break;default:i+=t("value",JSON.stringify(n))}}),i+=t("parenthesis",")")+" "}i+=t("position",t("bracket","[")+t("line",a.L.L)+t("slash",",")+t("column",a.L.C)+t("bracket","]")),i+="\n"}},"downward"),i}}]),e}()},{}],3:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!=r(e)||!e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!=r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;n.default=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"merge",value:function(e){var t=this,n=arguments.length>1&&void 0!==arguments[1]&&arguments[1],r=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};if(null===e)return this;if(!this.ctx.isA(e))throw new Error("merge: invalid AST node argument");if(n){var i=e.pos();this.pos(i.line,i.column,i.offset)}e.attrs().forEach(function(n){var i=void 0!==r[n]?r[n]:n;null!==i&&t.set(i,e.get(n))}),e.childs().forEach(function(n){e.del(n),t.add(n)});var o=e.parent();return null!==o&&o.del(e),this}}]),e}()},{}],4:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!=r(e)||!e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!=r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;n.default=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,null,[{key:"serialize",value:function(e,t){if(!e.isA(t))throw new Error("serialize: not an ASTy node");return JSON.stringify({ASTy:function e(t){var n={T:t.T,L:{L:t.L.L,C:t.L.C,O:t.L.O}},i=Object.keys(t.A);return i.length>0&&(n.A={},i.forEach(function(e){var i=t.A[e];switch(r(i)){case"boolean":case"number":case"string":n.A[e]=i;break;default:n.A[e]=JSON.parse(JSON.stringify(i))}})),t.C.length>0&&(n.C=t.C.map(function(t){return e(t)})),n}(t)})}},{key:"unserialize",value:function(e,t){var n=JSON.parse(t);if("object"!==r(n)||"object"!==r(n.ASTy))throw new Error("unserialize: not an ASTy JSON export");return function t(n){var i=e.create(n.T);return i.pos(n.L.L,n.L.C,n.L.O),"object"===r(n.A)&&Object.keys(n.A).forEach(function(e){var t=n.A[e];switch(r(t)){case"boolean":case"number":case"string":i.set(e,t);break;default:i.set(e,JSON.parse(JSON.stringify(t)))}}),"object"===r(n.C)&&n.C instanceof Array&&i.add(n.C.map(function(e){return t(e)})),i}(n.ASTy)}}]),e}()},{}],5:[function(e,t,n){"use strict";Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;n.default={major:1,minor:8,micro:20,date:20240308}},{}],6:[function(e,t,n){"use strict";function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function i(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,o(r.key),r)}}function o(e){var t=function(e,t){if("object"!=r(e)||!e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var i=n.call(e,t||"default");if("object"!=r(i))return i;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==r(t)?t:String(t)}Object.defineProperty(n,"__esModule",{value:!0}),n.default=void 0;n.default=function(){function e(){!function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e)}return function(e,t,n){t&&i(e.prototype,t),n&&i(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"walk",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"downward";return function n(r,i,o){"downward"!==t&&"both"!==t||e(r,i,o,"downward"),r.C.forEach(function(e){n(e,i+1,r)}),"upward"!==t&&"both"!==t||e(r,i,o,"upward")}(this,0,null),this}}]),e}()},{}],7:[function(e,t,n){"use strict";var r=l(e("./asty-base.js")),i=l(e("./asty-merge.js")),o=l(e("./asty-walk.js")),u=l(e("./asty-dump.js")),a=l(e("./asty-serialize.js")),f=l(e("./asty-version.js"));function l(e){return e&&e.__esModule?e:{default:e}}function c(e){return(c="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function s(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function y(e,t){for(var n=0;n<t.length;n++){var r=t[n];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,d(r.key),r)}}function h(e,t,n){return t&&y(e.prototype,t),n&&y(e,n),Object.defineProperty(e,"prototype",{writable:!1}),e}function d(e){var t=function(e,t){if("object"!=c(e)||!e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var r=n.call(e,t||"default");if("object"!=c(r))return r;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==c(t)?t:String(t)}var v=function(){function e(){var t=this;return s(this,e),this.ASTYNode=h(function e(){s(this,e)}),[[r.default,"init","create","type","pos","set","unset","get","attrs","nth","ins","add","del","childs","child","parent","serialize"],[i.default,"merge"],[o.default,"walk"],[u.default,"dump"]].forEach(function(e){var n=e[0].prototype;e.slice(1).forEach(function(e){t.ASTYNode.prototype[e]=n[e]})}),this}return h(e,[{key:"version",value:function(){return f.default}},{key:"extend",value:function(e){for(var t in e)Object.prototype.hasOwnProperty.call(e,t)&&(this.ASTYNode.prototype[t]=e[t]);return this}},{key:"create",value:function(e,t,n){return(new this.ASTYNode).init(this,e,t,n)}},{key:"isA",value:function(e){return"object"===c(e)&&e instanceof this.ASTYNode&&"boolean"==typeof e.ASTy&&!0===e.ASTy}},{key:"__serialize",value:function(t){return e.serialize(t)}}],[{key:"serialize",value:function(e){return a.default.serialize(e.ctx,e)}},{key:"unserialize",value:function(e){return a.default.unserialize(new this,e)}}]),e}();t.exports=v},{"./asty-base.js":1,"./asty-dump.js":2,"./asty-merge.js":3,"./asty-serialize.js":4,"./asty-version.js":5,"./asty-walk.js":6}]},{},[1,2,3,4,5,6,7])(7)});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],2:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e){if("object"==typeof exports&&"undefined"!=typeof module)module.exports=e();else if("function"==typeof define&&define.amd)define([],e);else{("undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:this).CacheLRU=e()}}(function(){return function(){return function e(t,n,i){function r(u,s){if(!n[u]){if(!t[u]){var l="function"==typeof _dereq_&&_dereq_;if(!s&&l)return l(u,!0);if(o)return o(u,!0);var a=new Error("Cannot find module '"+u+"'");throw a.code="MODULE_NOT_FOUND",a}var f=n[u]={exports:{}};t[u][0].call(f.exports,function(e){return r(t[u][1][e]||e)},f,f.exports,e,t,n,i)}return n[u].exports}for(var o="function"==typeof _dereq_&&_dereq_,u=0;u<i.length;u++)r(i[u]);return r}}()({1:[function(e,t,n){"use strict";function i(e){return(i="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function r(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,o(i.key),i)}}function o(e){var t=function(e,t){if("object"!=i(e)||!e)return e;var n=e[Symbol.toPrimitive];if(void 0!==n){var r=n.call(e,t||"default");if("object"!=i(r))return r;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}(e,"string");return"symbol"==i(t)?t:String(t)}var u=function(){function e(){return function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}(this,e),this._index={},this._LRU={newer:null},this._MRU={older:null},this._LRU.newer=this._MRU,this._MRU.older=this._LRU,this._cur=0,this._max=1/0,this._dispose=function(){},this}return function(e,t,n){t&&r(e.prototype,t),n&&r(e,n),Object.defineProperty(e,"prototype",{writable:!1})}(e,[{key:"limit",value:function(e){var t=this._max;return arguments.length>0&&(this._max=e,this._purge()),t}},{key:"dispose",value:function(e){return this._dispose=e,this}},{key:"length",value:function(){return this._cur}},{key:"keys",value:function(){return this.each(function(e,t){this.push(t)},[])}},{key:"values",value:function(){return this.each(function(e){this.push(e)},[])}},{key:"each",value:function(e,t){arguments<2&&(t=this);for(var n=0,i=this._MRU.older;i!==this._LRU;)e.call(t,i.val,i.key,n++),i=i.older;return t}},{key:"has",value:function(e){var t=this._index[e];return void 0!==t&&t.expires>=Date.now()}},{key:"peek",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return t.val;this.del(t.key)}}},{key:"touch",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("touch: no such item");return this._promote(t),this}},{key:"get",value:function(e){var t=this._index[e];if(void 0!==t){if(!(t.expires<Date.now()))return this._promote(t),t.val;this.del(t.key)}}},{key:"set",value:function(e,t,n){arguments.length<3&&(n=1/0),n+=Date.now();var i=this._index[e];if(void 0===i)i={older:null,newer:null,key:e,val:t,expires:n},this._index[e]=i,this._attach(i),this._cur++,this._purge();else{var r=i.val;i.val=t,this._promote(i),this._dispose.call(void 0,i.key,r,"set")}return this}},{key:"del",value:function(e){var t=this._index[e];if(void 0===t)throw new Error("del: no such item");return delete this._index[e],this._detach(t),this._cur--,this._dispose.call(void 0,e,t.val,"del"),this}},{key:"clear",value:function(){for(;this._cur>0;)this.del(this._LRU.newer.key);return this}},{key:"_purge",value:function(){for(;this._cur>this._max;)this.del(this._LRU.newer.key)}},{key:"_promote",value:function(e){this._detach(e),this._attach(e)}},{key:"_detach",value:function(e){e.older.newer=e.newer,e.newer.older=e.older,e.older=null,e.newer=null}},{key:"_attach",value:function(e){e.older=this._MRU.older,e.newer=this._MRU,e.newer.older=e,e.older.newer=e}}]),e}();t.exports=u},{}]},{},[1])(1)});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],3:[function(_dereq_,module,exports){
(function (global){(function (){
!function(e,n,r){"object"==typeof module&&"object"==typeof module.exports?module.exports=r():"function"==typeof define&&void 0!==define.amd?define("PEGUtil",function(){return r()}):e.PEGUtil=r()}("undefined"!=typeof global?global:"undefined"!=typeof window?window:this,0,function(){var e={makeAST:function(e,n){return function(){return n.util.__makeAST.call(null,e().start.line,e().start.column,e().start.offset,arguments)}},makeUnroll:function(e,n){return function(r,t,o){if("object"!=typeof t||!(t instanceof Array))throw new n.util.__SyntaxError("unroll: invalid list argument for unrolling",typeof t,"Array",e());if(void 0!==o){"number"==typeof o&&(o=[o]);var l=[];null!==r&&l.push(r);for(var a=0;a<t.length;a++)for(var i=0;i<o.length;i++)l.push(t[a][o[i]]);return l}return null!==r&&t.unshift(r),t}}},n=function(e,n){var r=e.length,t=n-20;t<0&&(t=0);var o=n+20;o>r&&(o=r);var l=function(e){return e.charCodeAt(0).toString(16).toUpperCase()},a=function(e,n,r){return e.substr(n,r).replace(/\\/g,"\\\\").replace(/\x08/g,"\\b").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\f/g,"\\f").replace(/\r/g,"\\r").replace(/[\x00-\x07\x0B\x0E\x0F]/g,function(e){return"\\x0"+l(e)}).replace(/[\x10-\x1F\x80-\xFF]/g,function(e){return"\\x"+l(e)}).replace(/[\u0100-\u0FFF]/g,function(e){return"\\u0"+l(e)}).replace(/[\u1000-\uFFFF]/g,function(e){return"\\u"+l(e)})};return{prolog:a(e,t,n-t),token:a(e,n,1),epilog:a(e,n+1,o-(n+1))}};return e.parse=function(r,t,o){if("object"!=typeof r)throw new Error("invalid parser object (not an object)");if("function"!=typeof r.parse)throw new Error('invalid parser object (no "parse" function)');if("string"!=typeof t)throw new Error("invalid input text (not a string)");if(void 0!==o&&"object"!=typeof o)throw new Error("invalid options (not an object)");void 0===o&&(o={});var l={ast:null,error:null};try{var a;a="function"==typeof o.makeAST?o.makeAST:function(e,n){return{line:e().start.line,column:e().start.column,offset:e().start.offset,args:n}},o.util={makeUnroll:e.makeUnroll,makeAST:e.makeAST,__makeAST:a,__SyntaxError:r.SyntaxError},l.ast=r.parse(t,o),l.error=null}catch(e){if(l.ast=null,e instanceof r.SyntaxError){var i=function(e,n){return void 0!==e?e:n};l.error={line:i(e.location.start.line,0),column:i(e.location.start.column,0),message:e.message,found:i(e.found,""),expected:i(e.expected,""),location:n(t,i(e.location.start.offset,0))}}else l.error={line:0,column:0,message:e.message,found:"",expected:"",location:n("",0)}}return l},e.errorMessage=function(e,n){for(var r=e.location,t="line "+e.line+" (column "+e.column+"): ",o="",l=0;l<t.length+r.prolog.length;l++)o+="-";return t+r.prolog+r.token+r.epilog+"\n"+o+"^\n"+e.message+(n?"":"\n")},e});
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],4:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterASTY=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"boolean"==typeof e.ASTy}},{key:"getParentNode",value:function(e){return e.parent()}},{key:"getChildNodes",value:function(e){return e.childs()}},{key:"getNodeType",value:function(e){return e.type()}},{key:"getNodeAttrNames",value:function(e){return e.attrs()}},{key:"getNodeAttrValue",value:function(e,t){return e.get(t)}}]),e}();
},{}],5:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var n=t[o];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,_toPropertyKey(n.key),n)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var o=e[Symbol.toPrimitive];if(void 0!==o){var n=o.call(e,t||"default");if("object"!=_typeof(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterCheerio=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return!("object"!==_typeof(e)||null===e||("object"===("undefined"==typeof Element?"undefined":_typeof(Element))&&e instanceof Element||"string"!=typeof e.tagName||""===e.tagName)&&("object"===("undefined"==typeof Document?"undefined":_typeof(Document))&&e instanceof Document||"string"!=typeof e.type||"root"!==e.type))}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&e.childNodes instanceof Array?e.childNodes:[]}},{key:"getNodeType",value:function(e){return e.tagName||"#".concat(e.type||"unknown")}},{key:"getNodeAttrNames",value:function(e){var t=["value"];return"object"===_typeof(e.attribs)&&(t=t.concat(Object.keys(e.attribs))),t}},{key:"getNodeAttrValue",value:function(e,t){var o;return"value"===t?o=e.nodeValue:"object"===_typeof(e.attribs)&&(o=e.attribs[t]),o}}]),e}();
},{}],6:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterGraphQL=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.kind&&""!==e.kind}},{key:"getParentNode",value:function(e,t){throw new Error("GraphQL AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,o=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&r.taste(e[t])?o.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&o.push(e)})};if("*"===t)for(var i in e)n(e,i);else void 0!==e[t]&&n(e,t);return o}},{key:"getNodeType",value:function(e){return e.kind}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"object"!==_typeof(e[r])&&"kind"!==r&&"loc"!==r&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])&&"kind"!==t&&"loc"!==t?e[t]:void 0}}]),e}();
},{}],7:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterJSON=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e}},{key:"getParentNode",value:function(e,t){throw new Error("JSON does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,o=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&r.taste(e[t])?o.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&o.push(e)})};if("*"===t)for(var i in e)n(e,i);else void 0!==e[t]&&n(e,t);return o}},{key:"getNodeType",value:function(e){return null===e?"Null":e instanceof Boolean?"Boolean":e instanceof Number?"Number":e instanceof String?"String":"object"===_typeof(e)?e instanceof Array?"Array":"function"==typeof e.constructor&&"string"==typeof e.constructor.name?e.constructor.name:"Object":"Unknown"}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"object"!==_typeof(e[r])&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])?e[t]:void 0}}]),e}();
},{}],8:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterMozAST=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e,t){if("*"!==t&&"parent"!==t)throw new Error('no such axis named "'+t+'" for walking to parent nodes');if(void 0!==e.parent)return e.parent;throw new Error("Your Mozilla SpiderMonkey AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e,t){var r=this,o=[],n=function(e,t){Object.prototype.hasOwnProperty.call(e,t)&&r.taste(e[t])?o.push(e[t]):Object.prototype.hasOwnProperty.call(e,t)&&"object"===_typeof(e[t])&&e[t]instanceof Array&&e[t].forEach(function(e){r.taste(e)&&o.push(e)})};if("*"===t)for(var i in e)n(e,i);else void 0!==e[t]&&n(e,t);return o}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"object"!==_typeof(e[r])&&"type"!==r&&"loc"!==r&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"object"!==_typeof(e[t])&&"type"!==t&&"loc"!==t?e[t]:void 0}}]),e}();
},{}],9:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterParse5=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&!("object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&e instanceof Node)&&"string"==typeof e.nodeName&&""!==e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&e.childNodes instanceof Array?e.childNodes:[]}},{key:"getNodeType",value:function(e){return e.nodeName}},{key:"getNodeAttrNames",value:function(e){var t=["value"];return"object"===_typeof(e.attrs)&&e.attrs instanceof Array&&(t=t.concat(e.attrs.map(function(e){return e.name}))),t}},{key:"getNodeAttrValue",value:function(e,t){var r;if("value"===t)r=e.value;else if("object"===_typeof(e.attrs)&&e.attrs instanceof Array){var o=e.attrs.filter(function(e){return e.name===t}).map(function(e){return e.value});1===o.length&&(r=o[0])}return r}}]),e}();
},{}],10:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterUniST=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===_typeof(e)&&null!==e&&"string"==typeof e.type&&""!==e.type}},{key:"getParentNode",value:function(e){if("object"===_typeof(e.parent)&&null!==e.parent)return e.parent;throw new Error("Your UniST AST does not support parent node traversal")}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.children)&&e.children instanceof Array?e.children:[]}},{key:"getNodeType",value:function(e){return e.type}},{key:"getNodeAttrNames",value:function(e){var t=[];for(var r in e)Object.prototype.hasOwnProperty.call(e,r)&&"type"!==r&&"data"!==r&&"position"!==r&&"children"!==r&&"object"!==_typeof(e[r])&&t.push(r);return t}},{key:"getNodeAttrValue",value:function(e,t){return Object.prototype.hasOwnProperty.call(e,t)&&"type"!==t&&"data"!==t&&"position"!==t&&"children"!==t&&"object"!==_typeof(e[t])?e[t]:void 0}}]),e}();
},{}],11:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var o=0;o<t.length;o++){var r=t[o];r.enumerable=r.enumerable||!1,r.configurable=!0,"value"in r&&(r.writable=!0),Object.defineProperty(e,_toPropertyKey(r.key),r)}}function _createClass(e,t,o){return t&&_defineProperties(e.prototype,t),o&&_defineProperties(e,o),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var o=e[Symbol.toPrimitive];if(void 0!==o){var r=o.call(e,t||"default");if("object"!=_typeof(r))return r;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapterXMLDOM=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"taste",value:function(e){return"object"===("undefined"==typeof Node?"undefined":_typeof(Node))&&null!==e&&e instanceof Node&&"object"===_typeof(e)&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName}},{key:"getParentNode",value:function(e){return e.parentNode}},{key:"getChildNodes",value:function(e){return"object"===_typeof(e.childNodes)&&null!==e.childNodes&&e.hasChildNodes()?Array.prototype.slice.call(e.childNodes,0):[]}},{key:"getNodeType",value:function(e){return"string"==typeof e.nodeName?e.nodeName:"unknown"}},{key:"getNodeAttrNames",value:function(e){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?Array.prototype.slice.call(e.attributes,0).map(function(e){return e.nodeName}):[]}},{key:"getNodeAttrValue",value:function(e,t){return"object"===_typeof(e.attributes)&&null!==e.attributes&&e.hasAttributes()?e.getAttribute(t):void 0}}]),e}();
},{}],12:[function(_dereq_,module,exports){
"use strict";function _typeof(t){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function _defineProperties(t,e){for(var r=0;r<e.length;r++){var o=e[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(t,_toPropertyKey(o.key),o)}}function _createClass(t,e,r){return e&&_defineProperties(t.prototype,e),r&&_defineProperties(t,r),Object.defineProperty(t,"prototype",{writable:!1}),t}function _toPropertyKey(t){var e=_toPrimitive(t,"string");return"symbol"==_typeof(e)?e:String(e)}function _toPrimitive(t,e){if("object"!=_typeof(t)||!t)return t;var r=t[Symbol.toPrimitive];if(void 0!==r){var o=r.call(t,e||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQAdapter=exports.default=function(){function t(){return _classCallCheck(this,t),this._adapters=[],this}return _createClass(t,[{key:"register",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];return this._adapters.unshift({adapter:t,force:e}),this}},{key:"unregister",value:function(t){if(void 0===t)this._adapters=[];else{for(var e=[],r=0;r<this._adapters.length;r++)this._adapters[r].adapter!==t&&e.push(this._adapters[r]);this._adapters=e}return this}},{key:"select",value:function(t){for(var e=0;e<this._adapters.length;e++)if(this._adapters[e].force||this._adapters[e].adapter.taste(t))return this._adapters[e].adapter}}]),t}();
},{}],13:[function(_dereq_,module,exports){
"use strict";function _typeof(t){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _pos=function(t,n){var e=t.getParentNode(n,"*");if(null===e)return 1;for(var r=t.getChildNodes(e,"*"),o=0;o<r.length;o++)if(r[o]===n)return o+1;throw new Error("cannot find myself")},parents=function(t,n){for(var e=[];null!==(n=t.getParentNode(n,"*"));)e.push(n);return e},stdfuncs={type:function(t,n){return t.getNodeType(n)},attrs:function(t,n,e){return void 0===e&&(e=" "),e+t.getNodeAttrNames(n).join(e)+e},depth:function(t,n){for(var e=1,r=n;null!==(r=t.getParentNode(r,"*"));)e++;return e},pos:function(t,n){return _pos(t,n)},nth:function(t,n,e){e=parseInt(e,10);var r=t.getParentNode(n,"*");if(null!==r){var o=t.getChildNodes(r,"*");e<0&&(e=o.length-(e+1));for(var u=0;u<o.length;u++)if(o[u]===n)return u+1===e;return!1}return 1===e},first:function(t,n){return stdfuncs.nth(t,n,1)},last:function(t,n){return stdfuncs.nth(t,n,-1)},count:function(t,n,e){return"object"===_typeof(e)&&e instanceof Array?e.length:"object"===_typeof(e)?Object.keys(e).length:"string"==typeof e?e.length:String(e).length},below:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "below" (node expected)');for(var r=n;null!==(r=t.getParentNode(r,"*"));)if(r===e)return!0;return!1},follows:function(t,n,e){if(!t.taste(e))throw new Error('invalid argument to function "follows" (node expected)');if(n===e)return!1;var r,o=[n].concat(parents(t,n)).reverse(),u=[e].concat(parents(t,e)).reverse(),f=Math.min(o.length,u.length);for(r=0;r<f&&o[r]===u[r];r++);if(0===r)throw new Error("internal error: root nodes have to be same same");return r===f?u.length<o.length:_pos(t,o[r])>_pos(t,u[r])},in:function(t,n,e){if(!("object"===_typeof(e)&&e instanceof Array))throw new Error('invalid argument to function "in" (array expected)');for(var r=0;r<e.length;r++)if(e[r]===n)return!0;return!1},substr:function(t,n,e,r,o){return String(e).substr(r,o)},index:function(t,n,e,r,o){return String(e).indexOf(r,o)},trim:function(t,n,e){return String(e).trim()},lc:function(t,n,e){return String(e).toLowerCase()},uc:function(t,n,e){return String(e).toUpperCase()}},_default=exports.default=stdfuncs;
},{}],14:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQFuncs=exports.default=function(){function e(){return _classCallCheck(this,e),this._funcs={},this}return _createClass(e,[{key:"register",value:function(e,t){this._funcs[e]=t}},{key:"run",value:function(e,t){var r=this._funcs[e];if("function"!=typeof r)throw new Error('invalid function "'+e+'"');return r.apply(null,t)}}]),e}();
},{}],15:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _astqUtil=_interopRequireDefault(_dereq_("./astq-util.js")),_astqQueryTrace=_interopRequireDefault(_dereq_("./astq-query-trace.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,_toPropertyKey(a.key),a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var a=r.call(e,t||"default");if("object"!=_typeof(a))return a;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}function _callSuper(e,t,r){return t=_getPrototypeOf(t),_possibleConstructorReturn(e,_isNativeReflectConstruct()?Reflect.construct(t,r||[],_getPrototypeOf(e).constructor):t.apply(e,r))}function _possibleConstructorReturn(e,t){if(t&&("object"===_typeof(t)||"function"==typeof t))return t;if(void 0!==t)throw new TypeError("Derived constructors may only return object or undefined");return _assertThisInitialized(e)}function _assertThisInitialized(e){if(void 0===e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return e}function _isNativeReflectConstruct(){try{var e=!Boolean.prototype.valueOf.call(Reflect.construct(Boolean,[],function(){}))}catch(e){}return(_isNativeReflectConstruct=function(){return!!e})()}function _getPrototypeOf(e){return(_getPrototypeOf=Object.setPrototypeOf?Object.getPrototypeOf.bind():function(e){return e.__proto__||Object.getPrototypeOf(e)})(e)}function _inherits(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function");e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,writable:!0,configurable:!0}}),Object.defineProperty(e,"prototype",{writable:!1}),t&&_setPrototypeOf(e,t)}function _setPrototypeOf(e,t){return(_setPrototypeOf=Object.setPrototypeOf?Object.setPrototypeOf.bind():function(e,t){return e.__proto__=t,e})(e,t)}var ASTQQueryExec=exports.default=function(e){function t(e,r,a,i){var n;return _classCallCheck(this,t),(n=_callSuper(this,t)).adapter=e,n.params=r,n.funcs=a,n.trace=i,n}return _inherits(t,_astqQueryTrace["default"]),_createClass(t,[{key:"execQuery",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[];return e.childs().forEach(function(e){a=a.concat(r.execPath(e,t))}),this.traceEnd(e,t,a),a}},{key:"execPath",value:function(e,t){var r=this;this.traceBegin(e,t);var a=[t],i=[],n=!1;return e.childs().forEach(function(e){var t=[];a.forEach(function(a){t=t.concat(r.execStep(e,a))}),a=t,e.get("isResult")&&(n=!0,i=i.concat(a))}),this.traceEnd(e,t,a),n?i:a}},{key:"execStep",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.childs(),i=null,n=null,c=null,s=0;if(s<a.length&&"Axis"===a[s].type()&&(i=a[s++]),s<a.length&&"Match"===a[s].type()&&(n=a[s++]),s<a.length&&"Filter"===a[s].type()&&(c=a[s++]),null===n)throw new Error("no matching part in query step");var l=[],o=n.get("id"),u=function(e){var t=r.adapter.getNodeType(e);if("*"===o||o===t){var a=!0;null!==c&&(r.execFilter(c,e)||(a=!1)),a&&l.push(e)}};if(null!==i){var f=i.get("op"),h=i.get("type");if("/"===f)this.adapter.getChildNodes(t,h).forEach(function(e){return u(e)});else if("//"===f){this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){u(t),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}else if("./"===f)u(t),this.adapter.getChildNodes(t,h).forEach(function(e){return u(e)});else if(".//"===f){u(t);this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){u(t),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}else if("-/"===f){var d=this.adapter.getParentNode(t,"*");if(null!==d){for(var p=this.adapter.getChildNodes(d,h),x=null,y=0;y<p.length&&p[y]!==t;y++)x=p[y];null!==x&&u(x)}}else if("-//"===f){var g=this.adapter.getParentNode(t,"*");if(null!==g){for(var v=this.adapter.getChildNodes(g,h),E=0;E<v.length&&v[E]!==t;E++);for(E--;E>=0;E--)u(v[E])}}else if("+/"===f){var b=this.adapter.getParentNode(t,"*");if(null!==b){var _,m=this.adapter.getChildNodes(b,h);for(_=0;_<m.length&&m[_]!==t;_++);_<m.length&&u(m[++_])}}else if("+//"===f){var k=this.adapter.getParentNode(t,"*");if(null!==k){var q,P=this.adapter.getChildNodes(k,h);for(q=0;q<P.length&&P[q]!==t;q++);if(q<P.length)for(q++;q<P.length;q++)u(P[q])}}else if("~/"===f){var U=this.adapter.getParentNode(t,"*");if(null!==U){var C,N=this.adapter.getChildNodes(U,h);for(C=0;C<N.length&&N[C]!==t;C++);C>0&&u(N[C-1]),C<N.length-1&&u(N[C+1])}}else if("~//"===f){var w=this.adapter.getParentNode(t,"*");if(null!==w)for(var B=this.adapter.getChildNodes(w,h),O=0;O<B.length;O++)B[O]!==t&&u(B[O])}else if("../"===f){var R=this.adapter.getParentNode(t,h);null!==R&&u(R)}else if("..//"===f)for(var S=t;;){var j=this.adapter.getParentNode(S,h);if(null===j)break;u(j),S=j}else if("<//"===f){for(var L={sentinel:t,take:!0};;){var T=this.adapter.getParentNode(t,"*");if(null===T)break;t=T}t!==L.sentinel&&(u(t),this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){t===L.sentinel&&(L.take=!1),L.take&&u(t),L.take&&r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})),l=l.reverse()}else if(">//"===f){for(var A={sentinel:t,take:!1};;){var F=this.adapter.getParentNode(t,"*");if(null===F)break;t=F}this.adapter.getChildNodes(t,h).forEach(function(e){return function e(t){A.take&&u(t),t===A.sentinel&&(A.take=!0),r.adapter.getChildNodes(t,h).forEach(function(t){return e(t)})}(e)})}}else u(t);return this.traceEnd(e,t,l),l}},{key:"execFilter",value:function(e,t){this.traceBegin(e,t);var r=e.childs()[0],a=this.execExpr(r,t);return a=_astqUtil.default.truthy(a),this.traceEnd(e,t,a),a}},{key:"execExpr",value:function(e,t){switch(e.type()){case"ConditionalBinary":return this.execExprConditionalBinary(e,t);case"ConditionalTernary":return this.execExprConditionalTernary(e,t);case"Logical":return this.execExprLogical(e,t);case"Bitwise":return this.execExprBitwise(e,t);case"Relational":return this.execExprRelational(e,t);case"Arithmetical":return this.execExprArithmetical(e,t);case"Unary":return this.execExprUnary(e,t);case"FuncCall":return this.execExprFuncCall(e,t);case"Attribute":return this.execExprAttribute(e,t);case"Param":return this.execExprParam(e,t);case"LiteralString":return this.execExprLiteralString(e,t);case"LiteralRegExp":return this.execExprLiteralRegExp(e,t);case"LiteralNumber":return this.execExprLiteralNumber(e,t);case"LiteralValue":return this.execExprLiteralValue(e,t);case"Path":return this.execExprPath(e,t)}}},{key:"execExprConditionalBinary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return _astqUtil.default.truthy(r)||(r=this.execExpr(e.childs()[1],t)),this.traceEnd(e,t,r),r}},{key:"execExprConditionalTernary",value:function(e,t){this.traceBegin(e,t);var r=this.execExpr(e.childs()[0],t);return r=_astqUtil.default.truthy(r)?this.execExpr(e.childs()[1],t):this.execExpr(e.childs()[2],t),this.traceEnd(e,t,r),r}},{key:"execExprLogical",value:function(e,t){this.traceBegin(e,t);var r=!1;switch(e.get("op")){case"&&":(r=_astqUtil.default.truthy(this.execExpr(e.childs()[0],t)))&&(r=r&&_astqUtil.default.truthy(this.execExpr(e.childs()[1],t)));break;case"||":(r=_astqUtil.default.truthy(this.execExpr(e.childs()[0],t)))||(r=r||_astqUtil.default.truthy(this.execExpr(e.childs()[1],t)))}return this.traceEnd(e,t,r),r}},{key:"execExprBitwise",value:function(e,t){this.traceBegin(e,t);var r,a=_astqUtil.default.coerce(this.execExpr(e.childs()[0],t),"number"),i=_astqUtil.default.coerce(this.execExpr(e.childs()[1],t),"number");switch(e.get("op")){case"&":r=a&i;break;case"|":r=a|i;break;case"<<":r=a<<i;break;case">>":r=a>>i}return this.traceEnd(e,t,r),r}},{key:"execExprRelational",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t),i=this.execExpr(e.childs()[1],t);switch(e.get("op")){case"==":r=a===i;break;case"!=":r=a!==i;break;case"<=":r=_astqUtil.default.coerce(a,"number")<=_astqUtil.default.coerce(i,"number");break;case">=":r=_astqUtil.default.coerce(a,"number")>=_astqUtil.default.coerce(i,"number");break;case"<":r=_astqUtil.default.coerce(a,"number")<_astqUtil.default.coerce(i,"number");break;case">":r=_astqUtil.default.coerce(a,"number")>_astqUtil.default.coerce(i,"number");break;case"=~":r=null!==_astqUtil.default.coerce(a,"string").match(_astqUtil.default.coerce(i,"regexp"));break;case"!~":r=null===_astqUtil.default.coerce(a,"string").match(_astqUtil.default.coerce(i,"regexp"))}return this.traceEnd(e,t,r),r}},{key:"execExprArithmetical",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t),i=this.execExpr(e.childs()[1],t);switch(e.get("op")){case"+":r="string"==typeof a?a+_astqUtil.default.coerce(i,"string"):_astqUtil.default.coerce(a,"number")+_astqUtil.default.coerce(i,"number");break;case"-":r=_astqUtil.default.coerce(a,"number")+_astqUtil.default.coerce(i,"number");break;case"*":r=_astqUtil.default.coerce(a,"number")*_astqUtil.default.coerce(i,"number");break;case"/":r=_astqUtil.default.coerce(a,"number")/_astqUtil.default.coerce(i,"number");break;case"%":r=_astqUtil.default.coerce(a,"number")%_astqUtil.default.coerce(i,"number");break;case"**":r=Math.pow(_astqUtil.default.coerce(a,"number"),_astqUtil.default.coerce(i,"number"))}return this.traceEnd(e,t,r),r}},{key:"execExprUnary",value:function(e,t){this.traceBegin(e,t);var r,a=this.execExpr(e.childs()[0],t);switch(e.get("op")){case"!":r=!_astqUtil.default.coerce(a,"boolean");break;case"~":r=~_astqUtil.default.coerce(a,"number")}return this.traceEnd(e,t,r),r}},{key:"execExprFuncCall",value:function(e,t){var r=this;this.traceBegin(e,t);var a=e.get("id"),i=[this.adapter,t];e.childs().forEach(function(e){i.push(r.execExpr(e,t))});var n=this.funcs.run(a,i);return this.traceEnd(e,t,n),n}},{key:"execExprAttribute",value:function(e,t){this.traceBegin(e,t);var r=e.get("id"),a=this.adapter.getNodeAttrValue(t,r);return this.traceEnd(e,t,a),a}},{key:"execExprParam",value:function(e,t){this.traceBegin(e,t);var r=e.get("id");if(void 0===this.params[r])throw new Error('invalid parameter "'+r+'"');var a=this.params[r];return this.traceEnd(e,t,a),a}},{key:"execExprLiteralString",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralRegExp",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralNumber",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprLiteralValue",value:function(e,t){this.traceBegin(e,t);var r=e.get("value");return this.traceEnd(e,t,r),r}},{key:"execExprPath",value:function(e,t){this.traceBegin(e,t);var r=this.execPath(e,t);return this.traceEnd(e,t,r),r}}]),t}();
},{"./astq-query-trace.js":16,"./astq-util.js":18}],16:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _astqUtil=_interopRequireDefault(_dereq_("./astq-util.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}var ASTQQueryTrace=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,[{key:"prefixOf",value:function(e,t){for(var r=0,o=e;null!==(o=o.parent());)r++;var i=_astqUtil.default.pad("",4*r);for(r=0,o=t;null!==(o=this.adapter.getParentNode(o,"*"));)r++;return{prefix1:i,prefix2:_astqUtil.default.pad("",4*r)}}},{key:"traceBegin",value:function(e,t){if(this.trace){var r=this.prefixOf(e,t),o=r.prefix1,i=r.prefix2;console.log("ASTQ: execute: | "+_astqUtil.default.pad(o+e.type()+" (",-60)+" | "+i+this.adapter.getNodeType(t))}}},{key:"traceEnd",value:function(e,t,r){var o=this;if(this.trace){var i,n=this.prefixOf(e,t),a=n.prefix1,f=n.prefix2;void 0===r?i="undefined":"object"===_typeof(r)&&r instanceof Array?(i="[",r.forEach(function(e){i+="node("+o.adapter.getNodeType(e)+"),"}),i=i.replace(/,$/,"")+"]"):i=_typeof(r)+"("+r+")",i.length>60&&(i=i.substr(0,60)+"..."),console.log("ASTQ: execute: | "+_astqUtil.default.pad(a+"): "+i,-60)+" | "+f+this.adapter.getNodeType(t))}}}]),e}();
},{"./astq-util.js":18}],17:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _asty=_interopRequireDefault(_dereq_("asty")),_pegjsUtil=_interopRequireDefault(_dereq_("pegjs-util")),_astqQueryExec=_interopRequireDefault(_dereq_("./astq-query-exec.js"));function _interopRequireDefault(t){return t&&t.__esModule?t:{default:t}}function _typeof(t){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(t){return typeof t}:function(t){return t&&"function"==typeof Symbol&&t.constructor===Symbol&&t!==Symbol.prototype?"symbol":typeof t})(t)}function _classCallCheck(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}function _defineProperties(t,e){for(var r=0;r<e.length;r++){var n=e[r];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,_toPropertyKey(n.key),n)}}function _createClass(t,e,r){return e&&_defineProperties(t.prototype,e),r&&_defineProperties(t,r),Object.defineProperty(t,"prototype",{writable:!1}),t}function _toPropertyKey(t){var e=_toPrimitive(t,"string");return"symbol"==_typeof(e)?e:String(e)}function _toPrimitive(t,e){if("object"!=_typeof(t)||!t)return t;var r=t[Symbol.toPrimitive];if(void 0!==r){var n=r.call(t,e||"default");if("object"!=_typeof(n))return n;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===e?String:Number)(t)}var ASTQQueryParse=function(){function t(e,r,n,u){var s=Error.call(this,e);return Object.setPrototypeOf&&Object.setPrototypeOf(s,t.prototype),s.expected=r,s.found=n,s.location=u,s.name="SyntaxError",s}function e(t,e,r){return r=r||" ",t.length>e?t:(e-=t.length,t+(r+=r.repeat(e)).slice(0,e))}return function(t,e){function r(){this.constructor=t}r.prototype=e.prototype,t.prototype=new r}(t,Error),t.prototype.format=function(t){var r="Error: "+this.message;if(this.location){var n,u=null;for(n=0;n<t.length;n++)if(t[n].source===this.location.source){u=t[n].text.split(/\r\n|\n|\r/g);break}var s=this.location.start,o=this.location.source&&"function"==typeof this.location.source.offset?this.location.source.offset(s):s,i=this.location.source+":"+o.line+":"+o.column;if(u){var a=this.location.end,l=e("",o.line.toString().length," "),c=u[s.line-1],f=(s.line===a.line?a.column:c.length+1)-s.column||1;r+="\n --\x3e "+i+"\n"+l+" |\n"+o.line+" | "+c+"\n"+l+" | "+e("",s.column-1," ")+e("",f,"^")}else r+="\n at "+i}return r},t.buildMessage=function(t,e){var r={literal:function(t){return'"'+u(t.text)+'"'},class:function(t){var e=t.parts.map(function(t){return Array.isArray(t)?s(t[0])+"-"+s(t[1]):s(t)});return"["+(t.inverted?"^":"")+e.join("")+"]"},any:function(){return"any character"},end:function(){return"end of input"},other:function(t){return t.description}};function n(t){return t.charCodeAt(0).toString(16).toUpperCase()}function u(t){return t.replace(/\\/g,"\\\\").replace(/"/g,'\\"').replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}function s(t){return t.replace(/\\/g,"\\\\").replace(/\]/g,"\\]").replace(/\^/g,"\\^").replace(/-/g,"\\-").replace(/\0/g,"\\0").replace(/\t/g,"\\t").replace(/\n/g,"\\n").replace(/\r/g,"\\r").replace(/[\x00-\x0F]/g,function(t){return"\\x0"+n(t)}).replace(/[\x10-\x1F\x7F-\x9F]/g,function(t){return"\\x"+n(t)})}function o(t){return r[t.type](t)}return"Expected "+function(t){var e,r,n=t.map(o);if(n.sort(),n.length>0){for(e=1,r=1;e<n.length;e++)n[e-1]!==n[e]&&(n[r]=n[e],r++);n.length=r}switch(n.length){case 1:return n[0];case 2:return n[0]+" or "+n[1];default:return n.slice(0,-1).join(", ")+", or "+n[n.length-1]}}(t)+" but "+function(t){return t?'"'+u(t)+'"':"end of input"}(e)+" found."},{StartRules:["query"],SyntaxError:t,parse:function(e,r){var n,u={},s=(r=void 0!==r?r:{}).grammarSource,o={query:zn},i=zn,a=",",l="!",c="//",f="/",p="-//",h="-/",d="+//",x="+/",g="~//",b="~/",A="..//",v="../",P=".//",y="./",m="<//",C=">//",_=":",S="*",w="[",E="]",q="?:",F="?",R="||",j="&&",L="|",Q="^",T="&",N="==",k="!=",$="<=",I=">=",M="=~",O="!~",U="<<",B=">>",D="**",V="(",z=")",Z="@",K="{",G="}",H='"',J="'",W="\\\\",X='\\"',Y="\\b",tt="\\v",et="\\f",rt="\\t",nt="\\r",ut="\\n",st="\\e",ot="\\x",it="\\u",at="\\'",lt="`",ct="\\`",ft="0b",pt="0o",ht="0x",dt=".",xt="true",gt="false",bt="null",At="NaN",vt="undefined",Pt="/*",yt="*/",mt=/^[<>]/,Ct=/^[+\-]/,_t=/^[%*\/]/,St=/^[!~]/,wt=/^[a-zA-Z_]/,Et=/^[a-zA-Z0-9_\-]/,qt=/^[^"]/,Ft=/^[^']/,Rt=/^[0-9a-fA-F]/,jt=/^[^`]/,Lt=/^[01]/,Qt=/^[0-7]/,Tt=/^[0-9]/,Nt=/^[eE]/,kt=/^[ \t\r\n]/,$t=In(",",!1),It=In("!",!1),Mt=On("axis"),Ot=In("//",!1),Ut=In("/",!1),Bt=In("-//",!1),Dt=In("-/",!1),Vt=In("+//",!1),zt=In("+/",!1),Zt=In("~//",!1),Kt=In("~/",!1),Gt=In("..//",!1),Ht=In("../",!1),Jt=In(".//",!1),Wt=In("./",!1),Xt=In("<//",!1),Yt=In(">//",!1),te=In(":",!1),ee=In("*",!1),re=In("[",!1),ne=In("]",!1),ue=In("?:",!1),se=In("?",!1),oe=In("||",!1),ie=In("&&",!1),ae=In("|",!1),le=In("^",!1),ce=In("&",!1),fe=In("==",!1),pe=In("!=",!1),he=In("<=",!1),de=In(">=",!1),xe=Mn(["<",">"],!1,!1),ge=In("=~",!1),be=In("!~",!1),Ae=In("<<",!1),ve=In(">>",!1),Pe=Mn(["+","-"],!1,!1),ye=In("**",!1),me=Mn(["%","*","/"],!1,!1),Ce=Mn(["!","~"],!1,!1),_e=In("(",!1),Se=In(")",!1),we=On("node attribute"),Ee=In("@",!1),qe=On("query parameter reference"),Fe=In("{",!1),Re=In("}",!1),je=On("identifier"),Le=Mn([["a","z"],["A","Z"],"_"],!1,!1),Qe=Mn([["a","z"],["A","Z"],["0","9"],"_","-"],!1,!1),Te=On("quoted string literal"),Ne=In('"',!1),ke=Mn(['"'],!0,!1),$e=In("'",!1),Ie=Mn(["'"],!0,!1),Me=On("escaped double-quoted-string character"),Oe=In("\\\\",!1),Ue=In('\\"',!1),Be=In("\\b",!1),De=In("\\v",!1),Ve=In("\\f",!1),ze=In("\\t",!1),Ze=In("\\r",!1),Ke=In("\\n",!1),Ge=In("\\e",!1),He=In("\\x",!1),Je=Mn([["0","9"],["a","f"],["A","F"]],!1,!1),We=In("\\u",!1),Xe=On("escaped single-quoted-string character"),Ye=In("\\'",!1),tr=On("regular expression literal"),er=In("`",!1),rr=In("\\`",!1),nr=Mn(["`"],!0,!1),ur=On("numeric literal"),sr=In("0b",!1),or=Mn(["0","1"],!1,!1),ir=In("0o",!1),ar=Mn([["0","7"]],!1,!1),lr=In("0x",!1),cr=Mn([["0","9"]],!1,!1),fr=In(".",!1),pr=Mn(["e","E"],!1,!1),hr=On("global value"),dr=In("true",!1),xr=In("false",!1),gr=In("null",!1),br=In("NaN",!1),Ar=In("undefined",!1),vr=On("optional blank"),Pr=On("multi-line comment"),yr=In("/*",!1),mr=In("*/",!1),Cr={type:"any"},_r=On("any whitespaces"),Sr=Mn([" ","\t","\r","\n"],!1,!1),wr=On("end of file"),Er=function(t){return t},qr=function(t,e){return Au("Query").add(bu(t,e,3))},Fr=function(t,e){return Au("Path").add(bu(t,e,1))},Rr=function(t,e,r,n){return Au("Step").add(t,e,n).set(null!==r?{isResult:!0}:{})},jr=function(t,e,r,n){return Au("Step").add(t,e,n).set(null!==r?{isResult:!0}:{})},Lr=function(t,e){return Au("Axis").set({op:t,type:null!==e?e:"*"})},Qr=function(t){return t.get("id")},Tr=function(t){return t.get("value")},Nr=function(t){return Au("Match").merge(t)},kr=function(t){return Au("Match").set({id:t.get("value")})},$r=function(){return Au("Match").set({id:"*"})},Ir=function(t){return Au("Filter").add(t)},Mr=function(t,e){return Au("ConditionalBinary").add(t,e)},Or=function(t,e,r){return Au("ConditionalTernary").add(t,e,r)},Ur=function(t,e,r){return Au("Logical").set({op:e}).add(t,r)},Br=function(t,e,r){return Au("Logical").set({op:e}).add(t,r)},Dr=function(t,e,r){return Au("Bitwise").set({op:e}).add(t,r)},Vr=function(t,e,r){return Au("Bitwise").set({op:e}).add(t,r)},zr=function(t,e,r){return Au("Bitwise").set({op:e}).add(t,r)},Zr=function(t,e,r){return Au("Relational").set({op:e}).add(t,r)},Kr=function(t,e,r){return Au("Bitwise").set({op:e}).add(t,r)},Gr=function(t,e,r){return Au("Arithmetical").set({op:e}).add(t,r)},Hr=function(t,e,r){return Au("Arithmetical").set({op:e}).add(t,r)},Jr=function(t,e){return Au("Unary").set({op:t}).add(e)},Wr=function(t,e){return Au("FuncCall").merge(t).add(e)},Xr=function(t,e){return bu(t,e,3)},Yr=function(t){return Au("Attribute").merge(t)},tn=function(t){return Au("Attribute").set({id:t.get("value")})},en=function(t){return Au("Param").merge(t)},rn=function(t){return t},nn=function(t){return Au("Identifier").set({id:t})},un=function(t){return Au("LiteralString").set({value:t.join("")})},sn=function(t){return Au("LiteralString").set({value:t.join("")})},on=function(){return"\\"},an=function(){return'"'},ln=function(){return"\b"},cn=function(){return"\v"},fn=function(){return"\f"},pn=function(){return"\t"},hn=function(){return"\r"},dn=function(){return"\n"},xn=function(){return""},gn=function(t){return String.fromCharCode(parseInt(t,16))},bn=function(t){return String.fromCharCode(parseInt(t,16))},An=function(){return"'"},vn=function(e){var r;try{r=new RegExp(e.replace(/\\`/g,"`"))}catch(e){!function(e,r){throw r=void 0!==r?r:Bn(jn,Rn),function(e,r){return new t(e,null,null,r)}(e,r)}(e.message)}return Au("LiteralRegExp").set({value:r})},Pn=function(t,e){return Au("LiteralNumber").set({value:parseInt(t+e,2)})},yn=function(t,e){return Au("LiteralNumber").set({value:parseInt(t+e,8)})},mn=function(t,e){return Au("LiteralNumber").set({value:parseInt(t+e,16)})},Cn=function(t){return Au("LiteralNumber").set({value:parseFloat(t)})},_n=function(t){return Au("LiteralNumber").set({value:parseInt(t,10)})},Sn=function(){return Au("LiteralValue").set({value:!0})},wn=function(){return Au("LiteralValue").set({value:!1})},En=function(){return Au("LiteralValue").set({value:null})},qn=function(){return Au("LiteralValue").set({value:NaN})},Fn=function(){return Au("LiteralValue").set({value:void 0})},Rn=0|r.peg$currPos,jn=Rn,Ln=[{line:1,column:1}],Qn=Rn,Tn=r.peg$maxFailExpected||[],Nn=0|r.peg$silentFails,kn={};if(r.startRule){if(!(r.startRule in o))throw new Error("Can't start parsing from rule \""+r.startRule+'".');i=o[r.startRule]}function $n(){return Bn(jn,Rn)}function In(t,e){return{type:"literal",text:t,ignoreCase:e}}function Mn(t,e,r){return{type:"class",parts:t,inverted:e,ignoreCase:r}}function On(t){return{type:"other",description:t}}function Un(t){var r,n=Ln[t];if(n)return n;if(t>=Ln.length)r=Ln.length-1;else for(r=t;!Ln[--r];);for(n={line:(n=Ln[r]).line,column:n.column};r<t;)10===e.charCodeAt(r)?(n.line++,n.column=1):n.column++,r++;return Ln[t]=n,n}function Bn(t,e,r){var n=Un(t),u=Un(e),o={source:s,start:{offset:t,line:n.line,column:n.column},end:{offset:e,line:u.line,column:u.column}};return r&&s&&"function"==typeof s.offset&&(o.start=s.offset(o.start),o.end=s.offset(o.end)),o}function Dn(t){Rn<Qn||(Rn>Qn&&(Qn=Rn,Tn=[]),Tn.push(t))}function Vn(e,r,n){return new t(t.buildMessage(e,r),e,r,n)}function zn(){var t,r,n=38*Rn+0,s=kn[n];return s?(Rn=s.nextPos,s.result):(t=Rn,du(),(r=function(){var t,r,n,s,o,i,l,c,f=38*Rn+1,p=kn[f];if(p)return Rn=p.nextPos,p.result;if(t=Rn,(r=Zn())!==u){for(n=[],s=Rn,o=du(),44===e.charCodeAt(Rn)?(i=a,Rn++):(i=u,0===Nn&&Dn($t)),i!==u?(l=du(),(c=Zn())!==u?s=o=[o,i,l,c]:(Rn=s,s=u)):(Rn=s,s=u);s!==u;)n.push(s),s=Rn,o=du(),44===e.charCodeAt(Rn)?(i=a,Rn++):(i=u,0===Nn&&Dn($t)),i!==u?(l=du(),(c=Zn())!==u?s=o=[o,i,l,c]:(Rn=s,s=u)):(Rn=s,s=u);jn=t,t=qr(r,n)}else Rn=t,t=u;return kn[f]={nextPos:Rn,result:t},t}())!==u?(du(),function(){var t,r,n=38*Rn+37,s=kn[n];return s?(Rn=s.nextPos,s.result):(Nn++,t=Rn,Nn++,e.length>Rn?(r=e.charAt(Rn),Rn++):(r=u,0===Nn&&Dn(Cr)),Nn--,r===u?t=void 0:(Rn=t,t=u),Nn--,t===u&&(r=u,0===Nn&&Dn(wr)),kn[n]={nextPos:Rn,result:t},t)}()!==u?(jn=t,t=Er(r)):(Rn=t,t=u)):(Rn=t,t=u),kn[n]={nextPos:Rn,result:t},t)}function Zn(){var t,r,n,s,o,i,a=38*Rn+2,c=kn[a];if(c)return Rn=c.nextPos,c.result;if(t=Rn,(r=function(){var t,r,n,s,o,i=38*Rn+3,a=kn[i];return a?(Rn=a.nextPos,a.result):(t=Rn,(r=Gn())===u&&(r=null),du(),(n=Hn())!==u?(du(),33===e.charCodeAt(Rn)?(s=l,Rn++):(s=u,0===Nn&&Dn(It)),s===u&&(s=null),du(),(o=Jn())===u&&(o=null),jn=t,t=Rr(r,n,s,o)):(Rn=t,t=u),kn[i]={nextPos:Rn,result:t},t)}())!==u){for(n=[],s=Rn,o=du(),(i=Kn())!==u?s=o=[o,i]:(Rn=s,s=u);s!==u;)n.push(s),s=Rn,o=du(),(i=Kn())!==u?s=o=[o,i]:(Rn=s,s=u);jn=t,t=Fr(r,n)}else Rn=t,t=u;return kn[a]={nextPos:Rn,result:t},t}function Kn(){var t,r,n,s,o,i=38*Rn+4,a=kn[i];return a?(Rn=a.nextPos,a.result):(t=Rn,(r=Gn())!==u?(du(),(n=Hn())!==u?(du(),33===e.charCodeAt(Rn)?(s=l,Rn++):(s=u,0===Nn&&Dn(It)),s===u&&(s=null),du(),(o=Jn())===u&&(o=null),jn=t,t=jr(r,n,s,o)):(Rn=t,t=u)):(Rn=t,t=u),kn[i]={nextPos:Rn,result:t},t)}function Gn(){var t,r,n,s=38*Rn+5,o=kn[s];return o?(Rn=o.nextPos,o.result):(Nn++,t=Rn,r=Rn,e.substr(Rn,2)===c?(n=c,Rn+=2):(n=u,0===Nn&&Dn(Ot)),n===u&&(47===e.charCodeAt(Rn)?(n=f,Rn++):(n=u,0===Nn&&Dn(Ut)),n===u&&(e.substr(Rn,3)===p?(n=p,Rn+=3):(n=u,0===Nn&&Dn(Bt)),n===u&&(e.substr(Rn,2)===h?(n=h,Rn+=2):(n=u,0===Nn&&Dn(Dt)),n===u&&(e.substr(Rn,3)===d?(n=d,Rn+=3):(n=u,0===Nn&&Dn(Vt)),n===u&&(e.substr(Rn,2)===x?(n=x,Rn+=2):(n=u,0===Nn&&Dn(zt)),n===u&&(e.substr(Rn,3)===g?(n=g,Rn+=3):(n=u,0===Nn&&Dn(Zt)),n===u&&(e.substr(Rn,2)===b?(n=b,Rn+=2):(n=u,0===Nn&&Dn(Kt)),n===u&&(e.substr(Rn,4)===A?(n=A,Rn+=4):(n=u,0===Nn&&Dn(Gt)),n===u&&(e.substr(Rn,3)===v?(n=v,Rn+=3):(n=u,0===Nn&&Dn(Ht)),n===u&&(e.substr(Rn,3)===P?(n=P,Rn+=3):(n=u,0===Nn&&Dn(Jt)),n===u&&(e.substr(Rn,2)===y?(n=y,Rn+=2):(n=u,0===Nn&&Dn(Wt)),n===u&&(e.substr(Rn,3)===m?(n=m,Rn+=3):(n=u,0===Nn&&Dn(Xt)),n===u&&(e.substr(Rn,3)===C?(n=C,Rn+=3):(n=u,0===Nn&&Dn(Yt))))))))))))))),(r=n!==u?e.substring(r,Rn):n)!==u?((n=function(){var t,r,n,s=38*Rn+6,o=kn[s];return o?(Rn=o.nextPos,o.result):(t=Rn,58===e.charCodeAt(Rn)?(r=_,Rn++):(r=u,0===Nn&&Dn(te)),r!==u&&(n=lu())!==u?(jn=t,t=Qr(n)):(Rn=t,t=u),t===u&&(t=Rn,58===e.charCodeAt(Rn)?(r=_,Rn++):(r=u,0===Nn&&Dn(te)),r!==u&&(n=cu())!==u?(jn=t,t=Tr(n)):(Rn=t,t=u)),kn[s]={nextPos:Rn,result:t},t)}())===u&&(n=null),jn=t,t=Lr(r,n)):(Rn=t,t=u),Nn--,t===u&&(r=u,0===Nn&&Dn(Mt)),kn[s]={nextPos:Rn,result:t},t)}function Hn(){var t,r,n=38*Rn+7,s=kn[n];return s?(Rn=s.nextPos,s.result):(t=Rn,(r=lu())!==u&&(jn=t,r=Nr(r)),(t=r)===u&&(t=Rn,(r=cu())!==u&&(jn=t,r=kr(r)),(t=r)===u&&(t=Rn,42===e.charCodeAt(Rn)?(r=S,Rn++):(r=u,0===Nn&&Dn(ee)),r!==u&&(jn=t,r=$r()),t=r)),kn[n]={nextPos:Rn,result:t},t)}function Jn(){var t,r,n,s,o=38*Rn+8,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,91===e.charCodeAt(Rn)?(r=w,Rn++):(r=u,0===Nn&&Dn(re)),r!==u?(du(),(n=Wn())!==u?(du(),93===e.charCodeAt(Rn)?(s=E,Rn++):(s=u,0===Nn&&Dn(ne)),s!==u?(jn=t,t=Ir(n)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),kn[o]={nextPos:Rn,result:t},t)}function Wn(){var t,r,n,s,o,i,a=38*Rn+9,l=kn[a];return l?(Rn=l.nextPos,l.result):(t=Rn,(r=Xn())!==u?(du(),e.substr(Rn,2)===q?(n=q,Rn+=2):(n=u,0===Nn&&Dn(ue)),n!==u?(du(),(s=Wn())!==u?(jn=t,t=Mr(r,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=Rn,(r=Xn())!==u?(du(),63===e.charCodeAt(Rn)?(n=F,Rn++):(n=u,0===Nn&&Dn(se)),n!==u?(du(),(s=Wn())!==u?(du(),58===e.charCodeAt(Rn)?(o=_,Rn++):(o=u,0===Nn&&Dn(te)),o!==u?(du(),(i=Wn())!==u?(jn=t,t=Or(r,s,i)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=Xn())),kn[a]={nextPos:Rn,result:t},t)}function Xn(){var t,r,n,s,o=38*Rn+10,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,(r=Yn())!==u?(du(),e.substr(Rn,2)===R?(n=R,Rn+=2):(n=u,0===Nn&&Dn(oe)),n!==u?(du(),(s=Xn())!==u?(jn=t,t=Ur(r,n,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=Yn()),kn[o]={nextPos:Rn,result:t},t)}function Yn(){var t,r,n,s,o=38*Rn+11,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,(r=tu())!==u?(du(),e.substr(Rn,2)===j?(n=j,Rn+=2):(n=u,0===Nn&&Dn(ie)),n!==u?(du(),(s=Yn())!==u?(jn=t,t=Br(r,n,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=tu()),kn[o]={nextPos:Rn,result:t},t)}function tu(){var t,r,n,s,o=38*Rn+12,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,(r=eu())!==u?(du(),124===e.charCodeAt(Rn)?(n=L,Rn++):(n=u,0===Nn&&Dn(ae)),n!==u?(du(),(s=tu())!==u?(jn=t,t=Dr(r,n,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=eu()),kn[o]={nextPos:Rn,result:t},t)}function eu(){var t,r,n,s,o=38*Rn+13,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,(r=ru())!==u?(du(),94===e.charCodeAt(Rn)?(n=Q,Rn++):(n=u,0===Nn&&Dn(le)),n!==u?(du(),(s=eu())!==u?(jn=t,t=Vr(r,n,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=ru()),kn[o]={nextPos:Rn,result:t},t)}function ru(){var t,r,n,s,o=38*Rn+14,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,(r=nu())!==u?(du(),38===e.charCodeAt(Rn)?(n=T,Rn++):(n=u,0===Nn&&Dn(ce)),n!==u?(du(),(s=ru())!==u?(jn=t,t=zr(r,n,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=nu()),kn[o]={nextPos:Rn,result:t},t)}function nu(){var t,r,n,s,o,i=38*Rn+15,a=kn[i];return a?(Rn=a.nextPos,a.result):(t=Rn,(r=uu())!==u?(du(),n=Rn,e.substr(Rn,2)===N?(s=N,Rn+=2):(s=u,0===Nn&&Dn(fe)),s===u&&(e.substr(Rn,2)===k?(s=k,Rn+=2):(s=u,0===Nn&&Dn(pe)),s===u&&(e.substr(Rn,2)===$?(s=$,Rn+=2):(s=u,0===Nn&&Dn(he)),s===u&&(e.substr(Rn,2)===I?(s=I,Rn+=2):(s=u,0===Nn&&Dn(de)),s===u&&(s=e.charAt(Rn),mt.test(s)?Rn++:(s=u,0===Nn&&Dn(xe)),s===u&&(e.substr(Rn,2)===M?(s=M,Rn+=2):(s=u,0===Nn&&Dn(ge)),s===u&&(e.substr(Rn,2)===O?(s=O,Rn+=2):(s=u,0===Nn&&Dn(be)))))))),(n=s!==u?e.substring(n,Rn):s)!==u?(s=du(),(o=nu())!==u?(jn=t,t=Zr(r,n,o)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=uu()),kn[i]={nextPos:Rn,result:t},t)}function uu(){var t,r,n,s,o,i=38*Rn+16,a=kn[i];return a?(Rn=a.nextPos,a.result):(t=Rn,(r=su())!==u?(du(),n=Rn,e.substr(Rn,2)===U?(s=U,Rn+=2):(s=u,0===Nn&&Dn(Ae)),s===u&&(e.substr(Rn,2)===B?(s=B,Rn+=2):(s=u,0===Nn&&Dn(ve))),(n=s!==u?e.substring(n,Rn):s)!==u?(s=du(),(o=uu())!==u?(jn=t,t=Kr(r,n,o)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=su()),kn[i]={nextPos:Rn,result:t},t)}function su(){var t,r,n,s,o=38*Rn+17,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,(r=ou())!==u?(du(),n=e.charAt(Rn),Ct.test(n)?Rn++:(n=u,0===Nn&&Dn(Pe)),n!==u?(du(),(s=su())!==u?(jn=t,t=Gr(r,n,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=ou()),kn[o]={nextPos:Rn,result:t},t)}function ou(){var t,r,n,s,o,i=38*Rn+18,a=kn[i];return a?(Rn=a.nextPos,a.result):(t=Rn,(r=iu())!==u?(du(),n=Rn,e.substr(Rn,2)===D?(s=D,Rn+=2):(s=u,0===Nn&&Dn(ye)),s===u&&(s=e.charAt(Rn),_t.test(s)?Rn++:(s=u,0===Nn&&Dn(me))),(n=s!==u?e.substring(n,Rn):s)!==u?(s=du(),(o=ou())!==u?(jn=t,t=Hr(r,n,o)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=iu()),kn[i]={nextPos:Rn,result:t},t)}function iu(){var t,r,n,s=38*Rn+19,o=kn[s];return o?(Rn=o.nextPos,o.result):(t=Rn,r=e.charAt(Rn),St.test(r)?Rn++:(r=u,0===Nn&&Dn(Ce)),r!==u&&(n=au())!==u?(jn=t,t=Jr(r,n)):(Rn=t,t=u),t===u&&(t=au()),kn[s]={nextPos:Rn,result:t},t)}function au(){var t,r=38*Rn+20,n=kn[r];return n?(Rn=n.nextPos,n.result):((t=function(){var t,r,n,s,o,i=38*Rn+21,l=kn[i];return l?(Rn=l.nextPos,l.result):(t=Rn,(r=lu())!==u?(du(),40===e.charCodeAt(Rn)?(n=V,Rn++):(n=u,0===Nn&&Dn(_e)),n!==u?(du(),(s=function(){var t,r,n,s,o,i,l,c,f=38*Rn+22,p=kn[f];if(p)return Rn=p.nextPos,p.result;if(t=Rn,(r=Wn())!==u){for(n=[],s=Rn,o=du(),44===e.charCodeAt(Rn)?(i=a,Rn++):(i=u,0===Nn&&Dn($t)),i!==u?(l=du(),(c=Wn())!==u?s=o=[o,i,l,c]:(Rn=s,s=u)):(Rn=s,s=u);s!==u;)n.push(s),s=Rn,o=du(),44===e.charCodeAt(Rn)?(i=a,Rn++):(i=u,0===Nn&&Dn($t)),i!==u?(l=du(),(c=Wn())!==u?s=o=[o,i,l,c]:(Rn=s,s=u)):(Rn=s,s=u);jn=t,t=Xr(r,n)}else Rn=t,t=u;return kn[f]={nextPos:Rn,result:t},t}())===u&&(s=null),du(),41===e.charCodeAt(Rn)?(o=z,Rn++):(o=u,0===Nn&&Dn(Se)),o!==u?(jn=t,t=Wr(r,s)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),kn[i]={nextPos:Rn,result:t},t)}())===u&&(t=function(){var t,r,n,s=38*Rn+23,o=kn[s];return o?(Rn=o.nextPos,o.result):(Nn++,t=Rn,64===e.charCodeAt(Rn)?(r=Z,Rn++):(r=u,0===Nn&&Dn(Ee)),r!==u&&(n=lu())!==u?(jn=t,t=Yr(n)):(Rn=t,t=u),t===u&&(t=Rn,64===e.charCodeAt(Rn)?(r=Z,Rn++):(r=u,0===Nn&&Dn(Ee)),r!==u&&(n=cu())!==u?(jn=t,t=tn(n)):(Rn=t,t=u)),Nn--,t===u&&(r=u,0===Nn&&Dn(we)),kn[s]={nextPos:Rn,result:t},t)}())===u&&(t=function(){var t,r,n,s,o=38*Rn+24,i=kn[o];return i?(Rn=i.nextPos,i.result):(Nn++,t=Rn,123===e.charCodeAt(Rn)?(r=K,Rn++):(r=u,0===Nn&&Dn(Fe)),r!==u?(du(),(n=lu())!==u?(du(),125===e.charCodeAt(Rn)?(s=G,Rn++):(s=u,0===Nn&&Dn(Re)),s!==u?(jn=t,t=en(n)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),Nn--,t===u&&(r=u,0===Nn&&Dn(qe)),kn[o]={nextPos:Rn,result:t},t)}())===u&&(t=function(){var t,r=38*Rn+25,n=kn[r];return n?(Rn=n.nextPos,n.result):((t=cu())===u&&(t=function(){var t,r,n,s,o,i=38*Rn+31,a=kn[i];if(a)return Rn=a.nextPos,a.result;if(Nn++,t=Rn,96===e.charCodeAt(Rn)?(r=lt,Rn++):(r=u,0===Nn&&Dn(er)),r!==u){for(n=Rn,s=[],e.substr(Rn,2)===ct?(o=ct,Rn+=2):(o=u,0===Nn&&Dn(rr)),o===u&&(o=e.charAt(Rn),jt.test(o)?Rn++:(o=u,0===Nn&&Dn(nr)));o!==u;)s.push(o),e.substr(Rn,2)===ct?(o=ct,Rn+=2):(o=u,0===Nn&&Dn(rr)),o===u&&(o=e.charAt(Rn),jt.test(o)?Rn++:(o=u,0===Nn&&Dn(nr)));n=e.substring(n,Rn),96===e.charCodeAt(Rn)?(s=lt,Rn++):(s=u,0===Nn&&Dn(er)),s!==u?(jn=t,t=vn(n)):(Rn=t,t=u)}else Rn=t,t=u;return Nn--,t===u&&(r=u,0===Nn&&Dn(tr)),kn[i]={nextPos:Rn,result:t},t}())===u&&(t=function(){var t,r,n,s,o,i,a,l,c,f,p,h,d=38*Rn+32,x=kn[d];if(x)return Rn=x.nextPos,x.result;if(Nn++,t=Rn,r=Rn,n=e.charAt(Rn),Ct.test(n)?Rn++:(n=u,0===Nn&&Dn(Pe)),n===u&&(n=null),r=e.substring(r,Rn),e.substr(Rn,2)===ft?(n=ft,Rn+=2):(n=u,0===Nn&&Dn(sr)),n!==u){if(s=Rn,o=[],i=e.charAt(Rn),Lt.test(i)?Rn++:(i=u,0===Nn&&Dn(or)),i!==u)for(;i!==u;)o.push(i),i=e.charAt(Rn),Lt.test(i)?Rn++:(i=u,0===Nn&&Dn(or));else o=u;(s=o!==u?e.substring(s,Rn):o)!==u?(jn=t,t=Pn(r,s)):(Rn=t,t=u)}else Rn=t,t=u;if(t===u){if(t=Rn,r=Rn,n=e.charAt(Rn),Ct.test(n)?Rn++:(n=u,0===Nn&&Dn(Pe)),n===u&&(n=null),r=e.substring(r,Rn),e.substr(Rn,2)===pt?(n=pt,Rn+=2):(n=u,0===Nn&&Dn(ir)),n!==u){if(s=Rn,o=[],i=e.charAt(Rn),Qt.test(i)?Rn++:(i=u,0===Nn&&Dn(ar)),i!==u)for(;i!==u;)o.push(i),i=e.charAt(Rn),Qt.test(i)?Rn++:(i=u,0===Nn&&Dn(ar));else o=u;(s=o!==u?e.substring(s,Rn):o)!==u?(jn=t,t=yn(r,s)):(Rn=t,t=u)}else Rn=t,t=u;if(t===u){if(t=Rn,r=Rn,n=e.charAt(Rn),Ct.test(n)?Rn++:(n=u,0===Nn&&Dn(Pe)),n===u&&(n=null),r=e.substring(r,Rn),e.substr(Rn,2)===ht?(n=ht,Rn+=2):(n=u,0===Nn&&Dn(lr)),n!==u){if(s=Rn,o=[],i=e.charAt(Rn),Rt.test(i)?Rn++:(i=u,0===Nn&&Dn(Je)),i!==u)for(;i!==u;)o.push(i),i=e.charAt(Rn),Rt.test(i)?Rn++:(i=u,0===Nn&&Dn(Je));else o=u;(s=o!==u?e.substring(s,Rn):o)!==u?(jn=t,t=mn(r,s)):(Rn=t,t=u)}else Rn=t,t=u;if(t===u){for(t=Rn,r=Rn,n=Rn,s=e.charAt(Rn),Ct.test(s)?Rn++:(s=u,0===Nn&&Dn(Pe)),s===u&&(s=null),o=[],i=e.charAt(Rn),Tt.test(i)?Rn++:(i=u,0===Nn&&Dn(cr));i!==u;)o.push(i),i=e.charAt(Rn),Tt.test(i)?Rn++:(i=u,0===Nn&&Dn(cr));if(46===e.charCodeAt(Rn)?(i=dt,Rn++):(i=u,0===Nn&&Dn(fr)),i!==u){if(a=[],l=e.charAt(Rn),Tt.test(l)?Rn++:(l=u,0===Nn&&Dn(cr)),l!==u)for(;l!==u;)a.push(l),l=e.charAt(Rn),Tt.test(l)?Rn++:(l=u,0===Nn&&Dn(cr));else a=u;if(a!==u){if(l=Rn,c=e.charAt(Rn),Nt.test(c)?Rn++:(c=u,0===Nn&&Dn(pr)),c!==u){if(f=e.charAt(Rn),Ct.test(f)?Rn++:(f=u,0===Nn&&Dn(Pe)),f===u&&(f=null),p=[],h=e.charAt(Rn),Tt.test(h)?Rn++:(h=u,0===Nn&&Dn(cr)),h!==u)for(;h!==u;)p.push(h),h=e.charAt(Rn),Tt.test(h)?Rn++:(h=u,0===Nn&&Dn(cr));else p=u;p!==u?l=c=[c,f,p]:(Rn=l,l=u)}else Rn=l,l=u;l===u&&(l=null),n=s=[s,o,i,a,l]}else Rn=n,n=u}else Rn=n,n=u;if((r=n!==u?e.substring(r,Rn):n)!==u&&(jn=t,r=Cn(r)),(t=r)===u){if(t=Rn,r=Rn,n=Rn,s=e.charAt(Rn),Ct.test(s)?Rn++:(s=u,0===Nn&&Dn(Pe)),s===u&&(s=null),o=[],i=e.charAt(Rn),Tt.test(i)?Rn++:(i=u,0===Nn&&Dn(cr)),i!==u)for(;i!==u;)o.push(i),i=e.charAt(Rn),Tt.test(i)?Rn++:(i=u,0===Nn&&Dn(cr));else o=u;o!==u?n=s=[s,o]:(Rn=n,n=u),(r=n!==u?e.substring(r,Rn):n)!==u&&(jn=t,r=_n(r)),t=r}}}}return Nn--,t===u&&(r=u,0===Nn&&Dn(ur)),kn[d]={nextPos:Rn,result:t},t}())===u&&(t=hu()),kn[r]={nextPos:Rn,result:t},t)}())===u&&(t=function(){var t,r,n,s,o=38*Rn+26,i=kn[o];return i?(Rn=i.nextPos,i.result):(t=Rn,40===e.charCodeAt(Rn)?(r=V,Rn++):(r=u,0===Nn&&Dn(_e)),r!==u?(du(),(n=Wn())!==u?(du(),41===e.charCodeAt(Rn)?(s=z,Rn++):(s=u,0===Nn&&Dn(Se)),s!==u?(jn=t,t=rn(n)):(Rn=t,t=u)):(Rn=t,t=u)):(Rn=t,t=u),kn[o]={nextPos:Rn,result:t},t)}())===u&&(t=Zn()),kn[r]={nextPos:Rn,result:t},t)}function lu(){var t,r,n,s,o,i,a,l=38*Rn+27,c=kn[l];if(c)return Rn=c.nextPos,c.result;if(Nn++,t=Rn,r=Rn,n=Rn,s=Rn,Nn++,o=hu(),Nn--,o===u?s=void 0:(Rn=s,s=u),s!==u)if(o=e.charAt(Rn),wt.test(o)?Rn++:(o=u,0===Nn&&Dn(Le)),o!==u){for(i=[],a=e.charAt(Rn),Et.test(a)?Rn++:(a=u,0===Nn&&Dn(Qe));a!==u;)i.push(a),a=e.charAt(Rn),Et.test(a)?Rn++:(a=u,0===Nn&&Dn(Qe));n=s=[s,o,i]}else Rn=n,n=u;else Rn=n,n=u;return(r=n!==u?e.substring(r,Rn):n)!==u&&(jn=t,r=nn(r)),Nn--,(t=r)===u&&(r=u,0===Nn&&Dn(je)),kn[l]={nextPos:Rn,result:t},t}function cu(){var t,r,n,s,o=38*Rn+28,i=kn[o];if(i)return Rn=i.nextPos,i.result;if(Nn++,t=Rn,34===e.charCodeAt(Rn)?(r=H,Rn++):(r=u,0===Nn&&Dn(Ne)),r!==u){for(n=[],(s=fu())===u&&(s=e.charAt(Rn),qt.test(s)?Rn++:(s=u,0===Nn&&Dn(ke)));s!==u;)n.push(s),(s=fu())===u&&(s=e.charAt(Rn),qt.test(s)?Rn++:(s=u,0===Nn&&Dn(ke)));34===e.charCodeAt(Rn)?(s=H,Rn++):(s=u,0===Nn&&Dn(Ne)),s!==u?(jn=t,t=un(n)):(Rn=t,t=u)}else Rn=t,t=u;if(t===u)if(t=Rn,39===e.charCodeAt(Rn)?(r=J,Rn++):(r=u,0===Nn&&Dn($e)),r!==u){for(n=[],(s=pu())===u&&(s=e.charAt(Rn),Ft.test(s)?Rn++:(s=u,0===Nn&&Dn(Ie)));s!==u;)n.push(s),(s=pu())===u&&(s=e.charAt(Rn),Ft.test(s)?Rn++:(s=u,0===Nn&&Dn(Ie)));39===e.charCodeAt(Rn)?(s=J,Rn++):(s=u,0===Nn&&Dn($e)),s!==u?(jn=t,t=sn(n)):(Rn=t,t=u)}else Rn=t,t=u;return Nn--,t===u&&(r=u,0===Nn&&Dn(Te)),kn[o]={nextPos:Rn,result:t},t}function fu(){var t,r,n,s,o,i,a,l,c=38*Rn+29,f=kn[c];return f?(Rn=f.nextPos,f.result):(Nn++,t=Rn,e.substr(Rn,2)===W?(r=W,Rn+=2):(r=u,0===Nn&&Dn(Oe)),r!==u&&(jn=t,r=on()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===X?(r=X,Rn+=2):(r=u,0===Nn&&Dn(Ue)),r!==u&&(jn=t,r=an()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===Y?(r=Y,Rn+=2):(r=u,0===Nn&&Dn(Be)),r!==u&&(jn=t,r=ln()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===tt?(r=tt,Rn+=2):(r=u,0===Nn&&Dn(De)),r!==u&&(jn=t,r=cn()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===et?(r=et,Rn+=2):(r=u,0===Nn&&Dn(Ve)),r!==u&&(jn=t,r=fn()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===rt?(r=rt,Rn+=2):(r=u,0===Nn&&Dn(ze)),r!==u&&(jn=t,r=pn()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===nt?(r=nt,Rn+=2):(r=u,0===Nn&&Dn(Ze)),r!==u&&(jn=t,r=hn()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===ut?(r=ut,Rn+=2):(r=u,0===Nn&&Dn(Ke)),r!==u&&(jn=t,r=dn()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===st?(r=st,Rn+=2):(r=u,0===Nn&&Dn(Ge)),r!==u&&(jn=t,r=xn()),(t=r)===u&&(t=Rn,e.substr(Rn,2)===ot?(r=ot,Rn+=2):(r=u,0===Nn&&Dn(He)),r!==u?(n=Rn,s=Rn,o=e.charAt(Rn),Rt.test(o)?Rn++:(o=u,0===Nn&&Dn(Je)),o!==u?(i=e.charAt(Rn),Rt.test(i)?Rn++:(i=u,0===Nn&&Dn(Je)),i!==u?s=o=[o,i]:(Rn=s,s=u)):(Rn=s,s=u),(n=s!==u?e.substring(n,Rn):s)!==u?(jn=t,t=gn(n)):(Rn=t,t=u)):(Rn=t,t=u),t===u&&(t=Rn,e.substr(Rn,2)===it?(r=it,Rn+=2):(r=u,0===Nn&&Dn(We)),r!==u?(n=Rn,s=Rn,o=e.charAt(Rn),Rt.test(o)?Rn++:(o=u,0===Nn&&Dn(Je)),o!==u?(i=e.charAt(Rn),Rt.test(i)?Rn++:(i=u,0===Nn&&Dn(Je)),i!==u?(a=e.charAt(Rn),Rt.test(a)?Rn++:(a=u,0===Nn&&Dn(Je)),a!==u?(l=e.charAt(Rn),Rt.test(l)?Rn++:(l=u,0===Nn&&Dn(Je)),l!==u?s=o=[o,i,a,l]:(Rn=s,s=u)):(Rn=s,s=u)):(Rn=s,s=u)):(Rn=s,s=u),(n=s!==u?e.substring(n,Rn):s)!==u?(jn=t,t=bn(n)):(Rn=t,t=u)):(Rn=t,t=u))))))))))),Nn--,t===u&&(r=u,0===Nn&&Dn(Me)),kn[c]={nextPos:Rn,result:t},t)}function pu(){var t,r,n=38*Rn+30,s=kn[n];return s?(Rn=s.nextPos,s.result):(Nn++,t=Rn,e.substr(Rn,2)===at?(r=at,Rn+=2):(r=u,0===Nn&&Dn(Ye)),r!==u&&(jn=t,r=An()),Nn--,(t=r)===u&&(r=u,0===Nn&&Dn(Xe)),kn[n]={nextPos:Rn,result:t},t)}function hu(){var t,r,n=38*Rn+33,s=kn[n];return s?(Rn=s.nextPos,s.result):(Nn++,t=Rn,e.substr(Rn,4)===xt?(r=xt,Rn+=4):(r=u,0===Nn&&Dn(dr)),r!==u&&(jn=t,r=Sn()),(t=r)===u&&(t=Rn,e.substr(Rn,5)===gt?(r=gt,Rn+=5):(r=u,0===Nn&&Dn(xr)),r!==u&&(jn=t,r=wn()),(t=r)===u&&(t=Rn,e.substr(Rn,4)===bt?(r=bt,Rn+=4):(r=u,0===Nn&&Dn(gr)),r!==u&&(jn=t,r=En()),(t=r)===u&&(t=Rn,e.substr(Rn,3)===At?(r=At,Rn+=3):(r=u,0===Nn&&Dn(br)),r!==u&&(jn=t,r=qn()),(t=r)===u&&(t=Rn,e.substr(Rn,9)===vt?(r=vt,Rn+=9):(r=u,0===Nn&&Dn(Ar)),r!==u&&(jn=t,r=Fn()),t=r)))),Nn--,t===u&&(r=u,0===Nn&&Dn(hr)),kn[n]={nextPos:Rn,result:t},t)}function du(){var t,e,r=38*Rn+34,n=kn[r];if(n)return Rn=n.nextPos,n.result;for(Nn++,t=[],(e=xu())===u&&(e=gu());e!==u;)t.push(e),(e=xu())===u&&(e=gu());return e=u,0==--Nn&&Dn(vr),kn[r]={nextPos:Rn,result:t},t}function xu(){var t,r,n,s,o,i,a=38*Rn+35,l=kn[a];if(l)return Rn=l.nextPos,l.result;if(Nn++,t=Rn,e.substr(Rn,2)===Pt?(r=Pt,Rn+=2):(r=u,0===Nn&&Dn(yr)),r!==u){for(n=[],s=Rn,o=Rn,Nn++,e.substr(Rn,2)===yt?(i=yt,Rn+=2):(i=u,0===Nn&&Dn(mr)),Nn--,i===u?o=void 0:(Rn=o,o=u),o!==u?(e.length>Rn?(i=e.charAt(Rn),Rn++):(i=u,0===Nn&&Dn(Cr)),i!==u?s=o=[o,i]:(Rn=s,s=u)):(Rn=s,s=u);s!==u;)n.push(s),s=Rn,o=Rn,Nn++,e.substr(Rn,2)===yt?(i=yt,Rn+=2):(i=u,0===Nn&&Dn(mr)),Nn--,i===u?o=void 0:(Rn=o,o=u),o!==u?(e.length>Rn?(i=e.charAt(Rn),Rn++):(i=u,0===Nn&&Dn(Cr)),i!==u?s=o=[o,i]:(Rn=s,s=u)):(Rn=s,s=u);e.substr(Rn,2)===yt?(s=yt,Rn+=2):(s=u,0===Nn&&Dn(mr)),s!==u?t=r=[r,n,s]:(Rn=t,t=u)}else Rn=t,t=u;return Nn--,t===u&&(r=u,0===Nn&&Dn(Pr)),kn[a]={nextPos:Rn,result:t},t}function gu(){var t,r,n=38*Rn+36,s=kn[n];if(s)return Rn=s.nextPos,s.result;if(Nn++,t=[],r=e.charAt(Rn),kt.test(r)?Rn++:(r=u,0===Nn&&Dn(Sr)),r!==u)for(;r!==u;)t.push(r),r=e.charAt(Rn),kt.test(r)?Rn++:(r=u,0===Nn&&Dn(Sr));else t=u;return Nn--,t===u&&(r=u,0===Nn&&Dn(_r)),kn[n]={nextPos:Rn,result:t},t}var bu=r.util.makeUnroll($n,r),Au=r.util.makeAST($n,r);if(n=i(),r.peg$library)return{peg$result:n,peg$currPos:Rn,peg$FAILED:u,peg$maxFailExpected:Tn,peg$maxFailPos:Qn};if(n!==u&&Rn===e.length)return n;throw n!==u&&Rn<e.length&&Dn({type:"end"}),Vn(Tn,Qn<e.length?e.charAt(Qn):null,Qn<e.length?Bn(Qn,Qn+1):Bn(Qn,Qn))}}}(),ASTQQuery=exports.default=function(){function t(e){_classCallCheck(this,t),this.asty=new _asty.default,this.ast=null,e&&this.compile(e)}return _createClass(t,[{key:"compile",value:function(t,e){var r=this;e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\nASTQ: compile: | "+t);var n=_pegjsUtil.default.parse(ASTQQueryParse,t,{startRule:"query",makeAST:function(t,e,n,u){return r.asty.create.apply(r.asty,u).pos(t,e,n)}});if(null!==n.error)throw new Error("ASTQ: compile: query parsing failed:\n"+_pegjsUtil.default.errorMessage(n.error,!0).replace(/^/gm,"ERROR: "));return this.ast=n.ast,e&&console.log("ASTQ: compile: +-------------------------------------------------------------------------------------------------------\n"+this.dump().replace(/\n$/,"").replace(/^/gm,"ASTQ: compile: | ")),this}},{key:"dump",value:function(){return this.ast.dump()}},{key:"execute",value:function(t,e,r,n,u){return u&&console.log("ASTQ: execute: +-------------------------------------------------------------------------------------------------------"),new _astqQueryExec.default(e,r,n,u).execQuery(this.ast,t)}}]),t}();
},{"./astq-query-exec.js":15,"asty":1,"pegjs-util":3}],18:[function(_dereq_,module,exports){
"use strict";function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var o=t[r];o.enumerable=o.enumerable||!1,o.configurable=!0,"value"in o&&(o.writable=!0),Object.defineProperty(e,_toPropertyKey(o.key),o)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var o=r.call(e,t||"default");if("object"!=_typeof(o))return o;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var ASTQUtil=exports.default=function(){function e(){_classCallCheck(this,e)}return _createClass(e,null,[{key:"pad",value:function(e,t){var r=t<0?-t:t;if(e.length>r)e=e.substr(0,r);else{var o=Array(r+1-e.length).join(" ");e=t<0?e+o:o+e}return e}},{key:"truthy",value:function(e){var t;switch(_typeof(e)){case"boolean":t=e;break;case"number":t=0!==e&&!isNaN(e);break;case"string":t=""!==e;break;case"object":t=!1,null!==e&&(t=!0,e instanceof Array&&(t=e.length>0));break;default:t=!1}return t}},{key:"coerce",value:function(e,t){if(_typeof(e)!==t)try{switch(t){case"boolean":"object"===_typeof(e)&&e instanceof Array?e=0!==e.length:"boolean"!=typeof e&&(e=Boolean(e));break;case"number":"object"===_typeof(e)&&e instanceof Array?e=e.length:"number"!=typeof e&&(e=Number(e));break;case"string":"string"!=typeof e&&(e=String(e));break;case"regexp":"object"===_typeof(e)&&e instanceof RegExp||(e=new RegExp(e))}}catch(e){throw new Error("cannot coerce value into type "+t)}return e}}]),e}();
},{}],19:[function(_dereq_,module,exports){
"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var version={major:2,minor:8,micro:0,date:20240308},_default=exports.default=version;
},{}],20:[function(_dereq_,module,exports){
"use strict";var _cacheLru=_interopRequireDefault(_dereq_("cache-lru")),_astqAdapter=_interopRequireDefault(_dereq_("./astq-adapter.js")),_astqAdapterXmldom=_interopRequireDefault(_dereq_("./astq-adapter-xmldom.js")),_astqAdapterParse=_interopRequireDefault(_dereq_("./astq-adapter-parse5.js")),_astqAdapterMozast=_interopRequireDefault(_dereq_("./astq-adapter-mozast.js")),_astqAdapterGraphql=_interopRequireDefault(_dereq_("./astq-adapter-graphql.js")),_astqAdapterJson=_interopRequireDefault(_dereq_("./astq-adapter-json.js")),_astqAdapterCheerio=_interopRequireDefault(_dereq_("./astq-adapter-cheerio.js")),_astqAdapterUnist=_interopRequireDefault(_dereq_("./astq-adapter-unist.js")),_astqAdapterAsty=_interopRequireDefault(_dereq_("./astq-adapter-asty.js")),_astqFuncs=_interopRequireDefault(_dereq_("./astq-funcs.js")),_astqFuncsStd=_interopRequireDefault(_dereq_("./astq-funcs-std.js")),_astqQuery=_interopRequireDefault(_dereq_("./astq-query.js")),_astqVersion=_interopRequireDefault(_dereq_("./astq-version.js"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _typeof(e){return(_typeof="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function _classCallCheck(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")}function _defineProperties(e,t){for(var r=0;r<t.length;r++){var a=t[r];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(e,_toPropertyKey(a.key),a)}}function _createClass(e,t,r){return t&&_defineProperties(e.prototype,t),r&&_defineProperties(e,r),Object.defineProperty(e,"prototype",{writable:!1}),e}function _toPropertyKey(e){var t=_toPrimitive(e,"string");return"symbol"==_typeof(t)?t:String(t)}function _toPrimitive(e,t){if("object"!=_typeof(e)||!e)return e;var r=e[Symbol.toPrimitive];if(void 0!==r){var a=r.call(e,t||"default");if("object"!=_typeof(a))return a;throw new TypeError("@@toPrimitive must return a primitive value.")}return("string"===t?String:Number)(e)}var ASTQ=function(){function e(){for(var t in _classCallCheck(this,e),this._adapter=(new _astqAdapter.default).register(_astqAdapterXmldom.default,!1).register(_astqAdapterParse.default,!1).register(_astqAdapterMozast.default,!1).register(_astqAdapterGraphql.default,!1).register(_astqAdapterJson.default,!1).register(_astqAdapterCheerio.default,!1).register(_astqAdapterUnist.default,!1).register(_astqAdapterAsty.default,!1),this._funcs=new _astqFuncs.default,_astqFuncsStd.default)this.func(t,_astqFuncsStd.default[t]);this._cache=new _cacheLru.default}return _createClass(e,[{key:"version",value:function(){return _astqVersion.default}},{key:"adapter",value:function(e){var t=this,r=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(arguments.length<1||arguments.length>2)throw new Error("ASTQ#adapter: invalid number of arguments");if(this._adapter.unregister(),"object"===_typeof(e)&&e instanceof Array||(e=[e]),e.length>1&&r)throw new Error("ASTQ#adapter: you can force just a single adapter to not taste the AST node");return e.forEach(function(e){if("string"==typeof e)if("mozast"===e)e=_astqAdapterMozast.default;else if("graphql"===e)e=_astqAdapterGraphql.default;else if("xmldom"===e)e=_astqAdapterXmldom.default;else if("parse5"===e)e=_astqAdapterParse.default;else if("json"===e)e=_astqAdapterJson.default;else if("cheerio"===e)e=_astqAdapterCheerio.default;else if("unist"===e)e=_astqAdapterUnist.default;else{if("asty"!==e)throw new Error("ASTQ#adapter: unknown built-in adapter");e=_astqAdapterAsty.default}t._adapter.register(e,r)}),this}},{key:"func",value:function(e,t){if(2!==arguments.length)throw new Error("ASTQ#func: invalid number of arguments");return this._funcs.register(e,t),this}},{key:"cache",value:function(e){if(1!==arguments.length)throw new Error("ASTQ#cache: invalid number of arguments");return this._cache.limit(e),this}},{key:"compile",value:function(e,t){if(arguments.length<1)throw new Error("ASTQ#compile: too less arguments");if(arguments.length>2)throw new Error("ASTQ#compile: too many arguments");void 0===t&&(t=!1);var r=this._cache.get(e);return void 0===r&&((r=new _astqQuery.default).compile(e,t),this._cache.set(e,r)),r}},{key:"execute",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#execute: too less arguments");if(arguments.length>4)throw new Error("ASTQ#execute: too many arguments");void 0===r&&(r={}),void 0===a&&(a=!1);var i=this._adapter.select(e);if(void 0===i)throw new Error("ASTQ#execute: no suitable adapter found for node");return t.execute(e,i,r,this._funcs,a)}},{key:"query",value:function(e,t,r,a){if(arguments.length<2)throw new Error("ASTQ#query: too less arguments");if(arguments.length>4)throw new Error("ASTQ#query: too many arguments");return void 0===r&&(r={}),void 0===a&&(a=!1),this.execute(e,this.compile(t,a),r,a)}}]),e}();module.exports=ASTQ;
},{"./astq-adapter-asty.js":4,"./astq-adapter-cheerio.js":5,"./astq-adapter-graphql.js":6,"./astq-adapter-json.js":7,"./astq-adapter-mozast.js":8,"./astq-adapter-parse5.js":9,"./astq-adapter-unist.js":10,"./astq-adapter-xmldom.js":11,"./astq-adapter.js":12,"./astq-funcs-std.js":13,"./astq-funcs.js":14,"./astq-query.js":17,"./astq-version.js":19,"cache-lru":2}]},{},[4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,20])(20)
});
